#!/usr/bin/env python
# -*- coding: utf-8 -*-

import re
import string
import braille_encodings as be
braile_abbr_info=u'''
     $zestawienie skrótów
  $skróty omawiamy według
kolejności znaków brajlowskich
=zdarzają się odstępstwa, gdy
razem omawiana jest cała grupa
skrótów=. $w nawiasie po
elemencie skracanym podano
uwarunkowania; zgodnie z
rozwiązaniami przyjętymi w
opracowaniach brajlowskich:
p oznacza skrót początkowy,
ś - skrót środkowy,
k - skrót końcowy,
w - skrót wyrazu.
  $uwarunkowania przy skrótach
uniwersalnych, tj. takich,
które mogą być stosowane we
wszystkich pozycjach, są z
reguły pomijane.
ao  albo =w=
b   bo =w=
bw  bowiem =w=
b[3] bardzo =w=
bj  bardziej =w=
nbj najbardziej =w=
c   co =w=
cś  coś =w=
cr  coraz
d   dla =w=
dt[256] dlatego =w=
dx[256] dlaczego =w=
e   ale =w=
f   gdy =w=
fb  gdyby =w=
fż  gdyż =w=
[123456]f  nigdy =w=
g   gdzie =w=
h   em =k=
h   tu =w=
ht  tutaj =w=
j   ej =k=
j   jeszcze =w=
jż  jeżeli =w=
jś  jeśli =w=
k   kto =w=
kś  ktoś =w=
kd  kiedy =w=
l   ym =k=
l   tym =w=
m   ma =w=
mm  mam =w=
mq  masz =w=
n   ten =w=
nbj najbardziej
n[12456]j najwięcej
oo  około =w=
ox  oczywiście =w=
or  oraz
p   przecież =w=
q   sz =pśk=
q   być =w=
r   raz =w=
cr  coraz =w=
or  oraz =w=
tr  teraz =w=
ąr  zaraz =w=
rż  również =w=
s   są =w=
t   to =w=
tr  teraz
v   dz =pśk=
v   będzie =w=
x   cz =pśk=
x   czy =w=
y   przy =pw=
zq  zresztą =w=
zw  zwłaszcza =w=
ż   że =w=
żb  żeby =w=
[123456]   ni =pśkw=
[123456]f  nigdy
[12356]   ch =pśk=
[12356]   ich =w=
[12356]b  chyba =w=
ź   był =pw=
[23456]   st =pśk=
[23456]   jest =w=
[23456]m  jestem =w=
[23456]y  jesteśmy =w=
[23456]ś  jesteś =w=
[23456][34] jesteście =w=
ą   za =pw=
ąq  zawsze =w=
ąr  zaraz
ł   sobie =w=
ć   jak =pw=
ń   tak =pw=
ńż  także =w=
ę   prze =p=
ę   przez =w=
[1246]   na =pśkw=
[1246][23456]  natomiast =w=
[12456]   wa =pśk=
[12456]   więc =w=
[12456]j  więcej =w=
n[12456]j najwięcej =w=
[1256]   rz =pśk=
[1256]   tam =w=
ś   się =w=
śb  siebie =w=
wb  wobec =w=
wg  według =w=
wt  wtedy =w=
w@  właśnie =w=
[2]  pa =pś=
[23]  ra =pś=
[23]  nawet =w=
[25]  wy =pśw=
[256]  ego =k=
[256]  do =pśw=
[256]p  dopiero =w=
[256][1256]  dobrze =w=
[26]  ko =pś=
[26]  tylko =w=
[235]  po =pśw=
[2356]  sk =ś=
[2356]  lub =w=
[236]  le =śk=
[236]  też =w=
[35]  od =pw=
[35]  ia =śk=
[356]  ro =pś=
[356]  już =w=
[4]  ość =k=
[45]  ości =śk=
[34]  ie =śk=
[34]  wszystko =w=
[34]  wszystki =p=
[34]y  wszyscy =w=
@   nie =pśkw=
ó   któr =p=
ó   który =w=
ó   ów =k=
[3456]  ny =k=
[3456]  może =w=
[3456][1246]  można =w=
[46]  ię =śk=
[456] li =śk=
[5]  ych =k=
[5]c  ciąg
[5]d  drugi =w=
[5]d  drug =pśk=
[5]e  kres
[5]f  form
[5]i  kilka =w=
[5]i  kilk =pśk=
[5]j  jeden =w=
[5]j  jedn =pśk=
[5]m  miejsc
[5]o  organ
[5]p  pierw
[5]t  trzeba =w=
[5]t  trzeb =pśk=
[5]x  człowiek
[5][23456]  stanowi =w=
[5][23456]  stanow =pśk=
[5]ę  problem
[5]ś  świat
[5]w  właściwie =w=
[5]w  właściw =pśk=
[5]@  niewidomy =w=
[5]@  niewidom =pśk=
[56]  ach =k=
[56]c  części
[56]j  jednak
[56]m  między
[56]o  ostatni
[56]s  spraw
[56][  chwil
[56]ń  państw
[56]w  większy =w=
[56]w  większ =pśk=
[3] pod =pw=
$znak [36], oznaczający kreskę
poziomą, może być w piśmie
integralnym stosowany zarówno
w różnych pozycjach w wyrazie
=łącznik, przenośnik=, jak
i między spacjami =pauza, czyli
myślnik=. $dlatego też nie jest
wykorzystany w skrótach.
$znak [6] został użyty w
piśmie skrótowym jako znak
integrału. $jego znaczenie to
przywrócenie znaczenia
integralnego następującej po
nim sekwencji liter aż do
spacji.
$znak pusty we wszystkich
wariantach pisma brajlowskiego
jest wykorzystywany w sposób
najbardziej naturalny - jako
spacja =odstęp=. $takie też
jest jego znaczenie w polskich
skrótach brajlowskich.
'''
braile_abbr_full_info=u'''
Gdy było to potrzebne, po danej grupie skrótów zamieszczono krótki
komentarz słowny.
1. [1] I stopień II stopień
!  [1][135] albo (w - 263)
!! [1][12] aby (w - 419)
Pierwotnie nie planowano skrótu dla wyrazu aby, ponieważ został
skrócony zbieg liter by. Dopiero po jego skreśleniu powstał skrót wyrazu
aby, który jednak włączono do II stopnia, gdzie przewiduje się też skrócenie
partykuły by (litera b).
2. [12] I stopień II stopień
!  [12] bo (w - 731)
!! [12] by (k - partykuła)
!  [12][2456] bowiem (w - 220)
!! [12][1345][134] bynajmniej (w)
!  [12][3] bardzo (w - 752)
!! [12][12346] bieżąc (pw - 272)
!  [12][245] bardziej (w - 253)
!  [1345][12][245] najbardziej (w - 163)
Wyraz bardzo występujący nieco częściej niż bo należałoby skrócić
litera b, ale wtedy nie byłoby symbolu dla bo. W II stopniu by jest skracane
tylko jako partykuła, trudno więc podać częstość występowania Element
bieżąc należy do nielicznych skrótów wyrazów, które mogą być użyte
w funkcji początkowego zbiegu liter.
3. [14] I stopień II stopień
!  [14] co (w - 2195)
!! [14] co (p)
!  [14][246] coś (w - 441)
!! [345][14] nieco (w)
!  [14][1235] coraz (por. [1235])
W II stopniu c używamy jako co tylko w złożeniach: codzienny,
conocny itd. Ich frekwencja jest w tekstach niska.
4. [145] I stopień II stopień
!  [145] dla (w - 1361)
!! [145][1245] drog (p)
!  [145][2345][256] dlatego (w - 277)
!! [145][1245] drogo (w)
!  [145][1346][256] dlaczego (w - 265)
!! [145][13] dokąd (w, por. [35][13])
!! [145][2345] dotąd (w, por. [35][2345])
!! [145][1234][13] dopóki (w)
!! [145][1234][2345] dopóty (w)
!! [145][12346] duż (p)
!! [145][12346] dużo (w - 150)
!! [145][126] dług (pw)
5. [15] I stopień II stopień
!  [15] ale (w - 1970)
!! [15] cie (k, po samogł. i ń, ś, ź)
6. [124] I stopień II stopień
!  [124] gdy (w - 415)
!! [345][124][246] niegdyś (w)
!  [124][12] gdyby (w - 195)
!  [124][12346] gdyż (w - 129)
!  [123456][124] nigdy (w - 226)
Litera f oznaczono wyraz gdy, ponieważ nie ma odpowiedniego do
skrótów wyrazu zaczynającego się od tej litery, natomiast są dwa wyrazy
zaczynające się od litery g, które warto było skrócić. Dlatego f oznacza
wyraz gdy, a g - gdzie.
7. [1245] I stopień II stopień
!  [1245] gdzie (w - 421)
!! [1245][126] główn (p)
!! [1245][126] głównie (w)
!! [1245][246] gdzieś (w)
!! [1245][345][1245] gdzieniegdzie (w)
!! [123456][1245] nigdzie (w)
Wyrazy gdzie i gdy należą do wyrazów o średniej frekwencji, ale dają
po dwie kratki oszczędności Z ich pomocą można dość łatwo tworzyć skróty
pochodne.
8. [125] I stopień II stopień
!  [125] em (k - 328)
!! [125] iem (k, po g, k)
!  [125] tu (w - 779)
!! [125][2345][12345] tutejsz (p)
!  [125][2345] tutaj (w -181)
Końcówka iem ma w materiałach Decaux zanotowana frekwencje 104,
jednak liczba ta obejmuje również jej wystąpienia po innych literach niż
uwzględnione w skrótach.
9. [24] I stopień II stopień
!! [24] inn (p - 897 w SWJP)
!! [24][1246] inaczej (w - 111)
Podobnie jest w skrótach niemieckich, gdzie [24] oznacza ihr.
10. [245] I stopień II stopień
!  [245] ej (k - 410)
!! [245] iej (k, po g, k)
!  [245] jeszcze (w - 1016)
!! [245][1346] jednocześnie (w - 103)
!  [245][12346] jeżeli (w - 242)
!! [245][1346] jednoczesn (p)
!  [245][246] jeśli (w - 325)
Literę [245] w I stopniu jako końcówkę ej, a w II - jako iej stosujemy
w ten sam sposób jak [125](em i iem). Frekwencja końcówki iej po różnych
literach wynosi 109.
11. [13] I stopień II stopień
!  [13] kto (w - 285)
!! [123456][13] nikt (w - 169)
!  [13][246] ktoś (w - 137)
!! [13][13] kolwiek (k)
!! [13][13] krótk (p)
!! [13][13] krótko (w)
!  [13][145] kiedy (w - 477)
!! [13][145][246] kiedyś (w)
!! [13][12346] każdy (w - 168)
!! [13][12346] każd (p)
Litera k w połączeniu z innymi znakami służy do tworzenia różnych
skrótów, ale nie są one skomplikowane. Godne odnotowania są dodatkowe
dane frekwencyjne: 111 razy wystąpiło słowo każdym.
12. [123] I stopień II stopień
!  [123] ym (k - 268)
!! [123][1234] lep (pw)
!  [123] tym (w - 1691)
!! [123][1234][245] lepiej (w - 145)
!! [123][1346] lecz (w - 242)
Litera [123] jako symbol końcówki -ym jest trudna do skojarzenia z elementem
skracanym i do zapamiętania. Nie zachodzi jednak obawa, że może
tu powstać niejasność przy takim jej użyciu. Jest to jedna z niewielu liter,
które można stosować jako końcówki bez zastrzeżeń. Skrót wyrazu tym
został dobrany ze względu na podobieństwo z ym.
13. [134] I stopień II stopień
!  [134] ma (w - 987)
!! [134] im (k, po g, k - 97)
!  [134][134] mam (w - 314)
!! [134][14] mianowicie (w)
!  [134][12345] masz (w - 118)
!! [134][135] mimo (w - 168)
!! [235][134][135] pomimo (w)
!! [134][126] mało (w - 99)
!! [134][126] mał (p)
Utworzenie skrótu dla każdej formy czasu teraźniejszego czasownika
mieć było niemożliwe ze względu na brak odpowiednich symboli.
Jako skrót końcowy dla im w II stopniu proponuje się nie literę
[123], lecz [134], ponieważ wydaje się to bardziej naturalne i nie stwarza
żadnych dwuznaczności. W materiałach Decaux zanotowano 97 wystąpień
końcowego m po różnych literach.
14. [1345] I stopień II stopień
!  [1345] ten (w - 841)
!! [1345] naj (p, przed spółgł.)
!  [1345][12][245] najbardziej (por. [12][245])
!! [1345][134] najmniej (w)
!  [1345][12456][245] najwięcej (por. [12456][245])
Litera n nie występuje na początku wyrazu przed spółgłoską, natomiast
naj występuje na ogól w takiej pozycji. W każdym razie należy zwracać
uwagę na dalszy kontekst.
15. [135] I stopień II stopień
!  [135][135] około (w - 302)
!! [135][12] oby (w)
!  [135][1346] oczywiście (w - 249)
!! [135][1346] oczywist (p)
!  [135][1235] oraz (por. [1235])
16. [1234] I stopień II stopień
!  [1234] przecież (w - 481)
!! [1234][13] póki (w)
!! [1234][2345] póty (w)
Od przecież na pewno częściej występuje słowo pracy, ale ponieważ
jest to forma wyrazu odmiennego, nie można go było wybrać jako znaczenia
skrótu wyrazu dla litery p. Litera ta nie nadawała się również na symbol
zbiegu liter i wyrazu po.
17. [12345] I stopień II stopień
!  [12345] sz (pśk - 887)
!  [12345] być (w - 653)
Znak 17. (litera q) jako zbieg liter sz został przejęty ze skrótów
laskowskich. Właściwie mógłby być z nich przejęty również w znaczeniu
wszystko, ale nasuwały się tu obawy, o których była już mowa wyżej
(por. rozdział 9.).
18. [1235] I stopień II stopień
!  [1235] raz (w - 308)
!! [1235][125] razem (w - 175)
!  [14][1235] coraz (w - 193)
!! [1235][136] razu (w)
!  [135][1235] oraz (w - 760)
!! [1235][1346] równoczesn (p)
!  [2345][1235] teraz (w - 482)
!! [1235][1346] równocześnie (w)
!  [16][1235] zaraz (w - 199)
!! [1235][13456] razy (w)
!  [1235][12346] również (w)
!! [1235][34] razie (w - 143)
!! [1246][1235] naraz (w)
!! [2456][1235] wraz (w)
!! [345][1235] nieraz (w)
Zachodzi tu ciekawy wypadek, gdy skrót zasadniczy ma niższa częstotliwość
występowania niż skróty pochodne. Najlepiej byłoby, gdyby litera r mogla
mieć uniwersalne znaczenie skrótowe raz. Ponieważ jest to niemożliwe,
każdy skrót zawierający ten element musi być wymieniony oddzielnie.
19. [234] I stopień II stopień
!  [234] są (w - 1068)
!! [234][13] skąd (w - 119)
!! [234][2345] stąd (w - 104)
!! [234][123] socjal (p)
20. [2345] I stopień II stopień
!  [2345] to (w - 4157)
!! [2345][2345] toteż (w)
!  [2345][1235] teraz (por. [1235])
!! [2345][1346] tymczasem (w)
!!  [2345][1346] tymczas (p)
!! [2345][12356] trochę (w - 182)
Skrótu wyrazu toteż nie można utworzyć ze znaków [2345]
i [236], bo czytałoby by się to ,,tle''.
21. [136] I stopień II stopień
!! [136] mu (k - po samogł. prócz i)
Skrót ten jest stosowany głównie w końcówce przymiotnikowej, można
jednak również pisać np. [13][1235][15][136] - kremu,
[145][12346][15][136] - dżemu.
22. [1236] I stopień II stopień
!  [1236] dz (pśk - 883)
!! [1236][13] dzięki (w - 145)
!! [1236][13] dzięk (p)
!! [1236][246] dziś (w - 253)
!! [1236][246][245] dzisiaj (w - 129)
!! [1236][246][12345] dzisiejsz (p)
!  [1236] będzie (w - 799)
!! [1236][12345] będziesz (w)
!! [1236][13456] będziemy (w - 103)
!! [1236][16] będą (pw - 287)
!! [1236][156] będę (w - 132)
!! [1236][34] będziecie (w - 132)
Znak [1236] na oznaczenie dz został przejęty z systemu laskowskiego.
Natomiast zamiast znaczenia we znakowi temu jako skrótowi wyrazu
nadano znaczenie będzie, które powinno użytkownikowi nasuwać bliższe
skojarzenia z dz niż we i daje bez porównania większa oszczędność miejsca.
Na temat skrótu będzie i pochodnych była już mowa wcześniej (por. rozdział 8).
23. [1346] I stopień II stopień
!  [1346] cz (pśk - 1066)
!! [1346][23456] często (w - 194)
!  [1346] czy (w - 1110)
!! [1346][23456] częst (p)
!! [1346][146] cześć (w)
!! [1346][456] czyli (w - 120)
Znak [1346] został wybrany na symbol dla cz ze względu na podobieństwo
do brajlowskiego [14] i [146] (ć).
24. [13456] I stopień II stopień
!  [13456] przy (p - 144)
!! [13456] my (k, po samogł. i ć, ń, ś, ź, j, l)
!  [13456] przy (w - 996)
!! [13456][1345][134] przynajmniej (w)
Element my na liście E. Decaux występuje 78 razy i jest na 34
miejscu, a na liście z Publicystyki (100 000 wyrazów, tj. ok. 600 000 liter)
występuje 784 razy i jest na 23 miejscu. Skrót ten wykorzystany jest w
większości wypadków, bo po samogłoskach i po symbolach odpowiadających
spółgłoskom miękkim.
25. [1356] I stopień II stopień
!  [1356][12345] zresztą (w - 170)
!! [1356][12] zbyt (pw - 130)
!  [1356][2456] zwłaszcza (w - 144)
!! [1356][136] znowu (w - 136)
!! [1356][346] znów (w - 110)
!! [1356][13] zwykł (pw)
!! [1356][236] zwykle (w)
26. [12346] I stopień II stopień
!  [12346] że (w - 4338)
!! [12346] że (k, partykuła)
!  [12346][12] żeby (w - 438)
!! [12346][145] żadn (p)
!! [12346][145] żaden (w)
Element że na końcu wyrazu w materiałach Decaux występuje 100
razy, a na liście z Publicystyki - 671 razy i jest na 5 miejscu.
27. [123456] I stopień II stopień
!  [123456] ni (pśkw)
!! [123456][12] niby (w)
!  [123456][124] nigdy (por. [124])
!! [123456][13] nikt (w, por. [13])
!! [123456][1245] nigdzie (w, por. [1245])
W materiałach Decaux zbieg liter ni występuje 2110 razy (wliczając
nie). Wyraz ni ma częstość niewielka, była już o tym mowa w poprzednich
rozdziałach.
28. [12356] I stopień II stopień
!  [12356] ch (pśk - 1146)
!! [12356] ich (k, po g, k)
!  [12356] ich (w - 750)
!! [12356][12346] chociaż (w - 113)
!  [12356][12] chyba (w - 292)
!! [12356][146] choć (w - 123)
!! [12356][15] chce (w - 161)
!! [12356][12345] chcesz (w)
!! [12356][13456] chcemy (w)
!! [12356][16] chcą (pw)
!! [12356][156] chcę (w - 121)
!! [12356][34] chcecie (w)
!! [12356][126] chciał (pw - 96)
!! [12356][456] chcieli (w)
29. [2346] I stopień II stopień
!  [2346] był (p)
!! [2346][24] byli (w - 111)
!  [2346] był (w - 663)
Znak [2346] był pierwotnie przewidziany jako skrót wyrazu bez. Ostatecznie
oznacza wyraz był, ponieważ można doń swobodnie dodawać
końcówki i przedrostki. Ponadto dla bez można dobrać symbol dwuznakowy,
gdyż słowo to występuje znacznie rzadziej niż nawet samo słowo
był, które na liście rangowej ze Słownictwa pojawia się 663 razy. Na liście tej
występują również inne formy czasu przeszłego czasownika być, różniące się
tylko literami końcowymi, np. była, było itd., których jest w sumie 1528.
Litera ź występuje na początku bardzo nielicznych wyrazów: źdźbło,
źgać, źle, źrebie, źrenica, źródło i pokrewnych. Z kolei początkowy
zbieg liter był może poprzedzać samogłoskę, nie ma więc obaw, że powstaną
nieporozumienia.
30. [23456] I stopień II stopień
!  [23456] st (pśk - 976)
!  [23456] jest (w - 3292)
!  [23456][134] jestem (w - 305)
!  [23456][13456] jesteśmy (w)
!  [23456][246] jesteś (w - 170)
!  [23456][34] jesteście (w)
Forma jestem miała być skrócona [23456][125], ale komisja rzeczoznawców
ustaliła, by skracać tak, jak podano w wykazie. Warto zwrócić uwagę,
że omawiany znak w skrótach laskowskich znaczy st i jest, w skrótach
niemieckich - st i ist.
31. [16] I stopień II stopień
!  [16] za (p - 423)
!! [16][23456] zamiast (w)
!  [16] za (w - 1561)
!! [16][5][1235] zarówno (w - 138)
!  [16][12345] zawsze (w - 331)
!! [16][125] zatem (w)
!  [16][1235] zaraz (por. [1235])
Zbieg liter za występuje głównie na początku wyrazu, dlatego też
wprowadzono skrót o takiej funkcji. Spotyka go się jednak dość często także
w środku i na końcu wyrazu, zwłaszcza po samogłoskach. Dlatego symbol
[16], oznaczający w integrale a, jest dobrze dobrany, bo umożliwia znaczne
rozszerzenie użycia skrótu w stopniu II. Wyraz zamiast zajmuje na liście
rangowej dalekie miejsce, mimo to utworzono dla niego skrót analogiczny
do skrótu dla wyrazu natomiast (podobnie też dla natychmiast).
32. [126] I stopień II stopień
!  [126] sobie (w - 733)
!! [126][16] sobą (w - 149)
Te dwa skróty łatwo się wzajemnie kojarzą, oznaczają wyrazy stosunkowo
częste i z powodzeniem oba mogły być wprowadzone do I stopnia
skrótów.
33. [146] I stopień II stopień
!! [146] cj (ś)
!! [146] ać (k - po spółgł.)
!  [146] jak (w - 3890)
!! [146][12] jakby (w - 229)
!  [146] jak (p)
!! [146][13456] jacy (w)
Znak [146] nabiera w stopniu II różnych znaczeń. Jego znaczenie integralne
ć jest podstawa dla utworzenia skrótów dla ać i cj. Zanotowana
przez Decaux częstość zakończenia ać (159) powinna być faktycznie zmniejszona,
bo występuje ono m. in. w kontekstach: iać, nać, rać, pać i
wać. Jeśli idzie o zbieg liter cj, to udało się ustalić, że na listach Publicystyki
(opartych na tekście o długości ok. 600 000 liter) występuje ono
ponad 1600 razy w ciągach cji, cja, cje itd.
Znaczenie skrótowe znaku [146] jest podstawa nowych skrótów w
stopniu II: jakby i jacy. Pierwszy z nich jest całkiem prosty, drugi - nieco bardziej
skomplikowany, utworzony analogicznie do skrótów dla wyrazów: tacy,
którzy, wszyscy.
34. [1456] I stopień II stopień
!  [1456] tak (p)
!! [1456] owa (ś)
!  [1456] tak (w - 1941)
!! [1456][13456] tacy (w)
!  [1456][12346] także (w - 433)
Jak widzimy, zastosowanie znaku [1456] jest również różnorodne. Wynika
to stąd, że stanowiąca podstawowe znaczenie tego znaku w polskim brajlu
integralnym litera ń w pewnych pozycjach występuje bardzo rzadko.
Nie spotkamy jej nigdy na początku wyrazu i przed samogłoska, a także
między dwiema spółgłoskami. Występuje głównie po samogłosce - przed
spółgłoska i na końcu wyrazu, rzadko - na końcu wyrazu po spółgłosce.
W materiałach E. Decaux w tekście o długości 100 000 liter wystąpiła zaledwie
187 razy.
Oprócz wyrazu tak w górnej części listy rangowej słów ze Słownika
frekwencyjnego znalazło się 1025 wystąpień wyrazu taki. Daje to w sumie
2966 użyć.
35. [156] I stopień II stopień
!  [156] prze (p - 294)
!! [156][125] przedtem (w)
!  [156] przez (w - 1450)
Przedrostek prze występuje ponadto czasem nie na początku wyrazu
- po samogłosce, co można wykorzystać w II stopniu skrótów, i po
spółgłosce, kiedy takie rozszerzenie nie jest możliwe. Skrót wyrazu przedtem
został utworzony analogicznie do potem ([235][125]) i zatem ([16][125]).
36. [1246] I stopień II stopień
!  [1246] na (w - 9078)
!! [1246][1235] naraz (por. [1235])
!  [1246] na (pśk - 868)
!! [1246][1234] naprawdę (w - 124)
!  [1246][23456] natomiast (w - 191)
!! [1246][12356][23456] natychmiast (pw)
!! [1246][236] nagle (w - 105)
Znak [1246] (zwierciadlane odbicie litery n) jest chyba symbolem dobrze
nadającym się do skrócenia na, ponieważ nasuwa skojarzenia z elementem
skracanym i jest łatwo czytelny. Wyraz natychmiast nie znalazł
się w początkowym fragmencie listy rangowej.
37. [12456] I stopień II stopień
!  [12456] wa (pśk - 713)
!! [12456] więc (w - 692)
!! [12456][245] więcej (w - 268)
!! [1345][12456][245] najwięcej (w)
Również znak [12456] jest chyba trafnie dobrany bo zawiera wszystkie
punkty wchodzące w skład znaków [1](a) i [2456](w).
38. [1256] I stopień II stopień
!  [1256] rz (pśk - 1010)
!! [1256] tam (p)
!  [1256] tam (w - 610)
!! [1256][1345] tamten (w)
!! [1256][2345] tamto (w)
39. [246] I stopień II stopień
!  [246] się (w - 10 043)
!! [246] św (pś, przed i)
!  [246][12] siebie (w - 255)
!! [246] sw (pś, przed inna samogł.)
!! [246] eś (k)
Jak widać, w wypadku znaku [246] w stopniu II wprowadzone są silne
uwarunkowania kontekstowe (podobnie jest dla [146]). Wypadków tego typu
jest w naszym systemie niewiele, tak że nie powinny one być kłopotliwe
w stosowaniu pisma skrótowego, zwłaszcza że litery ś, ć, ń, ź nigdy nie
występują przed samogłoska. Na końcu wyrazu [246] po spółgłosce oznacza
końcowe eś (podobnie jak w stopniu I [125] oznacza em, [245]- ej,
[123]- ym).
40. [2456] I stopień II stopień
!  [2456][12] wobec (w - 179)
!! [2456][14] wcale (w - 125)
!  [2456][1245] według (w - 144)
!! [2456][13] wkrótce (w)
!  [2456][2345] wtedy (w - 302)
!! [2456][1234] wprawdzie (w)
!  [2456][345] właśnie (w - 384)
!! [2456][1345] własn (p)
!! [2456][1236] wszędzie (w)
!! [2456][1235] wraz (por. [1235])
!! [2456][12345] wreszcie (w - 135)
!! [2456][234] współ (p, przed n)
!! [2456][234] współ (p, nie przed n)
!! [2456][1346] wówczas (w - 116)
!! [2456][12346] wciąż (w)
!! [2456][146] widać (w - 101)
Po skrótach utworzonych za pomocą znaku [2456] widać najlepiej, że
granica między stopniem I a II jest sztuczna. Skrócenie wobec w stopniu
I daje 537 kratek oszczędności w tekście o długości 500 000 wyrazów, a
skrócenie wreszcie w stopniu II - 580 kratek w tekście o tej samej długości
41. [2] I stopień II stopień
!  [2] pa (pś - 398)
42. [23] I stopień II stopień
!  [23] ra (pś - 804)
!  [23] nawet (w - 637)
43. [25] I stopień II stopień
!  [25] wy (w - 431)
!  [25] wy (pś)
44. [256] I stopień II stopień
!  [256] ego (k - 344)
!! [256] iego (k, po g, k)
!  [256] do (pś - 509)
!! [256] ne (k, po a, o)
!  [256] do (w - 5903)
!! [256][1346] dotychczas (w - 135)
!  [256][1234] dopiero (w - 229)
!! [256][1346] dotychczas (p)
!  [256][1256] dobrze (w - 393)
!! [256][1235] dobr (p)
45. [26] I stopień II stopień
!  [26] ko (pś - 404)
!! [26][1245] kogo (w)
!  [26] tylko (w - 1339)
46. [235] I stopień II stopień
!  [235] po (pś - 987)
!! [235][125] potem (w - 269)
!  [235] po (w - 1976)
!! [235][134][135] pomimo (por. [134][135])
!! [235][1345] ponad (w - 182)
!! [235][1345][2345] ponadto (w)
!! [235][123456] poniżej (w)
!! [235][2456] powyżej (w)
!! [235][345] ponieważ (w - 135)
47. [2356] I stopień II stopień
!  [2356] sk (ś - 308)
!  [2356] lub (w - 433)
48. [236] I stopień II stopień
!  [236] le (śk - 546)
!  [236] też (w - 612)
49. [35] I stopień II stopień
!  [35] od (p - 146)
!! [35] mi (k, po samogł.)
!  [35] od (w - 1897)
!! [35][13] odkąd (w, por. [145][13])
!  [35] ia (śk - 792)
!! [35][2345] odtąd (w, por. [145][2345])
50. [356] I stopień II stopień
!  [356] ro (pś - 681)
!  [356] już (w - 1641)
Znaki oznaczone w tablicy Monniera numerami 41--43, 45, 46 i 50
występują jako symbole skrótów tylko na początku i w środku wyrazu.
Na końcu maja znaczenie znaków przestankowych. Oznaczono nimi zbiegi
liter, które bardzo rzadko występują na końcu wyrazu.
W materiałach prof. Decaux jedynie ko i wy występują na końcu
wyrazu, przy czym oszczędność na nich jest mniejsza niż liczba ich wystąpień,
ponieważ istnieją skróty dla wyrazów tylko, wszystko, jako itd. Końcowe
wy zastępuje częściowo skrót wyrazu sprawy, a w II stopniu skrót dla
zbiegu liter ow, który często wchodzi w skład końcowego owy. Znak [2]
jest stosowany tylko jako skrót zbiegu liter, a znak[25] nie musi być
stosowany jako skrót wyrazu. Skrót dla wyrazu ponadto został wyprowadzony
bezpośrednio od skrótów dla wyrazów: ponad i to. Ponieważ mi
występuje przede wszystkim na końcu wyrazu i po samogłosce, zastosowanie
dla jego oznaczenia znaku [35] (o głównym znaczeniu skrótowym ia) wydaje
się rozwiązaniem szczęśliwym, bo samo znalezienie tego znaku w scharakteryzowanym
kontekście każe domyślać się, że mamy tu do czynienia
z jego dodatkowym znaczeniem, ponieważ wystąpienie trzech kolejnych
liter oznaczających samogłoski jest w języku polskim szalenie mało
prawdopodobne.
51. [4] I stopień II stopień
!  [4] ość (k - 74)
!! [4] ła (k, po samogł.)
!! [4][14] cało (w)
!! [4][14] cał (pśk)
!! [4][145] dal (581 w SWJP w pozycji p)
!! [4][15] obce (obecnie - 205)
!! [4][124] fakt (103)
!! [4][124][34] fakcie (w)
!! [4][1245] gląd
!! [4][1245][34] glądzie
!! [4][125] handl (pśk)
!! [4][125] handel (w)
!! [4][24] interes
!! [4][245] jedynie (w -139)
!! [4][245] jedyn (pśk)
!! [4][13] kier (337 w SWJP w pozycji p - bez kierun)
!! [4][123] lat (425)
!! [4][134] miał (247 w SWJP w pozycji w)
!! [4][1345] norm
!! [4][135] ostatecznie (w)
!! [4][135] ostateczn (pśk)
!! [4][1234] prac (1253 w SWJP w pozycji w)
!! [4][12345] bywa
!! [4][1235] real (realizacji - 97)
!! [4][234] sam (653)
!! [4][2345] trudz (przed i)
!! [4][2345] trud (nie przed i)
!! [4][136] kultur (kultury - 170)
!! [4][1236] dział (560)
!! [4][1346] czas (827)
!! [4][13456] mysł (przemysłu - 143)
!! [4][1356] znacz (295)
!! [4][12346] żyć (kw)
!! [4][12346] życi (pś)
!! [4][123456] nictw (śk)
!! [4][123456] niniejsz (p)
!! [4][12356] charakter
!! [4][2346] bez (461 jako w)
!! [4][23456] stosow (pś)
!! [4][23456] stosować (kw)
!! [4][16] łącz
!! [4][126] kład (468)
!! [4][126][34] kładzie
!! [4][146] ćwicz
!! [4][1456] kraj (638 w SWJP w pozycji p)
!! [4][156] przeciw (przeciwko - 119)
!! [4][1246] należy (w - 300)
!! [4][1246] należ (pśk)
!! [4][12456] ogól (nie przed n)
!! [4][12456] ogól (przed n)
!! [4][12456][15] ogóle (w - 156)
!! [4][1256] rzecz (285)
!! [4][246] świadcz
!! [4][2456] wiadomo (w - 133)
!! [4][2456] wiadom (pśk)
!! [4][34] wiele (w - 516)
!! [4][34] wiel (pśk)
!! [4][345] material (przed i, n)
!! [4][345] materiał (nie przed i, n)
!! [4][345][15] materiale (w)
!! [4][346] osób (w - 117)
!! [4][346] osob (pśk)
!! [4][3456] możliw (możliwości - 130)
52. [45] I stopień II stopień
!  [45] ości (śk - 137)
!! [45] ją (śk, po samogł.)
Znaki prawostronne starano się wykorzystać w ten sposób, by były
łatwe do odczytania. Skróty zastosowane w stopniu I wydaja się spełniać ten
warunek całkowicie Zbiegi liter ość, ości, ie nie występują po a (podobnie
końcowe ach). Po a występuje wprawdzie zbieg liter li, ale on z kolei nie
występuje po l, do którego jest tak podobny, że znaki brajlowskie dla nich
łatwo wzajemnie pomylić. Natomiast po k nie występują zbiegi liter ie czy
ych. Więcej kłopotu może sprawiać w II stopniu odczytanie ła, ły czy ło
po literze a. Ale takie zakończenia wyrazów występują też po i, y czy e,
a także po zbiegach liter na, wa czy ia, których symbole nie są znakami
lewostronnymi. Mówiliśmy już o tym, że niewygodnych połączeń nie da
się całkowicie uniknąć, ale nie można przeładować nimi systemu. Znak [45]
(podobnie jak [5]) jest ponadto kluczem pomocniczym, co jednak nie
prowadzi do dwuznaczności.
53. [34] I stopień II stopień
!  [34] ie (śk - 2997)
!! [34] je (śk, po samogł.)
!  [34] wszystko (w - 448)
!  [34] wszystki (p - 860)
!  [34][13456] wszyscy (w - 211)
54. [345] I stopień II stopień
!  [345] nie (w - 8721)
!! [345][14] nieco (por. [14])
!  [345] nie (pśk - 1210)
!! [345][124][246] niegdyś (por. [124])
!! [345][1235] nieraz (por. [1235])
!! [345][23456] niestety (w)
55. [346] I stopień II stopień
!  [346] któr (p)
!! [346] nia (k, po samogł. prócz i)
!  [346] który (w - 592)
!! [346][1356] którzy (w - 250)
!  [346] ów (k - 230)
Zbieg liter nia po a i e miał w materiałach Decaux frekwencje 190.
Formy wyrazu który, w których użyje się skrótu początkowego [346],
w początkowym fragmencie listy rangowej wystąpiły 2088 razy.
56. [3456] I stopień II stopień
!  [3456] ny (k - 187)
!! [3456] ow (ś)
!  [3456] może (w - 978)
!! [3456][12345] możesz (w)
!  [3456][1246] można (w - 606)
!! [3456][13456] możemy (w - 99)
!! [3456][16] mogą (pw - 195)
!! [3456][126] mógł (w - 132)
!! [3456][126] mogł (p)
!! [3456][156] mogę (w - 151)
!! [3456][34] możecie (w)
!! [3456][456] mogli (w)
57. [46] I stopień II stopień
!  [46] ię (śk - 639)
!! [46] ły (k, po samogł.)
58. [456] I stopień II stopień
!  [456] li (śk - 476)
59. [5] I stopień II stopień
!  [5] ych (k - 466)
!! [5] ło (k, po samogł.)
!  [5][14] ciąg (535 w SWJP w pozycji p)
!  [5][145] drugi (w - 533)
!! [5][145][13456] drudzy (w)
!  [5][145] drug (pśk)
!  [5][15] kres (390)
!! [5][15] kreś (przed l)
!  [5][124] form (300)
!! [5][1245] gospodar (593)
!! [5][125] historia (w)
!! [5][125] histor (pśk)
!  [5][24] kilka (w - 223)
!  [5][24] kilk (pśk)
!  [5][245] jeden (w - 431)
!  [5][245] jedn (pśk - 596)
!! [5][13] korzyśc (przed i)
!! [5][13] korzyst (nie przed i)
!! [5][123] lek
!  [5][134] miejsc (621 w SWJP w pozycji p)
!! [5][1345] pewien (w)
!! [5][1345] pewn (pśk - 167)
!  [5][135] organ (602)
!  [5][1234] pierw (1054 w SWJP w pozycji p)
!! [5][12345] puśc (przed i)
!! [5][12345] puszcz (nie przed i)
!! [5][1235] równo (w)
!! [5][1235] równ (pśk)
!! [5][234] społecz (594)
!  [5][2345] trzeba (w - 444)
!  [5][2345] trzeb (pśk)
!! [5][136] musi (120)
!! [5][1236] dziel
!  [5][1346] człowiek (500 w SWJP w pozycji p)
!! [5][1346][1346] człowiecz
!! [5][13456] myśl (225)
!! [5][1356] zosta (918 w SWJP w pozycji p)
!! [5][12346] życz
!! [5][123456] pełn (pśk)
!! [5][123456] pełno (w - 155)
!! [5][12356] chodzi (w - 235)
!! [5][12356] chodz (pśk)
!! [5][2346] późno (w)
!! [5][2346] późn (pśk, później - 117)
!  [5][23456] stanowi (w)
!  [5][23456] stanow (pśk)
!! [5][16] wiaz
!! [5][126] łatwo (w)
!! [5][126] łatw (pśk)
!! [5][146] specjal
!! [5][1456] praw
!  [5][156] problem (280)
!! [5][1246] natur
!! [5][12456] prowadz
!! [5][1256] rzeczywiście (w)
!! [5][1256] rzeczywist (pśk)
!  [5][246] świat (588)
!  [5][2456] właściwie (w - 119)
!  [5][2456] właściw (pśk)
!! [5][34] względem (w)
!! [5][34] względ (pśk)
!! [5][34][34] względzie (w)
!  [5][345] niewidomy (w)
!  [5][345] niewidom (pśk)
!! [5][346] sposób (w - 289)
!! [5][346] sposob (pśk)
!! [5][3456] prawdopodob
60. [56] I stopień II stopień
!  [56] ach (k - 158)
!  [56][14] części
!! [56][145] produk (281)
!! [56][15] temat (116)
!! [56][15][34] temacie (w)
!! [56][124] fil
!! [56][1245] grup (97)
!! [56][125] humani
!! [56][24] istot
!! [56][24][34] istocie (w)
!  [56][245] jednak (748 jako w)
!! [56][13] kształt
!! [56][13][14] kształc
!! [56][123] ludz (pśk - 120)
!! [56][123] ludzi (w)
!  [56][134] między (455 w pozycjach pw)
!! [56][1345] punkt (277)
!! [56][1345][34] punkcie (w)
!  [56][135] ostatni
!! [56][1234] prób
!! [56][12345] szczegól (przed n)
!! [56][12345] szczegół (nie przed n)
!! [56][12345][15] szczególe
!! [56][1235] różnie (w - 257)
!! [56][1235] różn (pśk)
!  [56][234] spraw (1074)
!! [56][2345] twierdz
!! [56][136] unk (ś, po spółgł. prócz z)
!! [56][136] rozum (pś, po samogł. i z)
!! [56][136] unek (k)
!! [56][1236] rodzaj (129 jako w)
!! [56][1346] czyn
!! [56][13456] pływ
!! [56][1356] zwyczaj
!! [56][12346] żyw
!! [56][123456] trzym
!  [56][12356] chwil (460)
!! [56][2346] średni
!! [56][23456] stosunek (w)
!! [56][23456] stosunk (pśk)
!! [56][16] zależy (w)
!! [56][16] zależ (pśk)
!! [56][126] łoż (pś)
!! [56][126] łożyć (kw)
!! [56][146] sytuacja (w - 133)
!! [56][146] sytuacj (pśk)
!  [56][1456] państw
!! [56][156] step
!! [56][1246] nauk (100)
!! [56][12456] warunk (pśk - 115)
!! [56][12456] warunek (w)
!! [56][1256] sprz
!! [56][246] świet
!  [56][2456] większy (w - 498)
!  [56][2456] większ (pśk)
!! [56][34] zasadz (przed i)
!! [56][34] zasad (nie przed i)
!! [56][345] środek (w)
!! [56][345] środk (pśk)
!! [56][346] śród
!! [56][3456] rozwój (w)
!! [56][3456] rozwoj (pśk)
61. [3] I stopień II stopień
!  [3] pod (pw)
!! [3][1346] podczas (w - 147)
62. [36] I stopień
Znak [36], oznaczający kreskę pozioma, może być w piśmie integralnym
stosowany zarówno w różnych pozycjach w wyrazie (łącznik, przenośnik),
jak i między spacjami (pauza, czyli łącznik). Dlatego też nie jest wykorzystany
w skrótach.
63. [6] I stopień
Znak [6] został użyty w piśmie skrótowym jako znak integralu. Jego
znaczenie to przywrócenie znaczenia integralnego następującej po nim sekwencji
liter aż do spacji.
64. [0] I stopień
Znak [0] we wszystkich wariantach pisma brajlowskiego jest wykorzystywany
w sposób najbardziej naturalny - jako spacja (odstęp). Takie
też jest jego znaczenie w polskich skrótach brajlowskich.
'''
def abbr_to_inf(abbr_str, form=1):
    bli = abbr_str.splitlines()
    bli = [b.strip() for b in bli]
    stru=[]
    for b in bli:
        if form==1:
            tinf = tit_to_inf(b)
            if tinf['ok']:
                v = tinf['value']
                n = v['number']
                t = v['tit']
                pass
            else:
                minf = main_to_inf(b)
                if minf['ok']:
                    stru.append(minf['value'])
                else:
                    pass
        elif form==2:
            minf = main_ii_to_inf(b)
            if minf['ok']:
                stru.append(minf['value'])
            else:
                pass
    return stru
def main_repr(inf):
    a = inf['abbr'].rjust(3)
    f = (inf['frag'].rjust(11))
    m = inf['mode'].ljust(4)
    if 'level' in inf:
        l = '%d' % inf['level']
    else:
        l = '0'
    return a + '  ' + f + '  {' + m + '}  ' + l
def from_pldots(s):
    sl=re.split('(\[0?1?2?3?4?5?6?\])',s)
    sll=[]
    for i in sl:
        if i:
            if i[0]=='[' and i[-1]==']':
                sll.append(i)
            else:
                for j in i:
                    sll.append(j)
    r=be.convert('pldots', 'unicode', sll)
    if r['ok']:
        return r['s']
    else:
        return None
def tit_to_inf(b):
    inf = {}
    pattern = ur'^\#([a-z]+)\.\s+(\S+)?$'
    mo = re.match(pattern, b)
    if mo:
        number = mo.group(1)
        tit = from_pldots(mo.group(2))
        v = {'number': number, 'tit': tit}
        r = {'ok': True, 'value': v}
    else:
        r = {'ok': False}
    return r
def main_to_inf(b):
    inf = {}
    pattern = ur'^(\S+)\s+(\S+)(?:\s+=(\S+)=)?$'
    mo = re.match(pattern, b)
    if mo:
        abbr = from_pldots(mo.group(1))
        if abbr and len(abbr)<4:
            ok = True
            try:
                frag = mo.group(2)
            except:
                frag = '[not decoded frag]'
                ok = False
            mode = mo.group(3)
            if mode is None:
                mode = u'pśkw'
            v = {'abbr': abbr, 'frag': frag.lower(), 'mode': mode, 'level': 1}
            r = {'ok': ok, 'value': v}
        else:
            r = {'ok': False}
    else:
        ok = False
        r = {'ok': False}
    return r
def main_ii_to_inf(b):
    inf = {}
    pattern = ur'^(!+)\s+([\[\]1-6]+)\s+(\S+)(?:\s+\((p?ś?k?w?)[, \)].*|\s+\(.*\))?\s*$'
    mo = re.match(pattern, b)
    if mo:
        abbr = from_pldots(mo.group(2))
        if abbr and len(abbr)<4:
            ok = True
            if mo.group(1)=='!':
                level=1
            elif mo.group(1)=='!!':
                level=2
            else:
                level=0
                ok = False
            try:
                frag = mo.group(3)
            except:
                frag = '[not decoded frag]'
                ok = False
            mode = mo.group(4)
            if mode is None:
                mode = u'pśkw'
            v = {'abbr': abbr, 'frag': frag.lower(), 'mode': mode, 'level': level}
            r = {'ok': ok, 'value': v}
        else:
            r = {'ok': False}
    else:
        ok = False
        r = {'ok': False}
    return r
def mk_abrr_dict(strui,struii):
    d = {'begin':{}, 'middle':{}, 'end':{}, 'word':{}}
    dd = {'begin':{}, 'middle':{}, 'end':{}, 'word':{}}
    po = {}
    def check_double(d,k,v,m,l):
        x=v+m
        if x not in po:
            po[x] = "(%s): %s -> %s" % (m,k,v)
        else:
            y = "(%s): %s -> %s" % (m,k,v)
            if  po[x]!=y:
                pass
        if k not in d:
            d[k]=v
            if l==1:
                pass
        else:
            if d[k]!=v:
                pass
    for l in strui:
        a=l['abbr']
        f=l['frag']
        m=l['mode']
        if m.find(u'w')>=0:
            check_double(d['word'],f,a,'w',0)
        if m.find(u'p')>=0:
            check_double(d['begin'],f,a,'p',0)
        if m.find(u'ś')>=0:
            check_double(d['middle'],f,a,u'ś',0)
        if m.find(u'k')>=0:
            check_double(d['end'],f,a,'k',0)
    for n in ('word', 'begin', 'middle', 'end'):
        for k,v in d[n].items():
            dd[n][k]=v
    for l in struii:
        a=l['abbr']
        f=l['frag']
        m=l['mode']
        if l['level']==1:
            if m.find(u'w')>=0:
                check_double(d['word'],f,a,'w',1)
            if m.find(u'p')>=0:
                check_double(d['begin'],f,a,'p',1)
            if m.find(u'ś')>=0:
                check_double(d['middle'],f,a,u'ś',1)
            if m.find(u'k')>=0:
                check_double(d['end'],f,a,'k',1)
        elif l['level']==2:
            if m.find(u'w')>=0:
                check_double(dd['word'],f,a,'w',2)
            if m.find(u'p')>=0:
                check_double(dd['begin'],f,a,'p',2)
            if m.find(u'ś')>=0:
                check_double(dd['middle'],f,a,u'ś',2)
            if m.find(u'k')>=0:
                check_double(dd['end'],f,a,'k',2)
    d['level2']=dd
    return d
def convert(s):
  return be.convert('pl', 'unicode', s)['s']
def abbreviate_word(word, level=1, abbdict=None):
    if not abbdict:
        if level==1:
            abbdict=abbr_dict
        else:
            abbdict=abbr_dict['level2']
    abrl=[{'v': word, 'a': 'text'}]
    if string.uppercase.find(abrl[0]['v'][0])>=0:
        abrl.insert(0,{'v': be.p2u_dict['uppercase'], 'a': 'upp'})
    w=abrl[-1]['v'].lower()
    if w in abbdict['word']:
        abrl[-1]['v']=abbdict['word'][w]
        abrl[-1]['a']='abbr'
    else:
        abrl[-1]['v']=w
    if abrl[-1]['a']=='text':
        w=abrl[-1]['v']
        l=len(w)
        if l==1:
            abrl[-1]={'v':convert(w), 'a':'abbr'}
        else:
            for e in range(1,l-1, 1):
                if w[e:] in abbdict['end']:
                    abrl.append({'v':abbdict['end'][w[e:]], 'a':'abbr'})
                    abrl[-2]['v']=w[:e]
                    break
            else: # last letter not abrr
                abrl.append({'v':convert(w[-1]), 'a':'abbr'})
                abrl[-2]['v']=w[:l-1]
    if abrl[0]['a']=='text':
        w=abrl[0]['v']
        i=0
    elif abrl[0]['a']=='upp' and abrl[1]['a']=='text':
        w=abrl[1]['v']
        i=1
    else:
        w=None
    if w: # if w <=> i==1 or i==0
        l=len(w)
        if l==1:
            abrl[i]={'v':convert(w), 'a':'abbr'}
        else:
            for b in range(len(w)-1, 1, -1):
                if w[:b] in abbdict['begin']:
                    abrl.insert(i,{'v':abbdict['begin'][w[:b]], 'a':'abbr'})
                    abrl[i+1]['v']=w[b:]
                    break
            else:
                abrl.insert(i,{'v':convert(w[0]), 'a':'abbr'})
                abrl[i+1]['v']=w[1:]
    i=0
    while i<len(abrl):
        if abrl[i]['a']=='text':
            w=abrl[i]['v']
            l=len(w)
            if l==1: # One char text is not text ("one start is not stars' :)
                abrl[i]={'v':convert(w), 'a':'abbr'}
            elif w in abbdict['middle']:
                abrl[i]={'v':abbdict['middle'][w], 'a':'abbr'}
            else:
                for k in range(l-1, 1, -1):
                    for j in range(l-k+1):
                        if w[j:j+k] in abbdict['middle']:
                            abrl[i]={'v':abbdict['middle'][w[j:j+k]], 'a':'abbr'}
                            if j+k<l:
                                abrl.insert(i+1,{'v':w[j+k:], 'a':'text'})
                            if j>0:
                                abrl.insert(i,{'v':w[:j], 'a':'text'})
                                i-=1
                            break
                    else:
                        continue
                    break
                else: # no abbrevation
                    abrl[i]={'v':convert(w), 'a':'abbr'}
        i+=1
    word = u''.join([i['v'] for i in abrl])
    return word
def abbreviate_word_json(s):
    ok = True
    try:
        w = s['v']
        if 'lev' in s:
            l=s['lev']
        else:
            l=1
        if 'dict' in s:
            ab=s['dict']
        else:
            ab=None
    except Exception:
        ok=False
        err="Input of abbreviate_word_json must be a dict with 'v' key"
    if ok:
        try:
            v = abbreviate_word(w, level=l, abbdict=ab)
        except Exception as ex:
            v = convert(w)
            ok=False
            err=repr(ex)
    r = {'ok': ok, 'v': v}
    if not ok:
        r['message'] = err
    return r
abbr_stru = abbr_to_inf(braile_abbr_info, form=1)
abbr_stru_ii = abbr_to_inf(braile_abbr_full_info, form=2)
abbr_dict = mk_abrr_dict(abbr_stru, abbr_stru_ii)
if __name__ == '__main__':
    def abbreviate_print(w):
       r = abbreviate_word(w)
       rr = abbreviate_word_json({'v':w, 'lev':2})['v']
       print w, '->', be.convert('unicode', 'pl', r)['s'], be.convert('unicode', 'pl', rr)['s']
       print rr.encode('utf-8'), '=', r.encode('utf-8'), '(%s)' % convert(w).encode("utf-8")
    s = u'''Ala ma kota,
ale dlaczego nie ma psa?
Chciałbym wiedzieć...'''
    print s
    print convert(s).encode("utf-8")
    abbreviate_print(u'kota')
    abbreviate_print(u'Psa')
    abbreviate_print(u'chciałabyś')
    abbreviate_print(u'chcieli')
    abbreviate_print(u'lilililaj')
    abbreviate_print(u'albo')