#!/usr/bin/env python
# -*- coding: utf-8 -*-

import pango
import gtk
import os
import keyboard
class TextEditor(gtk.ScrolledWindow):
    def __init__(self):
        gtk.ScrolledWindow.__init__(self)
        self.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC)
        self.textview = gtk.TextView()
        self.textbuffer = self.textview.get_buffer()
        self.add(self.textview)
        self.textview.add_events(gtk.gdk.KEY_PRESS_MASK)
        self.textview.add_events(gtk.gdk.KEY_RELEASE_MASK)
        self.textview.connect("key_press_event", self.key_press_event)
        self.textview.connect("key_release_event", self.key_release_event)
        self.textview.add_events(gtk.gdk.FOCUS_CHANGE_MASK) # It took me ages to research this
        self.textview.connect("focus-in-event", self.focus_in_event)
        self.set_input_type('transparent')
        if 0:
            self.textview.set_left_margin(5)
            self.textview.set_indent(12)
            self.textview.set_pixels_above_lines(2)
            self.textview.set_pixels_below_lines(0)
            self.textview.set_pixels_inside_wrap(-1)
            fontdesc = pango.FontDescription("monospace 12")
            textview.modify_font(fontdesc)
        self.prep()
        if 0:
            self.textbuffer.create_tag("red", foreground='red', style=pango.STYLE_ITALIC)
            self.textbuffer.create_tag("yel", background='yellow')
            self.textbuffer.create_tag("com", background='light goldenrod yellow', foreground='OliveDrab4', style=pango.STYLE_ITALIC)
    def set_input_type(self, type):
        if type == 'transparent':
            self.key_process = keyboard.process_transparent
        elif type == 'braille':
            self.key_process = keyboard.process_braille
        elif type == 'ascii_braille':
            self.key_process = keyboard.process_ascii_braille
        else:
            pass
    def key_press_event(self, widget, event):
        r = self.key_process['key_press'](event)
        program = r['program']
        for x in program:
            c, p = x
            if c == 'insert':
                self.textbuffer.insert_at_cursor(p)
            else:
                pass
        res = r['done']
        return res
        if key_name == 'F5' or key_name == 'F11':
            self.toggle_fullscreen()
        elif key_name == 'Escape':
            self.toggle_fullscreen()
        elif key_name == 'Page_Up':
            self.jump_by(-1)
        elif key_name == 'Page_Down':
            self.jump_by(1)
        elif key_name == 'F8':
            self.jump_by(-self.small_jump_size)
        elif key_name == 'F9':
            self.jump_by(self.small_jump_size)
        elif key_name == 'Home':
            self.first_slide()
        elif key_name == 'End':
            self.last_slide()
        else:
            pass
        return False
    def key_release_event(self, widget, event):
        r = self.key_process['key_release'](event)
        program = r['program']
        for x in program:
            c, p = x
            if c == 'insert':
                self.textbuffer.insert_at_cursor(p)
            else:
                pass
        res = r['done']
        return res
    def focus_in_event(self, widget, event):
        pass
    def set_wrapping(self, m):
        if m:
            self.textview.set_wrap_mode(gtk.WRAP_WORD)
        else:
            self.textview.set_wrap_mode(gtk.WRAP_NONE)
    def get_wrapping(self):
        m = self.textview.get_wrap_mode()
        if m == gtk.WRAP_WORD or m ==gtk.WRAP_CHAR:
            return True
        elif m == gtk.WRAP_NONE:
            return False
    def toggle_wrap_mode(self):
        m = self.textview.get_wrap_mode()
        if m == gtk.WRAP_WORD:
            self.textview.set_wrap_mode(gtk.WRAP_NONE)
            return 'no wrapping'
        else:
            self.textview.set_wrap_mode(gtk.WRAP_WORD)
            return 'wrapping'
    def ach(self):
        t = self.get_text()
        ll = t.splitlines()
        for ln in range(len(ll)):
            l=ll[ln]
            u=unicode(l)
            le=len(u)
            fr = 0
            to = le
            iter1 = self.textbuffer.get_iter_at_line_offset(ln, fr)
            iter2 = self.textbuffer.get_iter_at_line_offset(ln, to)
            self.textbuffer.remove_tag_by_name("com", iter1, iter2)
    def put_tag(self, tag, lineno, from_pos, to_pos):
        iter1 = self.textbuffer.get_iter_at_line_offset(lineno, from_pos)
        iter2 = self.textbuffer.get_iter_at_line_offset(lineno, to_pos)
        self.textbuffer.apply_tag_by_name(tag, iter1, iter2)
    def remove_tag(self, tag, lineno):
        iter1 = self.textbuffer.get_iter_at_line_offset(lineno, 0)
        iter2 = self.textbuffer.get_iter_at_line_offset(lineno, len(self.lines[lineno]))
        self.textbuffer.remove_tag_by_name(tag, iter1, iter2)
    def uch(self):
        t = self.get_text()
        ll = t.splitlines()
        for ln in range(len(ll)):
            l=ll[ln]
            u=unicode(l)
            for i in range(len(u)):
                pass
            le=len(u)
            print "[%s]" % ll[ln]
            fr = 0 if le == 0 else 1
            to = le if le <=1 else le-1
            iter1 = self.textbuffer.get_iter_at_line_offset(ln, fr)
            iter2 = self.textbuffer.get_iter_at_line_offset(ln, to)
            self.textbuffer.apply_tag_by_name("com", iter1, iter2)
    def tags(self):
        t = self.get_text()
        a=self.append_text
        ll = t.splitlines()
        for ln in range(len(ll)):
            l=ll[ln]
            u=unicode(l)
            for i in range(len(u)):
                pass
            le=len(u)
            print le
    def prep(self):
        self.text = self.get_text()
        self.lines = self.text.splitlines()
        self.nol = len(self.lines)
        for ln in range(self.nol):
            self.lines[ln] = unicode(self.lines[ln])
    def on_changed(self):
        self.prep()
    def _on_changed(self):
        self.prep()
    def set_text(self, text):
        self.textbuffer.set_text(text)
    def append_text(self, text):
        self.set_text(self.get_text()+text)
    def get_text(self):
        text = self.textbuffer.get_text(*self.textbuffer.get_bounds())
        return text
    def print_text(self):
        text = self.get_text()
        print os.linesep.join(["[%s]"%l for l in text.splitlines()])
default_config = {
    'a': {
        'left_margin': 5,
        'indent': 12,
        'pixels_above_lines': 2,
        'pixels_below_lines': 0,
        'pixels_inside_wrap': -1,
        'fontdesc': 'DejaVu Sans 12',
        'text': u'',
        'wrapping': False,
        'sensitive': True,
        'editable': True,
        'input_type': 'transparent',
    },
}
def eval(ev, par):
    a = {}
    try:
        a.update(default_config['a'])
    except:
        pass
    try:
        a.update(par['a'])
    except:
        pass
    w = TextEditor()
    w.textview.set_left_margin(a['left_margin'])
    w.textview.set_indent(a['indent'])
    w.textview.set_pixels_above_lines(a['pixels_above_lines'])
    w.textview.set_pixels_below_lines(a['pixels_below_lines'])
    w.textview.set_pixels_inside_wrap(a['pixels_inside_wrap'])
    w.textbuffer.set_text(a['text'])
    fontdesc = pango.FontDescription(a['fontdesc'])
    w.textview.modify_font(fontdesc)
    w.set_sensitive(a['sensitive'])
    w.textview.set_property('editable', a['editable'])
    w.set_input_type(a['input_type'])
    w.set_wrapping(a['wrapping'])
    w.show()
    w.textview.show()
    ons = {}
    def on(ev, f):
        if ev in ['changed']:
            w.textbuffer.connect(ev, f, w)
        else:
            w.connect(ev, f)
    try:
        ons = par['on']
        for k in ons:
            on(k, ons[k])
    except:
        pass
    def set_text(text):
        w.set_text(text)
        return w
    def clear():
        w.set_text(u'')
        return w
    def get_text():
        return unicode(w.get_text())
    def set_sensitive(b):
        w.set_sensitive(b)
        return w
    def grab_focus():
        w.textview.grab_focus()
        return w
    def set_editable(b):
        w.textview.set_property('editable', b)
        return w
    def set_input_type(t):
        w.set_input_type(t)
        return w
    def set_wrapping(m):
        w.set_wrapping(m)
        return w
    res = {
        'widget': w,
        'on': ons,
        'm': {
            'get_text': get_text,
            'set_text': set_text,
            'get_value': get_text,
            'set_value': set_text,
            'clear': clear,
            'toggle_wrap_mode': w.toggle_wrap_mode,
            'set_sensitive': set_sensitive,
            'set_input_type': set_input_type,
            'set_wrapping': set_wrapping,
            'grab_focus': grab_focus,
        },
    }
    return res
if __name__ == '__main__':
    class TopLevel(gtk.Window):
        def __init__(self, widget,
                minw=100,
                minh=100,
                startw=1300,
                starth=777,
                border_width=3,
                title=u''
                ):
            gtk.Window.__init__(self, gtk.WINDOW_TOPLEVEL)
            self.minw = minw
            self.minh = minh
            self.startw = startw
            self.starth = starth
            self.set_title(title)
            self.connect("destroy", gtk.main_quit)
            self.set_border_width(border_width)
            self.set_size_request(self.minw, self.minh)
            self.resize(self.startw, self.starth)
            self.add(widget)
            self.set_position(gtk.WIN_POS_CENTER)
            self.show_all()
            self.present()
        def center(self):
            self.set_position(gtk.WIN_POS_CENTER)
        def run(self):
            gtk.main()
    class MyEditor(TextEditor):
        def on_changed(self):
            TextEditor.on_changed(self)
            self.print_text()
    ed = MyEditor()
    def on_changed1(w1, w2):
        w2.on_changed()
        w2.print_text()
    ed1 = eval(None, {'on': {'changed': on_changed1}})['widget']
    t = TopLevel(ed1)
    gtk.main()