#!/usr/bin/env python
# -*- coding: utf-8 -*-

import pygtk
import pango
import gtk
pygtk.require('2.0')
if gtk.pygtk_version < (2,7,0):
    print "PyGtk 2.7.0 or later required for this program"
    raise SystemExit
class FileFilter(gtk.FileFilter):
    def __init__(self, name, patterns, mime_types=None):
        gtk.FileFilter.__init__(self)
        self.set_name(name)
        for p in patterns:
            self.add_pattern(p)
        if mime_types is None:
            mime_types = []
        for m in mime_types:
            self.add_mime_type(m)
class FileDialog:
    buttons_save = (gtk.STOCK_CANCEL, gtk.RESPONSE_CANCEL, gtk.STOCK_SAVE, gtk.RESPONSE_OK)
    buttons_open = (gtk.STOCK_CANCEL, gtk.RESPONSE_CANCEL, gtk.STOCK_OPEN, gtk.RESPONSE_OK)
    action_open = gtk.FILE_CHOOSER_ACTION_OPEN
    action_save = gtk.FILE_CHOOSER_ACTION_SAVE
    fi_all = FileFilter(u"All files", ["*"])
    fi_png = FileFilter(u"PNG files .png", ["*.png"], ["image/png"])
    fi_to = FileFilter(u"Typographic object files .to", ["*.to"], ["image/txt"])
    fi_pdf = FileFilter(u"PDF files .pdf", ["*.pdf"], ["image/pdf"])
    fi_midi = FileFilter(u"MIDI files .midi", ["*.midi"], ["audio/midi"])
    fi_brailleu = FileFilter(u"Unicode braille files", ["*.*"], ["text/plain"])
    fi_braillea = FileFilter(u"ASCII braille files", ["*.*"], ["text/plain"])
    fi_svg = FileFilter(u"SVG files .svg", ["*.svg"], ["image/svg"])
    def dialog(self, title, action, buttons, filters, current=None):
        d = gtk.FileChooserDialog(title,
            None,
            action, buttons)
        d.set_default_response(gtk.RESPONSE_OK)
        for f in filters:
            d.add_filter(f)
        if current != None:
            d.set_current_name(current)
        response = d.run()
        if response == gtk.RESPONSE_OK:
            ok = True
            thefilename = d.get_filename()
        elif response == gtk.RESPONSE_CANCEL:
            ok = False
            thefilename = ''
        else:
            ok = False
            thefilename=''
        d.destroy()
        return {'ok': ok, 'fn': thefilename}
    def open_dialog(self, title, filters):
        return self.dialog(title, self.action_open, self.buttons_open, filters)
    def save_dialog(self, title, filters, current=None):
        return self.dialog(title, self.action_save, self.buttons_save, filters, current)
def low_dialog(title, action, buttons, filters, current=None):
    d = gtk.FileChooserDialog(title,
        None,
        action, buttons)
    d.set_default_response(gtk.RESPONSE_OK)
    for f in filters:
        d.add_filter(f)
    if current != None:
        d.set_current_name(current)
    response = d.run()
    if response == gtk.RESPONSE_OK:
        ok = True
        thefilename = d.get_filename()
    elif response == gtk.RESPONSE_CANCEL:
        ok = False
        thefilename = ''
    else:
        ok = False
        thefilename=''
    d.destroy()
    return {'ok': ok, 'fn': thefilename}
buttons_save = (gtk.STOCK_CANCEL, gtk.RESPONSE_CANCEL, gtk.STOCK_SAVE, gtk.RESPONSE_OK)
buttons_open = (gtk.STOCK_CANCEL, gtk.RESPONSE_CANCEL, gtk.STOCK_OPEN, gtk.RESPONSE_OK)
action_open = gtk.FILE_CHOOSER_ACTION_OPEN
action_save = gtk.FILE_CHOOSER_ACTION_SAVE
def file_dialog(p):
    default = {
        'type': 'read',
        'title': u'',
        'suggested_name': None,
        'filters': []
    }
    par = {}
    par.update(default)
    par.update(p)
    filters = []
    for fi in par['filters']:
        fd = {
            'name': u'',
            'patterns': [],
            'mime_types': [],
        }
        fd.update(fi)
        f = FileFilter(fd['name'], fd['patterns'], fd['mime_types'])
        filters.append(f)
    action = action_open if par['type'] == 'read' else action_save
    buttons = buttons_open if par['type'] == 'read' else buttons_save
    r = low_dialog(par['title'], action, buttons, filters, par['suggested_name'])
    return r
def read_bytes(p):
    par = {}
    par.update(p)
    par.update({'type': 'read'})
    res = file_dialog(par)
    ecode = None
    message = None
    fn = None
    b = ''
    if res['ok']:
        fn = res['fn']
        try:
            ok = True
            b = open(fn, 'rb').read()
        except:
            ok = False
            message = u'błąd otwarcia pliku'
            ecode = u'open'
    else:
        ok = False
        message = u'błąd otwarcia pliku'
        ecode = u'dialog'
    r = {
        'ok': ok,
        'b': b,
    }
    if fn is not None:
        r['fn'] = fn
    if ecode is not None:
        r['ecode'] = ecode
    if message is not None:
        r['message'] = message
    return r
def write_bytes(p):
    par = {}
    par.update(p)
    par.update({'type': 'write'})
    res = file_dialog(par)
    ecode = None
    message = None
    fn = None
    if res['ok']:
        fn = res['fn']
        try:
            ok = True
            open(fn, 'wb').write(par['b'])
        except:
            ok = False
            message = u'błąd zapisu pliku'
            ecode = u'save'
    else:
        ok = False
        message = u'błąd zapisu pliku'
        ecode = u'dialog'
    r = {
        'ok': ok,
    }
    if fn is not None:
        r['fn'] = fn
    if ecode is not None:
        r['ecode'] = ecode
    if message is not None:
        r['message'] = message
    return r
def fool():        
    if r['ok']:
        fn = r['fn']
        try:
            s = (open(fn, 'rb').read().decode('utf8'))
        except:
            set_status('error', u'błąd otwarcia pliku')
            s = u''
        r = kl.convert('ascii', 'unicode', s)
        if r['ok']:
            wdict['editor']['m']['set_value'](r['s'])
            set_status('empty')
            wdict['viewer']['m']['clear']()
            wdict['fstatus']['m']['set_value'](fn)
        else:
            if False:
                set_status('error', u'niepoprawne znaki w pliku')
            else:
                wdict['editor']['m']['set_value'](r['s'])
                set_status('error', u'niepoprawne znaki w pliku')
                wdict['viewer']['m']['clear']()
                wdict['fstatus']['m']['set_value'](fn)
        priv['wdict']['button_get_pdf']['m']['set_label'](u'plik PDF niegotowy')
        priv['wdict']['button_get_pdf']['m']['set_sensitive'](False)
        priv['wdict']['button_get_midi']['m']['set_label'](u'plik MIDI niegotowy')
        priv['wdict']['button_get_midi']['m']['set_sensitive'](False)
    else:
        pass
def open_unicode_braille(w):
    fd = file_dialog.FileDialog()
    r = fd.open_dialog(u'otwórz plik w kodowaniu utf-8 Unicode Braille',
        [fd.fi_brailleu])
    if r['ok']:
        fn = r['fn']
        try:
            s = (open(fn, 'rb').read()).decode('utf8')
            wdict['editor']['m']['set_value'](s)
            set_status('empty')
            wdict['viewer']['m']['clear']()
            wdict['fstatus']['m']['set_value'](r['fn'])
        except:
            set_status('error', u'błąd otwarcia pliku')
    else:
        pass
    fd = file_dialog.FileDialog()
    r = fd.open_dialog(u'otwórz plik w kodowaniu utf-8 Unicode Braille',
        [fd.fi_brailleu])
    if r['ok']:
        fn = r['fn']
        try:
            s = (open(fn, 'rb').read().decode('utf8'))
        except:
            set_status('error', u'błąd otwarcia pliku')
            s = u''
        r = kl.convert('ascii', 'unicode', s)
        if r['ok']:
            wdict['editor']['m']['set_value'](r['s'])
            set_status('empty')
            wdict['viewer']['m']['clear']()
            wdict['fstatus']['m']['set_value'](fn)
        else:
            if False:
                set_status('error', u'niepoprawne znaki w pliku')
            else:
                wdict['editor']['m']['set_value'](r['s'])
                set_status('error', u'niepoprawne znaki w pliku')
                wdict['viewer']['m']['clear']()
                wdict['fstatus']['m']['set_value'](fn)
        priv['wdict']['button_get_pdf']['m']['set_label'](u'plik PDF niegotowy')
        priv['wdict']['button_get_pdf']['m']['set_sensitive'](False)
        priv['wdict']['button_get_midi']['m']['set_label'](u'plik MIDI niegotowy')
        priv['wdict']['button_get_midi']['m']['set_sensitive'](False)
    else:
        pass