#!/usr/bin/env python
# -*- coding: utf-8 -*-

__version__ = '0.9'
__date__= '15.04.2014'
error_messages = {
'server error': {
    'en': u'unhandled server error',
    'pl': u'nieznany błąd serwera',
    'guipl': u'błąd wewnętrzny programu',
    },
'call error': {
    'en': u'internal error',
    'pl': u'błąd wewnętrzny programu',
    'guipl': u'błąd wewnętrzny programu',
    },
'authentication error': {
    'en': u'authentication error',
    'pl': u'błąd dostępu do usługi',
    'guipl': u'błąd wewnętrzny programu',
    },
'kaliope call error': {
    'en': u'internal error',
    'pl': u'błąd wewnętrzny programu',
    'guipl': u'błąd wewnętrzny programu',
    },
'kaliope input parser warning': {
    'en': u'warning in input notation',
    'pl': u'niewłaściwa postać w zapisie wejścionym',
    'guipl': u'niewłaściwa postać w zapisie wejścionym',
    },
('kaliope input parser warning', 'unhandled exception'): {
    'en': u'unhandled error in input notation',
    'pl': u'nierozpoznany błąd w zapisie wejściowym',
    'guipl': u'nierozpoznany błąd w zapisie wejściowym',
    },
('kaliope input parser warning', 'braille_vioces_unequal'): {
    'en': u'partial voices must have exactly the same time',
    'pl': u'niezgodny czas głosów częściowych w takcie',
    'guipl': u'niezgodny czas głosów częściowych w takcie',
    },
('kaliope input parser warning', 'tuplet_longer_then_notes'): {
    'en': u'missing notes under tuplet',
    'pl': u'za mało nut w grupie nieregularnej',
    'giupl': u'za mało nut w grupie nieregularnej',
    },
('kaliope input parser warning', 'note_values_heuristics_failed'): {
    'en': u'note values heuristics failed',
    'pl': u'rozpoznanie długości nutowych nie powiodło się',
    'guipl': u'rozpoznanie długości nutowych nie powiodło się',
    },
('kaliope input parser warning', 'zero_time_voice'): {
    'en': u'zero time voice encountered',
    'pl': u'takt o zerowym czasie trwania',
    'guipl': u'takt o zerowym czasie trwania',
    },
('kaliope input parser warning', 'different_number_of_measures_in_staves'): {
    'en': u'all staves must have the same number of measures',
    'pl': u'niezgodna liczba taktów na pięcioliniach',
    'guipl': u'niezgodna liczba taktów na pięcioliniach',
    },
('kaliope input parser warning', 'staff_index_out_of_bounds'): {
    'en': u'staff index out of bounds',
    'pl': u'niewłaściwy numer pięciolini',
    'guipl': u'niewłaściwy numer pięciolini',
    },
('kaliope input parser warning', 'cannot_determine_note_time'): {
    'en': u'cannot determine note time',
    'pl': u'nierozpoznana wartość nutowa',
    'guipl': u'nierozpoznana wartość nutowa',
    },
('kaliope input parser warning', 'cannot_determine_note_pitch'): {
    'en': u'cannot determine note pitch',
    'pl': u'nierozpoznana wysokość nuty',
    'guipl': u'nierozpoznana wysokość nuty',
    },
('kaliope input parser warning', 'extra_stave_in_measure'): {
    'en': u'extra stave in measure',
    'pl': u'nadmiarowa pięciolinia w takcie',
    'guipl': u'nadmiarowa pięciolinia w takcie',
    },
('kaliope input parser warning', 'invalid_xml_value'): {
    'en': u'invalid xml value',
    'pl': u'błąd składniowy notacji typograficznej',
    'guipl': u'błąd składniowy notacji typograficznej',
    },
('kaliope input parser warning', 'syntax_error'): {
    'en': u'syntax error',
    'pl': u'błąd składniowy notacji braille-owskiej',
    'guipl': u'błąd składniowy notacji braille-owskiej',
    },
'kaliope input parser error': {
    'en': u'error in input notation',
    'pl': u'błąd w zapisie wejściowym',
    'guipl': u'błąd w zapisie wejściowym',
    },
'kaliope braille output error': {
    'en': u'error in Braille notation creation',
    'pl': u'błąd przy tworzeniu postaci braille-owskiej',
    'guipl': u'błąd podczas tworzenia pliku wyjściowego',
    },
'kaliope XML output error': {
    'en': u'error in MusicXML creation',
    'pl': u'błąd podczas tworzenia postaci MusicXML',
    'guipl': u'błąd podczas tworzenia pliku wyjściowego',
    },
'kaliope output error': {
    'en': u'error in output file creation',
    'pl': u'błąd podczas tworzenia plików wyjściowych',
    'guipl': u'błąd podczas tworzenia plików wyjściowych',
    },
}
for k, v in error_messages.items():
    if isinstance(k, tuple) and k[0] == 'kaliope input parser warning':
        error_messages[('kaliope input parser error', k[1])] = v