#!/usr/bin/env python
# -*- coding: utf-8 -*-

import os
import pprint
import cStringIO as stringio
import sys
import os
import base64
import re
import string
import jpc
import kaliope_hyph
import kaliope_errors
import braille_encodings as be
import braille_abbr as ba
import texjpclib as tj
def write_decoded_file(ofn, outstr):
    with open(ofn, 'wb') as ofile:
        ofile.write(decode(outstr))
def decode(s):
    return base64.b64decode(s)
url = 'http://eurydyka.kaliope.org.pl/kaliope'
func = ('kaliope', 'kaliope')
auth = {'usern': 'guicl', 'token': '656f8e9d6d05183222da12c552f5ab3d'}
kaliope = jpc.Client(func, url, 'http', Auth=auth)
outxml = {'xml': {'type': 'xml'}}
outjson = {'json': {'type': 'omus'}}
outbrailleu = {'brailleu': {'type': 'brailleu'}}
outmidi = {'midi': {'type': 'midi'}}
outpdfb = {'pdfb': {'type': 'pdfb'}}
outpdf = {'pdf': {'type': 'pdf', 'page': 1}}
outpng = {'png': {'type': 'png', 'resol': 144, 'h': 200}}
js = {'value': '', 'type': '', 'output': {}}
def braille_to_typo(s):
    par = {}
    par.update(js)
    par.update({'type': 'brailleu'})
    par['value'] = s
    outpng = {'png': {'type': 'png',
        'resol': 200,
        'cut': {'box': 'glyph',
            'unit': 'pt',
            'margins': 5,
            },
        }}
    outpdf = {'pdf': {'type': 'pdf', 'page': 1}}
    outmidi = {'midi': {'type': 'midi'}}
    outxml = {'xml': {'type': 'xml'}}
    par['output'].update(outpng)
    par['output'].update(outmidi)
    par['output'].update(outpdf)
    par['output'].update(outxml)
    ou = kaliope(par)
    ou = kaliope(par)
    if 'status' in ou:
        o = ou['output']
        value = {}
        if 'png' in o and 'pdf' in o and 'midi' in o and 'xml' in o:
            res = {'ok': True,
                'value': {
                    'png': decode(o['png']['value']),
                    'pdf': decode(o['pdf']['value']),
                    'midi': decode(o['midi']['value']),
                    'xml': o['xml']['value'],
                    }
                }
        else:
            res = {'ok': False, 'message': 'Nie udało się wygenerować pliku graficznego'}
    else:
        if 0:
            id = ou['error']['id']
            if isinstance(id, list):
                id = tuple(id)
            message = kaliope_errors.error_messages[id]['guipl']
        message = error_message(ou)
        res = {'ok': False, 'message': message}
    return res
def typo_to_braille(s):
    par = {}
    par.update(js)
    par.update({'type': 'xml'})
    par['value'] = s
    outpng = {'png': {'type': 'png',
        'resol': 200,
        'cut': {'box': 'glyph',
            'unit': 'pt',
            'margins': 5,
            },
        }}
    outbrailleu = {'brailleu': {'type': 'brailleu'}}
    outmidi = {'midi': {'type': 'midi'}}
    outpdf = {'pdf': {'type': 'pdf', 'page': 1}}
    par['output'].update(outbrailleu)
    par['output'].update(outmidi)
    par['output'].update(outpdf)
    ou = kaliope(par)
    if 'status' in ou:
        o = ou['output']
        value = {}
        if 'brailleu' in o and 'midi' in o:
            res = {'ok': True,
                'value': {
                    'brailleu': o['brailleu']['value'],
                    'midi': decode(o['midi']['value']),
                    'pdf': decode(o['pdf']['value']),
                    }
                }
        else:
            res = {'ok': False, 'message': 'Nie udało się wygenerować pliku brailowskiego'}
    else:
        if 0:
            id = ou['error']['id']
            if isinstance(id, list):
                id = tuple(id)
            if id in kaliope_errors.error_messages:
                message = kaliope_errors.error_messages[id]['guipl']
            else:
                message = ou['error']['message']
            try:
                lineno=err['info'][0]['line']
                print 'w %d linii' % lineno 
            except:
                lineno=None
        message = error_message(ou)
        res = {'ok': False, 'message': message}
    return res
def mk_sklad_lib():
    conf = {
      'func': 'mamut_api_gui',
      'url': 'http://eurydyka.kaliope.org.pl/kaliope',
      'usern': 'guicl',
      'token': '656f8e9d6d05183222da12c552f5ab3d',
    }
    """
      auxjson_to_amusjson -- function specific to 'amus' service
      from:
        {'global': <global>, 'objects': <objects>, 'info': <infos>}
        where:
          <global> -- dictionary with keys: 'info', 'params', 'prolog'
          <objects> -- list of dictionaries with keys: 'info', 'params', 'prolog' and 'value'
          <infos>  -- dictionary with keys 'global' and 'objects' which contains
            information extracted from key 'info' of the above object
      to two dictionares:
        {'tex': <global prolog>, 'par': <global params>, 'val': <objects>}
        {'attr':{'info': <glob info>, ...}, 'value': <infos>}
      with some keys migations between block
    """
    def auxjson_to_amusjson(auxjson, output=None):
        try:
           glob = auxjson['global']
           objs = auxjson['objects']
           inf = auxjson['info']
        except KeyError:
           pass
        objnew = []
        for o in objs:
             objnew.append({'tex': o['prolog'], 'par': o['params'], 'val': o['value']})
        prog = {'tex': glob['prolog'], 'par': glob['params'], 'val': objnew}
        if output:
            prog['output'] = output
        oinf = {'attr': {'nop': len(inf['objects']), 'info': glob['info']}, 'value': inf['objects']}
        return prog, oinf
    conf['call'] = jpc.Client(conf['func'], conf['url'], 'http', 
      Auth={'usern': conf['usern'], 'token': conf['token']})
    def string_to_blocks(s):
        blocks = tj.jpcaux_split(s, {'amus': 1})
        blocks = tj.jpc_json_structuralize(blocks)
        return blocks
    def string_to_parts(s):
        return blocks_to_parts(string_to_blocks(s))
    def parts_to_blocks(parts):
        info = parts['info']
        if 'params' not in parts:
            parts['params'] = {}
        blocks = {
            'amus': {
                'info': {
                    'global': {},
                    'objects': [info]
                    },
                'global': {'info': {}, 'params': {}, 'prolog': ''},
                'objects': [parts
                    ],
            }
        }
        return blocks
    def blocks_to_parts(bl):
        ob0 = bl['amus']['objects'][0]
        parts = ob0
        return parts
    def blocks_to_results(bl):
        out={}
        out = {'png': {'type': 'png', 'resol': 200}}
        out['pdf'] = {'type': 'pdf'}
        prog, oinf = auxjson_to_amusjson(bl['amus'], output=out)
        resp = conf['call'](prog)
        if 'error' in resp:
            res = {'ok': False, 'message': resp['error']}
        else:
            o = resp['output']
            if 'png' in o and 'pdf' in o:
                res = {'ok': True,
                    'value': {
                        'png': decode(o['png']['value']),
                        'pdf': decode(o['pdf']['value']),
                        }
                    }
            else:
                res = {'ok': False, 'message': 'Nie udało się wygenerować pliku graficznego'}
        return res
    def string_to_results(s):
        return blocks_to_results(string_to_blocks(s))
    serialize_config = {
        'service': 'amus',
        'part_name': {
            'prolog': 'PROLOG',
            'value': 'VALUE',
            'info': 'INFO',
        },
    }
    def part_brace(be, pn):
        return u'%%JPC%s %s: OBJECT %s' % (be, serialize_config['service'], serialize_config['part_name'][pn])
    def part_to_string(p, pt):
        s = u''
        s += part_brace('BEGIN', pt)
        s += u'\n'
        s += p
        s += u'\n'
        s += part_brace('END', pt)
        return s
    def info_to_string(info):
        rl = [u'%s=%s;' % (k, info[k]) for k in info.keys()]
        res = u'\n'.join(rl)
        return res
    def parts_to_string(parts):
        res = u'\n'.join([
            part_to_string(parts['prolog'], 'prolog'),
            part_to_string(parts['value'], 'value'),
            part_to_string(info_to_string(parts['info']), 'info'),
        ])
        return res
    r = {
        'string_to_results': string_to_results,
        'blocks_to_results': blocks_to_results,
        'string_to_blocks': string_to_blocks,
        'string_to_parts': string_to_parts,
        'parts_to_string': parts_to_string,
        'parts_to_blocks': parts_to_blocks,
    }
    return r
sklad = mk_sklad_lib()
def error_message(ou):
    if 'error' in ou:
        err = ou['error']
        id = err['id']
        if isinstance(id, list):
            id = tuple(id)
        if id in kaliope_errors.error_messages:
            message = kaliope_errors.error_messages[id]['guipl']
        else:
            message = err['message']
        try:
            lineno = err['info'][0]['line']
            message += '| linia: %d' % lineno 
        except:
            pass
    else:
        message = 'błąd przetwarzania'
    return message
convert = be.convert
def pdf_to_png(s, page):
    resol = 200
    encoded = base64.b64encode(s)
    func = ('kaliope', 'pdf_to_bmp')
    action = jpc.Client(func, url, 'http', Auth=auth)
    par = {}
    js = {'value': '', 'type': '', 'output': {}}
    par.update(js)
    par.update({'type': 'png'})
    par.update({'page': page})
    par['page'] = page
    par['value'] = encoded
    outpng = {'png': {'type': 'png', 'resol': resol}}
    par['output'].update(outpng)
    ou = action(par)
    if 'status' in ou:
        o = ou['output']
        value = {}
        if 'png' in o:
            res = {'ok': True,
                'value': {
                    'png': decode(o['png']['value']),
                    },
                'sid': ou['sid'],
                }
        else:
            res = {'ok': False, 'message': 'Nie udało się wygenerować pliku graficznego'}
    else:
        if 0:
            id = ou['error']['id']
            if isinstance(id, list):
                id = tuple(id)
            message = kaliope_errors.error_messages[id]['guipl']
        message = error_message(ou)
        res = {'ok': False, 'message': message}
    return res
def pdf_to_mono(p):
    resol = 200
    func = ('kaliope','pdf_to_bmp')
    action = jpc.Client(func, url, 'http', Auth=auth)
    try:
        page = p['page']
    except:
        page = 1
    par = {}
    js = {'value': '', 'type': '', 'output': {}}
    par.update(js)
    par.update({'page': page})
    if  'sid' in p:
        par['sid'] = p['sid']
    elif 's' in p:
        encoded = base64.b64encode(p['s'])
        par['value'] = encoded
    outpng = {'png': {'type': 'png', 'resol': resol}}
    out = {'colors': 'mono'}
    out.update(p['out'])
    outjson = {'json': {'type': 'json', 'cut': p['cut'], 'out': out}}
    par['output'].update(outpng)
    par['output'].update(outjson)
    ou = action(par)
    if 'status' in ou:
        o = ou['output']
        value = {}
        if 'png' in o:
            res = {'ok': True,
                'value': {
                    'json': o['json']['value'],
                    },
                'sid': ou['sid'],
                }
        else:
            res = {'ok': False, 'message': 'Nie udało się wygenerować pliku graficznego'}
    else:
        if 0:
            id = ou['error']['id']
            if isinstance(id, list):
                id = tuple(id)
            message = kaliope_errors.error_messages[id]['guipl']
        message = error_message(ou)
        res = {'ok': False, 'message': message}
    return res
def xml_to_png(s):
    par = {}
    par.update(js)
    par.update({'type': 'xml'})
    par['value'] = s
    outpng = {'png': {'type': 'png', 'resol': 144, 'h': 400}}
    par['output'].update(outpng)
    ou = kaliope(par)
    if 'output' in ou:
        o = ou['output']
        value = {}
        if 'png' in o and 'pdf' in o:
            res = {'ok': True,
                'value': {
                    'png': decode(o['png']['value']),
                    'pdf': decode(o['pdf']['value']),
                    }
                }
        else:
            res = {'ok': False, 'message': 'buu'}
    else:
        res = {'ok': False, 'message': 'buuu'}
    return res
def hyphenate_prepare_function():
    kh = kaliope_hyph
    h = kh.Hyphenator(kh.patterns.w05_patterns, kh.patterns.w05_exceptions)
    hy = h.hyphenate_word
    return hy
def hyphenate_word(s, hfunction):
    r = u'-'.join(hfunction(s))
    return r
def hyphenate_words(tokens, algorithm=None):
    hfunction = hyphenate_prepare_function()
    res = []
    for t, v in tokens:
        if t == 'word':
            r = hyphenate_word(v, hfunction)
        else:
            r = v
        res.append([t, r])
    return res
def abbreviate_word(word, level=1):
    return ba.abbreviate_word(word, level)
def abbreviate_words(tokens, level=1):
    res = []
    for t, v in tokens:
        if t == 'word':
            r = abbreviate_word(v, level)
        else:
            r = v
        res.append([t, r])
    return res
polish_lowercase = u'ąćęłńóśźż'
polish_uppercase = polish_lowercase.upper()
polish_letters = polish_lowercase + polish_uppercase
letters = string.letters + polish_letters
punctuation = u',\.;:()' + '\''
def split_text(s):
    pattern = ur'([' + letters + ur']+)|([^' + letters + ur']+)'
    types = ['word', 'nonword']
    mol = re.finditer(pattern, s, flags=0)
    tokens = []
    for mo in mol:
        gr = 1 if mo.group(1) else 2
        t = types[gr - 1]
        v = mo.group(gr)
        tokens.append([t, v])
    return tokens
if __name__ == '__main__':
    if 0:
        res = kaliope(js)
        o = res['output']
        if 'xml' in o:
          with open('out.xml', 'wb') as ofile:
            ofile.write(o['xml']['value'])
        if 'pdfb' in o:
          write_decoded_file('out.pdf',o['pdfb']['value'])
        if 'pdf' in o:
          write_decoded_file('out.pdf',o['pdf']['value'])
        if 'mid' in o:
          write_decoded_file('out.mid',o['mid']['value'])
        try:
          write_decoded_file('out.png',o['png']['value'])
        except KeyError:
          pass
        r = repr(res)
        if len(r)<1000:
            print r
        else:
           print 'long response, printing shortened "output"'
           res['output']='{DICT BELOW}'
           print res
           for i in o.values():
             if 'value' in i and len(i['value'])>1000:
                 i['value']='... HERE WAS LONG STRING ...'
           r = repr(o)
           print r
    if 1:
        lg_string = ur'''
%JPCBEGIN amus: OBJECT PROLOG
  %! example prolog for choir
  \input mus-pro-xc
  \musdefscore {\\s\mussize\+{16\musunit}\\a\mussize\+{16\musunit}\\t\mussize\+{16\musunit}\\b\mussize}%
  \musclefs{\-s0\treble \-a0\treble\-t0{\treble\dlap{\kern2.6mm\llap{\sevenrm8\kern1mm}}}\-b0\bass}
  \musaccidentals{\-s8\krz \-a8\krz \-t8\krz \-b6\krz}
  \mustextconfig{\\Ss{-6}\\Aa{-7}\\Tt{-7}\\Bb{-6}}
  \musbars{\\ss\\aa\\tt\\bb}
  \def\S{\mustextput S}\def\A{\mustextput A}\def\T{\mustextput T}\def\B{\mustextput B}
  \musaccolades{\-b0 {\placeltortoise bs}}
  \def\diste{.4}
  \def\hdiste{.2}
  \def\distq{.6}
  \def\hdistq{.3}
%JPCEND amus: OBJECT PROLOG
%JPCBEGIN amus: OBJECT VALUE
  % ----------------------------------------------------------------------------
  %! sł. J. Przybora, muz. J.Wasowski, „W kawiarence «Sułtan»”, takty 1–4, opr. na chór mieszany A. Borzym
  % ----------------------------------------------------------------------------
  % takt 1
  % ----------------------------------------------------------------------------
  \+-1\mushq
  \-s3 {\rlap{\kern-23.5mm\srm Sopran}}
  \-a3 {\rlap{\kern-23.5mm\srm Alt}}
  \-t3 {\rlap{\kern-23.5mm\srm Tenor}}
  \-b3 {\rlap{\kern-23.5mm\srm Bas}}
  \-s6 {\muscyf 4}\-s2 {\muscyf 4}%
  \-a6 {\muscyf 4}\-a2 {\muscyf 4}%
  \-t6 {\muscyf 4}\-t2 {\muscyf 4}%
  \-b6 {\muscyf 4}\-b2 {\muscyf 4}%
  \+2.5\mushq
  \-b{10} {\bi p}
  \+1\mushq
  \-s{15} {\rlap{\bf Moderato}}
   \museighr s
   \museighr a
   \museighr t
  \-b1 \quat
  \-b1 \krop
  \B {}{}{Pa}{}
  \*{\hdiste}
  \-s{10} {\bi p}
  \-a{10} {\bi p}
  \-t{10} {\bi p}
  \*{\hdiste}
  \-s2 \quat
  \-s3 \krop
  \S {}{}{Pa}{}
  \=a{-2} \quat
  \=a{-1} \krop
  \A {}{}{Pa}{}
  \-t4 \quatd
  \-t5 \krop
  \T {}{}{Pa}{}
  \*{\distq}
  \-b5 \eighd
  \B {}{}{pa}{}
  \*{\diste}
   \museighr s
   \museighr a
   \museighr t
  \-b1 \quat
  \-b1 \krop
  \B {}{}{pa}{}
  \*{\diste}
  \-s2 \quat
  \-s3 \krop
  \S {}{}{pa}{}
  \=a{-2} \quat
  \=a{-1} \krop
  \A {}{}{pa}{}
  \-t4 \quatd
  \-t5 \krop
  \T {}{}{pa}{}
  \*{\distq}
  \-b5 \eighd
  \B {}{}{pa}{}
  \*{\diste}
  % ----------------------------------------------------------------------------
  % takt 2
  % ----------------------------------------------------------------------------
  \bar
  \+2.5\mushq
   \museighr s
   \museighr a
   \museighr t
  \-b1 \quat
  \-b1 \krop
  \B {}{}{pa}{}
  \*{\diste}
  \-s2 \quat
  \-s3 \krop
  \S {}{}{pa}{}
  \=a{-2} \quat
  \=a{-1} \krop
  \A {}{}{pa}{}
  \-t4 \quatd
  \-t5 \krop
  \T {}{}{pa}{}
  \*{\distq}
  \-b5 \eighd
  \B {}{}{pa}{}
  \*{\diste}
   \museighr s
   \museighr a
   \museighr t
  \-b1 \quat
  \-b1 \krop
  \B {}{}{pa}{}
  \*{\diste}
  \-s2 \quat
  \-s3 \krop
  \S {}{}{pa}{}
  \=a{-2} \quat
  \=a{-1} \krop
  \A {}{}{pa}{}
  \-t4 \quatd
  \-t5 \krop
  \T {}{}{pa}{}
  \*{\distq}
  \-b5 \eighd
  \B {}{}{pa}{}
  \*{\diste}
  \+\mushq
  \-s{10} {\bi mf}
  \-a{10} {\bi mf}
  \-t{10} {\bi mf}
  \-b{10} {\bi mf}
  \+-\mushq
  % ----------------------------------------------------------------------------
  % takt 3
  % ----------------------------------------------------------------------------
  \bard
  \+2.5\mushq
  \-s5 \quatd
  \-s5 \krop
  \S {}{}{W ka}{}
  \-a2 \quat
  \-a3 \krop
  \A {}{}{W ka}{}
  \-t7 \quatd
  \T {}{}{W ka}{}
  \-b1 \quat
  \B {}{}{W ka}{}
  \*{\distq}
  \-t7 \quatd
  \T {-}{}{wia}{}
  \-b1 \quat
  \B {-}{}{wia}{}
  \*{\hdistq}
  \+-.8\mushq
  \-s4 \eighd
  \+.8\mushq
  \S {-}{wia}{}{}
  \+-.8\mushq
  \-a2 \eigh
  \+.8\mushq
  \A {-}{wia}{}{}
  \*{\hdistq}
  \-s2 \lkrz
  \-s2 \quat
  \S {-}{}{re}{}
  \-s3 \krop
  \-a1 \quat
  \-a1 \krop
  \A {-}{}{re}{}
  \-t5 \quatd
  \-t5 \krop
  \T {-}{}{re}{}
  \-b4 \quatd
  \B {-}{}{re}{}
  \*{\distq}
  \-b4 \quatd
  \B {-}{}{nce}{}
  \*{\hdistq}
  \-s3 \eigh
  \S {-}{}{nce}{}
  \-a1 \eigh
  \A {-}{}{nce}{}
  \-t5 \eigh
  \T {-}{}{nce}{}
  \*{\diste}
  % ----------------------------------------------------------------------------
  % takt 4
  % ----------------------------------------------------------------------------
  \bar
  \+2.5\mushq
  \-s3 \lkrz
  \-s3 \eigh
  \S {}{,,}{Su}{}
  \-a1 \half
  \A {}{,,}{Su}{}
  \-t6 \halfd
  \T {}{,,}{Su}{}
  \-b7 \half
  \-b0 \half
  \B {}{,,}{Su}{}
  \*{\diste}
  \-s4 \eighd
  \-s{5.6} {\hclslurb {dir 60}{tension 1.7} a}
  \S {-}{}{}{łtan''}
  \*{\diste}
  \-s4 \halfd
  \-s{5.6} {\hclslure {dir -60} a}
  \*{\distq} % cheating
  \museighr a
  \museighr t
  \-b3 \lkrz
  \-b3 \half
  \B {-}{}{łtan}{''}
  \*{\hdistq}
  \-a2 \quat
  \A {-}{}{łtan''}{}
  \-t4 \quatd
  \T {-}{}{łtan''}{}
  \*{\hdistq}
  \museighr s
  \*{\hdistq}
  \-s4 \eighd
  \+.5\mushq
  \S {}{}{przed}{}
  \+-.5\mushq
  \-a2 \eigh
  \+.5\mushq
  \A {}{}{przed}{}
  \+-.5\mushq
  \-t7 \eighd
  \+.5\mushq
  \T {}{}{przed}{}
  \+-.5\mushq
  \*{\diste}
%JPCEND amus: OBJECT VALUE
%JPCBEGIN amus: OBJECT INFO
filename=LG-xc-01-W_kawiarence_Sultan.pdf;
title=sł. J. Przybora, muz. J.Wasowski, „W kawiarence «Sułtan»”;
%JPCEND amus: OBJECT INFO
        '''
        if 0:
            print res.keys()
            print res['amus'].keys()
            print res['amus']['info']
            print len(res['amus']['objects'])
            for ao in res['amus']['objects']:
                print ao.keys()
                print ao['value'][:550]
        parts = sklad['string_to_parts'](lg_string)
        blocks = sklad['parts_to_blocks'](parts)
        reserialized = sklad['parts_to_string'](parts)
        open('000_serialize_test.lg', 'wb').write(reserialized.encode('utf8'))