#!/usr/bin/env python
# -*- coding: utf-8 -*-

import os
import tempfile
import random, string
def random_word(length):
    return u''.join(random.choice(string.lowercase) for i in range(length))
def mk_multipage_viewer(par):
    priv = {}
    def init():
        priv['nop'] = len(par['pages'])
        length = 10
        priv['fool'] = random_word(length)
        fool_dir = tempfile.mkdtemp()
        fool_fn = priv['fool']
        fool_path = os.path.join(fool_dir, fool_fn)
        priv['fool_path'] = fool_path
        priv['wdict'] = par['wdict']
        priv['id'] = 'viewer_' + random_word(5)
        save_image_string(par['pages'][par['pno'] - 1])
        priv['pno'] = par['pno']
    def save_image_string(image_string):
        fool_fh = open(priv['fool_path'], 'wb')
        fool_fh.write(image_string)
        fool_fh.close()
    def mk_image_viewer(par):
        if 'bg' not in par:
            bg = ['bytes', [0, 0, 0]],
        vi = {
            't': 'viewer',
            'id': par['id'],
            'on': {
                'key_press': key_press,
            },
            'a': {
                'img': par['img'],
            },
        }
        if 'page' in par:
            vi['a']['page'] = par['page']
        return vi
    init()
    def key_press(*ar):
        print 'arr', ar
    def first():
        if priv['nop'] >= 1:
            display_page(1)
    def last():
        if priv['nop'] >= 1:
            display_page(priv['nop'])
    def next():
        n = priv['pno'] + 1 if priv['pno'] < priv['nop'] else priv['pno']
        display_page(n)
    def previous():
        n = priv['pno'] - 1 if priv['pno'] > 1 else priv['pno']
        display_page(n)
    def display_page(n):
        save_image_string(par['pages'][n - 1])
        priv['pno'] = n
        priv['wdict'][priv['id']]['m']['set_value'](priv['fool_path'])
    def mk_button(lab, fun):
        return {
            't': 'button',
            'a': {
                'label': lab,
            },
            'on': {
                'clicked': fun,
            },
        }
    button_first = mk_button(u'pierwsza strona', lambda w: first())
    button_last = mk_button(u'ostatnia strona', lambda w: last())
    button_next = mk_button(u'następna strona', lambda w: next())
    button_previous = mk_button(u'poprzednia strona', lambda w: previous())
    toolbar = {
        't': 'hbox',
        'a': {
        },
        'on': {},
        'c': [['exp', button_first], ['exp', button_previous], ['exp', button_next], ['exp', button_last]],
    }
    par_img_page = {
            'img': priv['fool_path'],
            'bg': ['bytes', [100, 100, 100]],
            'id': priv['id'],
        }
    pdf_page = mk_image_viewer(par_img_page)
    vb = {
        't': 'vbox',
        'a': {
        },
        'on': {
            'key_press': key_press,
        },
        'c': [['noexp', toolbar], ['exp', pdf_page]],
    }
    res = vb
    return res