#!/usr/bin/env python
# -*- coding: utf-8 -*-

import pygtk
pygtk.require('2.0')
import gtk
import whiteboard as wb
class ScrolledWindow(gtk.ScrolledWindow):
    def __init__(self):
        gtk.ScrolledWindow.__init__(self)
        self.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC)
        self.set_shadow_type(gtk.SHADOW_NONE)
        self.show()
    def addv(self, widget):
        self.add_with_viewport(widget)
class WScrolledWindowWithRulers(gtk.Table):
    def __init__(self, subwidget):
        gtk.Table.__init__(self, 2, 2)
        self.subwidget = subwidget
        self.sw = gtk.ScrolledWindow()
        self.sw.add_with_viewport(self.subwidget)
        self.sw.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC)
        self.sw.set_shadow_type(gtk.SHADOW_NONE)
        self.sw.show()
        self.hruler = gtk.HRuler()
        self.vruler = gtk.VRuler()
        self.hruler.set_range(0, 400, 0, 400)
        self.vruler.set_range(0, 300, 0, 300)
        self.attach(self.hruler, 1, 2, 0, 1, yoptions=0)
        self.attach(self.vruler, 0, 1, 1, 2, xoptions=0)
        self.attach(self.sw, 1, 2, 1, 2)
        self.subwidget.set_events(gtk.gdk.POINTER_MOTION_MASK |
                             gtk.gdk.POINTER_MOTION_HINT_MASK )
        def motion_notify(ruler, event):
            return ruler.emit("motion_notify_event", event)
        self.subwidget.connect_object("motion_notify_event", motion_notify,
                                 self.hruler)
        self.subwidget.connect_object("motion_notify_event", motion_notify,
                                 self.vruler)
        self.hadj = self.sw.get_hadjustment()
        self.vadj = self.sw.get_vadjustment()
        def val_cb(adj, ruler, horiz):
            if horiz:
                span = self.sw.get_allocation()[3]
            else:
                span = self.sw.get_allocation()[2]
            l,u,p,m = ruler.get_range()
            v = adj.value
            ruler.set_range(v, v+span, p, m)
            while gtk.events_pending():
                gtk.main_iteration()
        self.hadj.connect('value-changed', val_cb, self.hruler, True)
        self.vadj.connect('value-changed', val_cb, self.vruler, False)
        def size_allocate_cb(wid, allocation):
            x, y, w, h = allocation
            l,u,p,m = self.hruler.get_range()
            m = max(m, w)
            self.hruler.set_range(l, l+w, p, m)
            l,u,p,m = self.vruler.get_range()
            m = max(m, h)
            self.vruler.set_range(l, l+h, p, m)
        self.sw.connect('size-allocate', size_allocate_cb)
        self.hruler.show()
        self.vruler.show()
        self.sw.show()
        self.subwidget.show()
        self.show()
    def adds(self, widget, subwidget):
        widget.width
        widget.height
    def addv(self, widget):
        self.add_with_viewport(widget)
default_config = {
    't': 'scrolled_window',
    'c': [None],
    'a': {
    },
    'on': {},
}
def eval(ev, par):
    config = {}
    config.update(default_config['a'])
    config.update(par['a'])
    w = ScrolledWindow()
    w.show()
    def add(c):
        w.add(c)
        return w
    def addv(c):
        w.addv(c)
        return w
    add = addv
    def remove():
        c = w.get_child()
        if c is not None:
            w.remove(c)
        return w
    def replace(c):
        remove()
        add(c)
    def on(ev, f):
        w.connect(ev, f)
    ons = {}
    ons.update(default_config['on'])
    ons.update(par['on'])
    try:
        for k in ons:
            on(k, ons[k])
    except:
        pass
    c = default_config['c']
    try:
        c = par['c']
    except:
        pass
    if isinstance(c, (list, tuple)) and len(c) == 1:
        c0 = ev(c[0])
        if c0 is not None:
            w.addv(c0['widget'])
    else:
        uti.err(u'cóś za dużo albo za mało dzieci')
    res = {
        'widget': w,
        'on': ons,
        'c': [c0],
        'm': {
            'add': add,
            'remove': remove,
            'replace': replace,
        }
    }
    return res
if __name__ == '__main__':
    pass