#!/usr/bin/env python
# -*- coding: utf-8 -*-

import pygtk
pygtk.require('2.0')
import gtk
import whiteboard as wb
class Senseboard(gtk.EventBox):
    def __init__(self):
        gtk.EventBox.__init__(self)
        self.connect("expose_event", self.expose_event)
        self.connect("size-allocate", self.size_allocate_event)
        self.set_events(self.get_events()
            | gtk.gdk.BUTTON_PRESS_MASK
            | gtk.gdk.BUTTON_RELEASE_MASK
            | gtk.gdk.POINTER_MOTION_MASK
            | gtk.gdk.POINTER_MOTION_HINT_MASK)
        self.connect("motion_notify_event", self.motion_notify_event)
        self.connect("button_press_event", self.button_press_event)
        self.connect("button_release_event", self.button_release_event)
        self.add_events(gtk.gdk.KEY_PRESS_MASK)
        self.add_events(gtk.gdk.KEY_RELEASE_MASK)
        self.connect("key_press_event", self.key_press_event)
        self.connect("key_release_event", self.key_release_event)
        event_box = self
        event_box.show()
        self.board = wb.Whiteboard()
        event_box.add(self.board)
        self.board.show()
        self.show()
        self.node = None
    def size_allocate_event(self, widget, event):
        print 'size allocate event'
        pass
        return False
    def expose_event(self, widget, event):
        print 'expose event'
        pass
        return False
    def button_press_event(self, widget, event):
        print 'button press event'
        return False
    def button_release_event(self, widget, event):
        print 'button release event'
        return False
    def motion_notify_event(self, widget, event):
        print 'motion notify event'
        return False        
    def key_press_event(self, widget, event):
        print 'key press event', event
        return False
    def key_release_event(self, widget, event):
        print 'key release event', event
        return False
def viewport_matrix(viewp, ext):
    x = viewp['x']
    y = viewp['y']
    w = viewp['w']
    h = viewp['h']
    width = ext['w']
    height = ext['h']
    fw, fh = geometry.fit_rectangle(w, h, width, height, keep_small=False)
    scale = float(fw) / float(w)
    trans_x = (width - fw) / 2
    trans_y = (height - fh) / 2
    matrix = cairo.Matrix()
    cairo.Matrix.translate(matrix, trans_x, trans_y)
    cairo.Matrix.scale(matrix, scale, scale)
    res = {
        'matrix': matrix,
        'trans': (trans_x, trans_y),
        'scale': (scale, scale),
        'ext': ext, # w, h
    }
    return res
def viewport_origin_matrix(viewp, ext):
    x = viewp['x']
    y = viewp['y']
    w = viewp['w']
    h = viewp['h']
    width = ext['w']
    height = ext['h']
    vm = viewport_matrix(viewp, ext)
    matrix = vm['matrix']
    cairo.Matrix.translate(matrix, x, y)
    vm['matrix'] = matrix
    return vm
def area_to_vieport_origin_matrix(vinfo, viewport):
    matrix = cairo.Matrix()
    matrix.translate(0, vinfo['ext']['h'])
    matrix.translate(*vinfo['trans'])
    matrix.scale(*vinfo['scale'])
    matrix.scale(1, -1)
    matrix.translate(-viewport['x'], -viewport['y'])
    return matrix
default_config = {
    'a': {
        'bg': ['bytes', [0, 0, 0.5]],
        'filename': None,
    },
    'on': {},
    'm': {}
}
def eval(ev, par):
    a = {}
    try:
        a.update(default_config['a'])
    except:
        pass
    try:
        a.update(par['a'])
    except:
        pass
    w = Senseboard()
    if 'filename' in a:
        w.board.filename = a['filename']
    w.board.myon = {}
    w.myon = {}
    def on(ev, f):
        if ev in ['changed', 'button_release']:
            w.board.myon[ev] = f
        if ev in ['key_press', 'key_release']:
            w.myon[ev] = f
        else:
            w.board.connect(ev, f, w)
    try:
        ons = par['on']
        for k in ons:
            on(k, ons[k])
    except:
        pass
    def read(name):
        w.board.read(name)
        return w
    def set_viewport(v):
        w.board.set_viewport(v)
        return w
    def set_svg(s):
        w.board.set_svg(s)
        return w
    def viewport_origin_matrix(viewp):
        return w.board.viewport_origin_matrix(viewp)
    def viewport_matrix(viewp):
        return w.board.viewport_matrix(viewp)
    def redraw():
        w.board.redraw()
        return w
    def draw():
        w.board.draw()
        return w
    def just_draw():
        w.board.just_draw()
        return w
    w.board.sensor_state = {}
    def on_changed_sensor(par):
        vinfo = viewport_origin_matrix(w.board.viewport)
        matrix = area_to_vieport_origin_matrix(vinfo, w.board.viewport)
        matrix.invert()
        val = {}
        for s in w.board.sensors:
            x, y = matrix.transform_point(s.xc, s.yc)
            val[s.id] = x, y
        if 'changed' in w.board.myon:
            w.board.myon['changed'](val)
    def viewport2ctm(w):
        pass
    def append_sensor(s):
        if s['type'] == 'round':
            par = {}
            par['area'] = w
            if w.board.viewport is None:
                matrix = cairo.Matrix()
            else:
                vinfo = viewport_origin_matrix(w.board.viewport)
                matrix = vinfo['matrix']
            par['ctm'] = cairo.Matrix()
            cen = s['center']
            rad = s['radius']
            if 1:
                matrix = area_to_vieport_origin_matrix(vinfo, w.board.viewport)
                cen = matrix.transform_point(*s['center'])
                rad = matrix.transform_distance(s['radius'], 0)[0]
            par['center'] = cen
            par['radius'] = rad
            par['on'] = {'changed': on_changed_sensor}
            par['id'] = s['id']
            sob = sensor.RoundSensor(par)
            w.board.add_sensor(sob)
    def append_sensors(sl):
        def do_append():
            if isinstance(sl, (list, tuple)):
                for s in sl:
                    append_sensor(s)
            else:
                append_sensor(sl)
            w.board.do_append_sensors = do_nothing
        def do_nothing():
            pass
        w.board.do_append_sensors = do_append
    def clear_sensors():
        w.board.clear_sensors()
    res = {
        'widget': w,
        'on': on,
        'm': {
            'redraw': redraw,
            'draw': draw,
            'just_draw': just_draw,
            'append_sensor': append_sensor,
            'append_sensors': append_sensors,
            'clear_sensors': clear_sensors,
            'set_viewport': set_viewport,
            'set_svg': set_svg,
            'viewport_origin_matrix': viewport_origin_matrix,
            'viewport_matrix': viewport_matrix,
            },
    }
    w.node = res
    w.board.node = res
    return res
if __name__ == "__main__":
    class Statusbar(gtk.Statusbar):
        def __init__(self):
            gtk.Statusbar.__init__(self)
            self.show()
        def change(self, s):
            context_description = u"the only one"
            self.context_id = self.get_context_id(context_description)
            message_id = self.push(self.context_id, s)
            return self
    def main():
        import sensor
        window = gtk.Window(gtk.WINDOW_TOPLEVEL)
        window.set_name("Drawable")
        vbox = gtk.VBox(False, 0)
        window.add(vbox)
        vbox.show()
        window.connect("destroy", lambda w: gtk.main_quit())
        drawing_area = Whiteboard(filename='svg/test-ala-svg-100.svg')
        drawing_area.set_size_request(500, 500)
        drawing_area.show()
        vbox.pack_start(drawing_area, True, True, 0)
        center = 200, 200
        radius = 20
        sensor = sensor.RoundSensor(drawing_area, cairo.Matrix(), center, radius)
        drawing_area.sensors.append(sensor)
        button = gtk.Button("Quit")
        vbox.pack_start(button, False, False, 0)
        button.connect_object("clicked", lambda w: w.destroy(), window)
        button.show()
        status = Statusbar()
        vbox.pack_start(status, False, False, 0)
        status.show()
        drawing_area.status = status
        window.set_position(gtk.WIN_POS_CENTER)
        window.show()
        gtk.main()
        return 0
    main()