#!/usr/bin/env python
# -*- coding: utf-8 -*-

import pygtk
import pango
import gtk
pygtk.require('2.0')
if gtk.pygtk_version < (2,7,0):
    print "PyGtk 2.7.0 or later required for this program"
    raise SystemExit
import black
import keyboard
class TopLevel(gtk.Window):
    def __init__(self):
        gtk.Window.__init__(self, gtk.WINDOW_TOPLEVEL)
        self.myon = {}
    def set_icon(self, fn):
        if fn is not None:
            try:
                self.set_icon_from_file(fn)
            except Exception, e:
                pass
class Presentation(TopLevel):
    def __init__(self):
        TopLevel.__init__(self)
        if isinstance(self.title, basestring):
            self.set_title(self.title)
        else:
            self.set_title(u'')
        self.is_fullscreen = False
        self.slides = []
        self.slide_number = None
        self.slide = None
        self.black = False
        self.black_widget = black.Black()
        self.black_widget.show()
        self.small_jump_size = 13
        self.big_jump_size = 10
        self.start_from_here = 0
        self.add_events(gtk.gdk.KEY_PRESS_MASK)
        self.add_events(gtk.gdk.KEY_RELEASE_MASK)
        self.connect("key_press_event", self.key_press_event)
        self.connect("key_release_event", self.key_release_event)
        self.connect("expose_event", self.expose_eventX)
        self.connect("size-allocate", self.size_allocate_event)
        self.input_type = None
    def set_input_type(self, type):
        self.input_type = type
        if type == 'transparent':
            self.key_process = keyboard.process_transparent
        else:
            pass
    def key_press_event(self, widget, event):
        d = keyboard.event_to_dict(event)
        if 'key_press' in self.myon and self.myon['key_press'] is not None:
            self.myon['key_press'](d)
        if self.input_type == 'presentation':
            if 'node' in dir(self.slides[self.slide_number]):
                node = self.slides[self.slide_number].node
                if 'key_press' in node['m']:
                    node['m']['key_press']({'node': node, 'key': d})
            key_name = gtk.gdk.keyval_name(event.keyval)
            if key_name == 'F5' or key_name == 'F11':
                self.toggle_fullscreen()
            elif key_name == 'Escape':
                self.toggle_fullscreen()
            elif key_name == 'Page_Up':
                self.jump_by(-1)
            elif key_name == 'Page_Down':
                self.jump_by(1)
            elif key_name == 'F8':
                self.jump_by(-self.small_jump_size)
            elif key_name == 'F9':
                self.jump_by(self.small_jump_size)
            elif key_name == 'Home':
                self.first_slide()
            elif key_name == 'End':
                self.last_slide()
            else:
                pass
            done = False
        elif self.input_type is not None:
            r = self.key_process['key_press'](event)
            program = r['program']
            for x in program:
                c, p = x
                if c == 'insert':
                    self.textbuffer.insert_at_cursor(p)
                else:
                    pass
            done = r['done']
        return done
    def key_press_eventA(self, widget, event):
        r = self.key_process['key_press'](event)
        program = r['program']
        for x in program:
            c, p = x
            if c == 'insert':
                self.textbuffer.insert_at_cursor(p)
            else:
                pass
        res = r['done']
        return res
        if key_name == 'F5' or key_name == 'F11':
            self.toggle_fullscreen()
        elif key_name == 'Escape':
            self.toggle_fullscreen()
        elif key_name == 'Page_Up':
            self.jump_by(-1)
        elif key_name == 'Page_Down':
            self.jump_by(1)
        elif key_name == 'F8':
            self.jump_by(-self.small_jump_size)
        elif key_name == 'F9':
            self.jump_by(self.small_jump_size)
        elif key_name == 'Home':
            self.first_slide()
        elif key_name == 'End':
            self.last_slide()
        else:
            pass
        return False
    def key_release_event(self, widget, event):
        if self.input_type == 'presentation':
            d = keyboard.event_to_dict(event)
            if 'node' in dir(self.slides[self.slide_number]):
                node = self.slides[self.slide_number].node
                if 'key_release' in node['m']:
                    node['m']['key_release']({'node': node, 'key': d})
            done = False
        else:
            r = self.key_process['key_release'](event)
            program = r['program']
            for x in program:
                c, p = x
                if c == 'insert':
                    self.textbuffer.insert_at_cursor(p)
                else:
                    pass
            done = r['done']
        return done
    def hereX(self):
        if self.slides:
            self.start_from_here = len(self.slides) - 1
    def front(self):
        self.start_from_here = len(self.slides)
    def back(self):
        self.start_from_here = len(self.slides) - 1
    def toggle_fullscreen(self):
        if self.is_fullscreen:
            self.unfullscreen()
            self.is_fullscreen = False
        else:
            self.fullscreen()
            self.is_fullscreen = True
    def expose_eventX(self, widget, event):
        if 'rescale_image' in dir(self):
            self.rescale_image()
    def size_allocate_event(self, widget, event):
        self.widget_rect = self.get_allocation()
        w = self.widget_rect.width
        h = self.widget_rect.height
        forward = 0
        back = 0
        def prep(i):
            if i < len(self.slides):
                if 'prepare_scaled' in dir(self.slides[i]):
                    self.slides[i].prepare_scaled(w, h)
        if self.slide_number is not None:
            for i in range(self.slide_number - back, self.slide_number + forward + 1):
                prep(i)
    def add_slide(self, widget):
        self.slides.append(widget)
        return self
    def display_slide(self, number=None):
        if not self.slides:
            return
        if number is None:
            number = self.start_from_here
        number = self.adjust_range(number)
        if self.slide is not None:
            self.remove(self.slide)
        self.slide = self.slides[number]
        self.add(self.slide)
        self.slide_number = number
        if 'slide_file' in dir(self):
            fi = self.slide_file
            fh = open(fi, 'w')
            fh.write(str(self.slide_number))
            fh.close()
        if 'on_start' in dir(self.slide):
            self.slide.on_start(self.slide)
        if 'on_stop' in dir(self.slide):
            self.slide.on_stop(self.slide)
        self.widget_rect = self.get_allocation()
        w = self.widget_rect.width
        h = self.widget_rect.height
        return self
    def adjust_range(self, number):
        if number >= len(self.slides):
            number = len(self.slides) - 1
        elif number < 0:
            number = 0
        return number
    def next_slide(self):
        if self.slide_number is not None:
            if self.slide_number == len(self.slides) - 1:
                pass
            else:
                self.display_slide(self.slide_number + 1)
        return self
    def previous_slide(self):
        if self.slide_number is not None:
            if self.slide_number == 0:
                pass
            else:
                self.display_slide(self.slide_number - 1)
        return self
    def first_slide(self):
        self.display_slide(0)
        return self
    def last_slide(self):
        self.display_slide(len(self.slides) - 1)
        return self
    def jump_by(self, step):
        if self.slide_number is not None:
            if step == 0:
                pass
            else:
                self.display_slide(self.slide_number + step)
        return self
    def toggle_black(self):
        if self.black:
            self.remove(self.black_widget)
            self.add(self.slide)
            self.black = False
        else:
            self.remove(self.slide)
            self.add(self.black_widget)
            self.black = True
default_config = {
    'c': None,
    'a': {
        'title': u'',
        'border_width': 0,
        'minw': 200,
        'minh': 200,
        'startw': 800,
        'starth': 600,
        'position': 'center',
        'input_type': 'transparent',
        'icon': None,
    },
}
def eval(ev, par):
    config = {}
    config.update(default_config['a'])
    config.update(par['a'])
    w = Presentation()
    w.set_title(config['title'])
    w.set_border_width(config['border_width'])
    w.set_size_request(config['minw'], config['minh'])
    w.resize(config['startw'], config['starth'])
    if 'input_type' in config:
        w.set_input_type(config['input_type'])
    if config['position'] == 'center':
        w.set_position(gtk.WIN_POS_CENTER)
    elif config['position'] == 'maximize':
        w.maximize()
    else:
        pass
    w.set_icon(config['icon'])
    w.show_all()
    w.present()
    w.myon = {}
    def on(ev, f):
        if ev in ['key_press']:
            w.myon[ev] = f
        else:
            w.connect(ev, f, w)
    def onX(ev, f):
        w.connect(ev, f)
    w.add_events(gtk.gdk.KEY_PRESS_MASK)
    try:
        ons = par['on']
        for k in ons:
            on(k, ons[k])
    except:
        print 'oj, niedobrze...'
        pass
    c = default_config['c']
    try:
        c = par['c']
    except:
        pass
    c = [ev(cc) for cc in c]
    for cc in c:
        if cc is not None:
            w.add_slide(cc['widget'])
    w.display_slide()
    def set_icon(ic):
        w.set_icon(ic)
    res = {
        'widget': w,
        'on': ons,
        'c': c,
        'm': {
            'add': w.add,
            'set_icon': set_icon,
            },
    }
    return res
def run():
    gtk.main()
def quit(*ar):
    gtk.main_quit()