#!/usr/bin/env python
# -*- coding: utf-8 -*-

import editor
import top_level
import hdouble
import vdouble
import scrolled_window
import empty
import viewer
import sensor_area
import whiteboard
import senseboard
import statusbar
import drawing_simple
import label
import vbox
import hbox
import menu
import button
import about
import notebook
eval_fun = {
    'top_level': top_level.eval,
    'hdouble': hdouble.eval,
    'vdouble': vdouble.eval,
    'scrolled_window': scrolled_window.eval,
    'editor': editor.eval,
    'empty': empty.eval,
    'viewer': viewer.eval,
    'sensor_area': sensor_area.eval,
    'whiteboard': whiteboard.eval,
    'senseboard': senseboard.eval,
    'drawing_simple': drawing_simple.eval,
    'statusbar': statusbar.eval,
    'label': label.eval,
    'vbox': vbox.eval,
    'hbox': hbox.eval,
    'menu': menu.eval,
    'button': button.eval,
    'about': about.eval,
    'notebook': notebook.eval,
}
def eval(uio):
    if (uio is None) or ('widget' in uio):
        return uio
    t = uio['t']
    res = eval_fun[t](eval, uio)
    if 't' in uio:
        res['t'] = uio['t']
    if 'id' in uio:
        res['id'] = uio['id']
    return res
def mk_idict(uit):
    idict = {}
    for n in all_nodes(uit):
        if 'id' in n:
            idict[n['id']] = n
    return idict
def iterator(uit):
    if 'c' in uit:
        for c in uit['c']:
            yield iterator(c)
    yield uit
def all_nodes(uit):
    li = []
    li.append(uit)
    if has_subnodes(uit):
        if 'sub' in uit:
            for sub in uit['sub']:
                li.extend(all_nodes(sub))
        else:
            for c in uit['c']:
                li.extend(all_nodes(c))
    return li
def has_subnodes(uit):
    yes = 'sub' in uit and hasattr(uit['sub'], '__iter__')
    yes = yes or 'c' in uit and hasattr(uit['c'], '__iter__')
    return yes
def has_children(uit):
    return 'c' in uit and hasattr(uit['c'], '__iter__')
def repr_uit(uit, indent=u''):
    def kv(k, v):
        s = u''
        s += k + ': '
        s += unicode(v)
        return s
    s = indent
    if 't' in uit:
        s += kv('t', uit['t'])
        s += ' '
    if 'id' in uit:
        s += kv('id', uit['id'])
        s += ' '
    if 'widget' in uit:
        pass
    if 'a' in uit:
        asl = []
        for ak in uit['a']:
            asl.append(kv(ak, uit['a'][ak]))
        astr = indent + '--> ' + ', '.join(asl)
        s += '\n' + astr
    if 'm' in uit:
        msl = [mk for mk in uit['m']]
        mstr = indent + '--> methods: ' + ', '.join(msl)
        s += '\n' + mstr
    if 'on' in uit:
        ostr = indent + '--> on: ' + repr(uit['on'])
        s += '\n' + ostr
    if has_children(uit):
        new_indent = indent + '    '
        subl = [repr_uit(c, indent=new_indent) for c in uit['c']]
        sub = '\n'.join(subl)
        s += '\n' + sub
    return s