#!/usr/bin/env python
# -*- coding: utf-8 -*-

import pygtk
import pango
import gtk
pygtk.require('2.0')
if gtk.pygtk_version < (2,7,0):
    print "PyGtk 2.7.0 or later required for this program"
    raise SystemExit
import os
import subprocess
import cStringIO as stringio
import urllib2
import color
import lib
import uti
import lib
import keyboard
def pdf2png(pdf, png, resol=None, first=None, last=None):
    if resol is None:
        resol = 240
    first_list = ['-dFirstPage=' + str(first)] if first is not None else []
    last_list = ['-dLastPage=' + str(last)] if last is not None else []
    dev_null = open('/dev/null', 'w')
    subprocess.call([
        'gs',
        '-SAFER',
        '-dBATCH',
        '-dNOPAUSE',
        '-sDEVICE=png16m',
        '-r' + str(resol),
        '-dGraphicsAlphaBits=4',
        '-dTextAlphaBits=4',
        '-dMaxStripSize=8192',
        ] + first_list + last_list + [
        '-sOutputFile=' + png,
        pdf,
        'quit.ps',
        ], stdout=dev_null, stderr=dev_null)
class ConfigTeX(object):
    def __init__(self, dir=None):
        if dir is None:
            dir = os.getcwd()
        self.version_dir = dir
        self.texmixer_dir = os.path.join(self.version_dir, 'texmixer')
        self.mixer_dir = os.path.join(self.version_dir, 'mixer')
        self.tex_input_dir = os.path.join(self.version_dir, 'inp')
        self.pdf_dir = os.path.join(self.version_dir, 'pdf')
        self.png_dir = os.path.join(self.version_dir, 'tex_png')
        self.image_dir = os.path.join(self.version_dir, 'images')
        self.err_dir = os.path.join(self.version_dir, 'err')
        self.keyhole_dir = os.path.join(self.version_dir, 'keyhole')
config_object = ConfigTeX(dir=os.getcwd())
class FutureImage(gtk.EventBox):
    def __init__(self):
        gtk.EventBox.__init__(self)
        self.connect("expose_event", self.expose_event)
        self.connect("size-allocate", self.size_allocate_event)
        self.size_allocate_no = 0
        self.last_allocation_width = 0
        self.last_allocation_height = 0
        event_box = self
        self.img = gtk.Image()
        event_box.add(self.img)
        self.pixbuf = None
        self.scaled_w = None
        self.scaled_h = None
        self.filename = None
        self.url = None
        self.add_events(gtk.gdk.KEY_PRESS_MASK)
        self.add_events(gtk.gdk.KEY_RELEASE_MASK)
        self.connect("key_press_event", self.key_press_event)
        self.connect("key_release_event", self.key_release_event)
    def key_press_event(self, widget, event):
        d = keyboard.event_to_dict(event)
        print d.keys()
        if 'key_press' in self.myon and self.myon['key_press'] is not None:
            self.myon['key_press'](d)
        if 0:
            r = self.key_process['key_press'](event)
            program = r['program']
            for x in program:
                c, p = x
                if c == 'insert':
                    self.textbuffer.insert_at_cursor(p)
                else:
                    pass
            res = r['done']
            return res
    def key_release_event(self, widget, event):
        if 0:
            r = self.key_process['key_release'](event)
            program = r['program']
            for x in program:
                c, p = x
                if c == 'insert':
                    self.textbuffer.insert_at_cursor(p)
                else:
                    pass
            res = r['done']
            return res
    def set_color(self, par):
        cob = color.ColorRGB()
        cob.from_tv(par)
        c = cob.to_long()
        self.modify_bg(gtk.STATE_NORMAL, gtk.gdk.Color(*c))
    def expose_event(self, widget, event):
        if self.pixbuf is not None:
            self.rescale_image()
    def size_allocate_event(self, widget, event):
        self.size_allocate_no += 1
        self.widget_rect = self.get_allocation()
        w = self.widget_rect.width
        h = self.widget_rect.height
        if w != self.last_allocation_width or h != self.last_allocation_height:
            self.last_allocation_width, self.last_allocation_height = w, h
            if self.pixbuf is not None:
                sr = self.prepare_scaled(w, h)
                if sr['changed']:
                    self.img.set_from_pixbuf(self.pixbuf_scaled)
                else:
                    pass
        else:
            pass
    def rescale_image(self):
        self.widget_rect = self.get_allocation()
        w = self.widget_rect.width
        h = self.widget_rect.height
        self.prepare_scaled(w, h)
    def prepare(self):
        if self.filename is not None:
            self.from_file(self.filename)
        elif self.url is not None:
            self.from_url(self.url)
        return self
    def unprepare(self):
        self.pixbuf = None
        self.img.clear()
    def unprepare_scaled(self):
        self.img.clear()
    def prepare_scaled(self, w, h):
        if w < 10 or h < 10:
            w = 800
            h = 600
        new_w, new_h = self.fit_size(w, h)
        if False:
            res = {
                'changed': False,
                'w': self.scaled_w,
                'h': self.scaled_h,
            }
        else:
            pass
            self.pixbuf_scaled = self.pixbuf.scale_simple(new_w, new_h,
                gtk.gdk.INTERP_BILINEAR)
            w = self.pixbuf_scaled.get_width()
            h = self.pixbuf_scaled.get_height()
            self.scaled_w = w
            self.scaled_h = h
            res = {
                'changed': True,
                'w': w,
                'h': h
            }
        return res
    def fit_size(self, dw, dh):
        pw, ph = self.pixbuf.get_width(), self.pixbuf.get_height()
        return lib.fit_gen(pw, ph, dw, dh, keep_small=False)
    def pixbuf_from_pdf(self, filename, page=1):
        pdf_filename = filename
        self.pdf_w = 128
        self.pdf_h = 96
        self.max_w, self.max_h = 1280, 960
        self.pdf_filename = filename
        self.page = page
        config = config_object
        self.png_dir = config.png_dir
        pdf_hash = uti.string2hash(pdf_filename)
        png_basename = pdf_hash + '_' + os.path.basename(pdf_filename) + '_' + '%03d.png' % page
        self.png_filename = os.path.join(self.png_dir, png_basename)
        if self.pixbuf is None:
            new_w, new_h = lib.fit_gen(self.pdf_w, self.pdf_h,
                self.max_w, self.max_h, keep_small=False,
                sharp=False)
            resol = 25.4 * new_w / self.pdf_w
            pdf2png(self.pdf_filename, self.png_filename,
                resol=resol, first=self.page, last=self.page)
            self.pixbuf = gtk.gdk.pixbuf_new_from_file(self.png_filename)
        return self.pixbuf
    def from_file(self, filename, page=1):
        r, e = os.path.splitext(filename)
        if e == '.pdf':
            self.pixbuf = self.pixbuf_from_pdf(filename, page)
        else:
            self.pixbuf = gtk.gdk.pixbuf_new_from_file(filename)
        self.filename = filename
        self.rescale_image()
        self.img.set_from_pixbuf(self.pixbuf_scaled)
        return self
    def from_url(self, url):
        self.url = url
        f = urllib2.urlopen(url)
        data = f.read()
        if 0:
            pbl = gtk.gdk.PixbufLoader()
            pbl.write(data)
            pixbuf = pbl.get_pixbuf()
            pbl.close()
            self.pixbuf = pixbuf
        else:
            tmp = 'zzz_very_tmp'
            fw = open(tmp, 'wb')
            fw.write(data)
            fw.close()
            self.from_file(tmp)
        return self
    def read(self, name, page=1):
        self.from_file(name, page)
        if 0:
            try:
                self.from_file(name, page)
            except:
                try:
                    self.from_url(name)
                except:
                    print u'to chyba nie jest url'
                    pass
        return self
    def from_image(self, im):
        file1 = stringio.StringIO()  
        im.save(file1, "ppm")  
        contents = file1.getvalue()  
        file1.close()  
        loader = gtk.gdk.PixbufLoader("pnm")  
        loader.write(contents, len(contents))  
        pixbuf = loader.get_pixbuf()  
        loader.close()  
        self.pixbuf = pixbuf
        self.rescale_image()
        w = self.pixbuf_scaled.get_width()
        h = self.pixbuf_scaled.get_height()
        print self.pixbuf_scaled, w, h
        self.img.set_from_pixbuf(self.pixbuf_scaled)
        return self
class Image(FutureImage):
    def __init__(self):
        FutureImage.__init__(self)
        self.prepare()
default_config = {
    'a': {
        'bg': ['bytes', [0, 0, 0]],
        'size': None,
    },
    'on': {},
}
def eval(ev, par):
    a = {}
    try:
        a.update(default_config['a'])
    except:
        pass
    try:
        a.update(par['a'])
    except:
        pass
    w = Image()
    w.set_color(a['bg'])
    if a['size'] is not None:
        w.set_size_request(a['size']['w'], a['size']['h'])
    if 'img' in a:
        if 'page' in a:
            w.read(a['img'], page=a['page'])
        else:
            w.read(a['img'])
    w.prepare()
    w.show()
    w.img.show()
    w.myon = {}
    def on(ev, f):
        if ev in ['key_press']:
            w.myon[ev] = f
        elif ev in ['changed']:
            w.img.connect(ev, f, w)
        else:
            w.connect(ev, f, w)
    ons = {}
    try:
        ons.update(default_config['on'])
    except:
        pass
    try:
        ons.update(par['on'])
    except:
        pass
    try:
        for k in ons:
            on(k, ons[k])
    except:
        pass
    def read(name):
        w.read(name)
        return w
    def from_image(im):
        w.from_image(im)
        return w
    def unprepare():
        w.unprepare()
        return w
    def set_color(c):
        w.set_color(c)
    def set_size(s):
        if s is not None:
            w.set_size_request(s['w'], s['h'])
            w.queue_draw()
    res = {
        'widget': w,
        'on': ons,
        'm': {
            'read': read,
            'set_value': read,
            'clear': unprepare,
            'from_image': from_image,
            'set_color': set_color,
            'set_size': set_size,
        },
    }
    return res