#!/usr/bin/python
# -*- coding: utf-8 -*-

import os
import pprint
import tempfile
import gtk
import kaliope.ui as ui
import kaliope.top_level as top_level
import kaliope.kaliope_lib as kaliope_lib
import kaliope.kaliope_examples as ke
import kaliope.file_dialog as file_dialog
kl = kaliope_lib
import kaliope.uti as uti
def mk_config():
    config = {}
    config['colors'] = {
        'area_editable': ['bytes', [226, 255, 163]],
        'area_noneditable': ['bytes', [255, 233, 163]],
    }
    return config
config = mk_config()
def mk_ui_functions():
    priv = {
        'pdf_string': None,
        'midi_string': None,
        'reflected_source': None,
        'wdict': None,
        'result_actions': None,
    }
    color_white = ['bytes', [255, 255, 255]]
    color_light =  ['bytes', [255, 255, 150]] 
    color_red = ['bytes', [255, 0, 0]]
    color_orange =  ['bytes', [255, 165, 0]] 
    color_yellow =  ['bytes', [255, 215, 000]] 
    color_blue =  ['bytes', [0, 0, 255]] 
    color_green =  ['bytes', [50, 205, 50]] 
    status_color = {
        'empty': color_light,
        'inconsistent': color_orange,
        'in_progress': color_yellow,
        'consistent': color_green,
        'error': color_red,
    }
    status_text = {
        'empty': u'rezultat niegotowy',
        'inconsistent': u'rezultat niegotowy',
        'in_progress': u'obliczam...',
        'consistent': u'rezultat gotowy',
        'error': u'błąd',
    }
    def set_status(sid, message=None):
        new_text = message if message is not None else status_text[sid]
        wdict['tstatus']['m']['set_value'](u'  ' + new_text)
        wdict['gstatus']['m']['set_color'](status_color[sid])
    def init():
        set_status('empty')
        priv['wdict']['editor']['m']['grab_focus']()
        result_actions_no()
    def result_actions_no():
        priv['wdict']['button_get_pdf']['m']['set_label'](u'plik PDF niegotowy')
        priv['wdict']['button_get_pdf']['m']['set_sensitive'](False)
        priv['wdict']['button_get_midi']['m']['set_label'](u'plik MIDI niegotowy')
        priv['wdict']['button_get_midi']['m']['set_sensitive'](False)
        priv['wdict']['button_get_ascii_braille']['m']['set_label'](u'plik brajlowski ASCII niegotowy')
        priv['wdict']['button_get_ascii_braille']['m']['set_sensitive'](False)
        priv['wdict']['button_get_unicode_braille']['m']['set_label'](u'plik brajlowski Unicode niegotowy')
        priv['wdict']['button_get_unicode_braille']['m']['set_sensitive'](False)
        priv['result_actions'] = False
    def result_actions_yes():
        priv['wdict']['button_get_pdf']['m']['set_label'](u'zapisz plik PDF')
        priv['wdict']['button_get_pdf']['m']['set_sensitive'](True)
        priv['wdict']['button_get_midi']['m']['set_label'](u'zapisz plik MIDI')
        priv['wdict']['button_get_midi']['m']['set_sensitive'](True)
        priv['wdict']['button_get_ascii_braille']['m']['set_label'](u'zapisz plik brajlowski ASCII')
        priv['wdict']['button_get_ascii_braille']['m']['set_sensitive'](True)
        priv['wdict']['button_get_unicode_braille']['m']['set_label'](u'zapisz plik  brajlowski Unicode')
        priv['wdict']['button_get_unicode_braille']['m']['set_sensitive'](True)
        priv['result_actions'] = True
    def editor_to_result(w):
        e_value = priv['wdict']['editor']['m']['get_value']()
        if True:
            set_status(u'in_progress')
            while gtk.events_pending():
                gtk.main_iteration(False)
            r = kaliope_lib.typo_to_braille(e_value)
            if r['ok']:
                new_text = r['value']['brailleu'][0]
                priv['wdict']['result']['m']['set_value'](new_text)
                set_status(u'consistent')
                priv['midi_string'] = r['value']['midi']
                priv['pdf_string'] = r['value']['pdf']
                priv['reflected_source'] = e_value
                result_actions_yes()
            else:
                set_status('error', r['message'])
        else:
            set_status('consistent', u'zapis typograficzny nie uległ zmianie')
    def get_pdfX(w):
        if pdf_string is not None:
            fd = file_dialog.FileDialog()
            r = fd.save_dialog('', [file_dialog.FileFilter(u"pliki .pdf", ["*.pdf"], ["image/pdf"])], 'plik.pdf')
            fn = r['fn']
            try:
                open(fn, 'wb').write(pdf_string)
            except:
                pass
        else:
            pass
    def get_midiX(w):
        if priv['midi_string'] is not None:
            fd = file_dialog.FileDialog()
            r = fd.save_dialog('', [file_dialog.FileFilter(u"pliki .midi", ["*.midi"], [" audio/midi"])], 'plik.midi')
            fn = r['fn']
            try:
                open(fn, 'wb').write(priv['midi_string'])
            except:
                pass
        else:
            pass
    def save_pdf(w):
        if priv['pdf_string'] is not None:
            p = {'title': u'zapisz plik PDF',
                'filters': [
                        {'name': u"pliki PDF", 'patterns': ["*.pdf"], 'mime_types': ["image/pdf"]},
                        {'name': u"wszystkie pliki", 'patterns': ["*.*"]},
                    ],
                'suggested_name': 'plik.pdf',
                'b': priv['pdf_string'],
            }
            r = file_dialog.write_bytes(p)
            if r['ok']:
                pass
            else:
                set_status('error', u'błąd zapisu pliku lub rezygnacja z zapisu')
    def save_midi(w):
        if priv['midi_string'] is not None:
            p = {'title': u'zapisz plik MIDI',
                'filters': [
                        {'name': u"pliki MIDI", 'patterns': ["*.midi"], 'mime_types': ["audio/midi"]},
                        {'name': u"wszystkie pliki", 'patterns': ["*.*"]},
                    ],
                'suggested_name': 'plik.midi',
                'b': priv['midi_string'],
            }
            r = file_dialog.write_bytes(p)
            if r['ok']:
                pass
            else:
                set_status('error', u'błąd zapisu pliku lub rezygnacja z zapisu')
    def save_music_xml(w):
        s = wdict['editor']['m']['get_value']()
        s = s.encode('utf8')
        if True:
            p = {'title': u'zapisz plik MusicXML',
                'filters': [
                        {'name': u"pliki XML", 'patterns': ["*.xml"]},
                        {'name': u"wszystkie pliki", 'patterns': ["*.*"]},
                    ],
                'suggested_name': 'plik.xml',
                'b': s,
            }
            r = file_dialog.write_bytes(p)
            if r['ok']:
                pass
            else:
                set_status('error', u'błąd zapisu pliku lub rezygnacja z zapisu')
    def load_unicode_braille(w):
        fd = file_dialog.FileDialog()
        r = fd.open_dialog(u'otwórz plik w kodowaniu utf-8 Unicode Braille',
            [fd.fi_brailleu])
        if r['ok']:
            fn = r['fn']
            try:
                s = (open(fn, 'r').read()).decode('utf8')
                wdict['editor']['m']['set_value'](s)
                set_status('empty')
                wdict['viewer']['m']['clear']()
                wdict['fstatus']['m']['set_value'](r['fn'])
            except:
                set_status('error', u'błąd otwarcia pliku')
        else:
            pass
    def open_example(i):
        wdict['editor']['m']['set_value'](ke.examples_xml[i]['value'])
        set_status('empty')
        wdict['result']['m']['clear']()
        wdict['fstatus']['m']['set_value'](u'')
    def open_music_xml(w):
        p = {'title': u'otwórz plik MusicXML',
            'filters': [
                    {'name': u"pliki XML", 'patterns': ["*.xml"]},
                    {'name': u"wszystkie pliki", 'patterns': ["*.*"]},
                ],
        }
        r = file_dialog.read_bytes(p)
        if r['ok']:
            b = r['b']
            try:
                s = b.decode('utf8')
                c_ok = True
            except:
                c_ok = False
                s = u''
            if c_ok:
                wdict['editor']['m']['set_value'](s)
                set_status('empty')
                wdict['result']['m']['clear']()
                wdict['fstatus']['m']['set_value'](r['fn'])
            else:
                if False:
                    set_status('error', u'niepoprawne znaki w pliku')
                else:
                    wdict['editor']['m']['set_value'](s)
                    set_status('error', u'niepoprawne znaki w pliku')
                    wdict['result']['m']['clear']()
                    wdict['fstatus']['m']['set_value'](fn)
            result_actions_no()
        else:
            pass
    def save_unicode_braille(w):
        s = wdict['result']['m']['get_value']()
        if True:
            b = s.encode('utf8')
            c_ok = True
        else:
            b = ''
            c_ok = False
        if c_ok:
            p = {'title': u'zapisz plik w kodowaniu Unicode Braille',
                'filters': [
                        {'name': u"pliki Unicode Braille", 'patterns': ["*.ubr"]},
                        {'name': u"wszystkie pliki", 'patterns': ["*.*"]},
                    ],
                'b': b,
            }
            r = file_dialog.write_bytes(p)
            if r['ok']:
                wdict['fstatus']['m']['set_value'](r['fn'])
            else:
                set_status('error', u'błąd zapisu pliku lub rezygnacja z zapisu')
        else:
            set_status('error', u'błąd konwersji pliku do Unicode Braille')
    def save_ascii_braille(w):
        s = wdict['result']['m']['get_value']()
        r = kl.convert('unicode', 'ascii', s)
        if r['ok']:
            b = r['s'].encode('utf8')
            c_ok = True
        else:
            b = ''
            c_ok = False
        if c_ok:
            p = {'title': u'zapisz plik w kodowaniu ASCII Braille',
                'filters': [
                        {'name': u"pliki ASCII Braille", 'patterns': ["*.abr"]},
                        {'name': u"wszystkie pliki", 'patterns': ["*.*"]},
                    ],
                'b': b,
            }
            r = file_dialog.write_bytes(p)
            if r['ok']:
                wdict['fstatus']['m']['set_value'](r['fn'])
            else:
                set_status('error', u'błąd zapisu pliku lub rezygnacja z zapisu')
        else:
            set_status('error', u'błąd konwersji pliku do ASCII Braille')
    def load_ascii_braille(w):
        fd = file_dialog.FileDialog()
        r = fd.open_dialog(u'otwórz plik w kodowaniu utf-8 Unicode Braille',
            [fd.fi_brailleu])
        if r['ok']:
            fn = r['fn']
            try:
                s = (open(fn, 'r').read()).decode('utf8')
                wdict['editor']['m']['set_value'](s)
                set_status('empty')
                wdict['viewer']['m']['clear']()
                wdict['fstatus']['m']['set_value'](r['fn'])
            except:
                set_status('error', u'błąd otwarcia pliku')
        else:
            pass
    def on_changed_editor():
        set_status('inconsistent')
        result_actions_no()
    def on_changed_resultX():
        set_status('inconsistent')
    def quit(*ar):
        top_level.quit()
    def display_about(w):
        about_w = ui.eval(about_window)
        awdict = ui.mk_idict(about_w)
        met = awdict['about']['m']
        met['show']()
        met['run']()
        met['destroy']()
    def set_widgets_dictionary(wd):
        priv['wdict'] = wd
    res = {
        'init': init,
        'set_widgets_dictionary': set_widgets_dictionary,
        'editor_to_result': editor_to_result,
        'on_changed_editor': on_changed_editor,
        'open_music_xml': open_music_xml,
        'open_example': open_example,
        'save_music_xml': save_music_xml,
        'save_unicode_braille': save_unicode_braille,
        'save_ascii_braille': save_ascii_braille,
        'save_midi': save_midi,
        'save_pdf': save_pdf,
        'display_about': display_about,
        'quit': quit,
        'wd': priv['wdict'],
    }
    return res
def mk_ui_structure(fdict):
    def edit(p):
        default = {
        't': 'editor',
        'a': {
            'left_margin': 0,
            'indent': 2,
            'pixels_above_lines': 2,
            'pixels_below_lines': 0,
            'pixels_inside_wrap': -1,
            'text': u'',
            'sensitive': True,
            'editable': True,
            'wrapping': True,
        },
        'on': {},
        }
        return uti.sub_update(default, p)
    def lab(p):
        default = {
            't': 'label',
            'a': {
                'xalign': 0.5,
                'size': {'x': 100, 'y': 33},
            },
            'on': {},
        }
        return uti.sub_update(default, p)
    def editl(p, l):
        la = lab({'a': {'label': l}})
        ed = edit(p)
        vb = {
            't': 'vbox',
            'a': {
            },
            'on': {},
            'c': [['noexp', la], ['exp', ed]],
        }
        return vb
    def editlab(edp, lap):
        la = lab(lap)
        ed = edit(edp)
        vb = {
            't': 'vbox',
            'a': {
            },
            'on': {},
            'c': [['noexp', la], ['exp', ed]],
        }
        return vb
    edc = editlab({
        'id': 'edc',
        'a': {
            'editable': True,
            'input_type': 'transparent',
        },
        'on': {'changed': lambda a, b: fdict['on_changed_edc']()},
    }, {'a': {'label': u'edytor konfiguracji', 'bg_color': config['colors']['area_editable']}})
    def mk_editorX(par):
        if 'text' in par:
            initial_text = par['text']
        else:
            initial_text = ''
        def on_changed_edi(a, b):
            fdict['on_changed_editor']()
        edi = {
            't': 'editor',
            'a': {
                'left_margin': 0,
                'indent': 2,
                'pixels_above_lines': 2,
                'pixels_below_lines': 0,
                'pixels_inside_wrap': -1,
                'text': initial_text,
            },
            'on': {'changed': on_changed_edi},
        }
        return edi
    edi = editlab({
        'id': 'editor',
        'a': {
            'editable': True,
            'input_type': 'transparent',
            'text': u'',
            'sensitive': True,
            'editable': True,
        },
        'on': {'changed': lambda a, b: fdict['on_changed_editor']()},
    }, {'a': {'label': u'edytor pliku MusicXML', 'bg_color': config['colors']['area_editable']}})
    result = editlab({
        'id': 'result',
        'a': {
            'editable': True,
            'input_type': 'transparent',
            'text': u'',
            'sensitive': True,
            'editable': False,
        },
        'on': {'changed': lambda a, b: fdict['on_changed_editor']()},
    }, {'a': {'label': u'wynikowy zapis brajlowski', 'bg_color': config['colors']['area_noneditable']}})
    def mk_image_viewer(par):
        if 'bg' not in par:
            bg = ['bytes', [0, 0, 0]],
        vi = {
            't': 'viewer',
            'a': {
                'img': par['img'],
            },
        }
        if 'page' in par:
            vi['a']['page'] = par['page']
        return vi
    def png(f, dir='tex_png', bg=None):
        return img(f, '.png', dir)
    def jpg(f, dir='pub', bg=None):
        return img(f, '.jpg', dir)
    def pdf(f, page=1, bg=None):
        return img(f, '.pdf', page=page)
    def img(f, ext=None, dir=None, page=None, bg=None):
        r, e = os.path.splitext(f)
        if ext is not None:
            fn = r + ext
        else:
            fn = f
        if dir is not None:
            path = os.path.join(dir, fn)
        else:
            path = fn
        par = {'img': path}
        if page is not None:
            par['page'] = page
        if bg is not None:
            par['bg'] = bg
        return mk_image_viewer(par)
    empty = {
        't': 'empty',
        'a': {
            'color': ['bytes', [20, 20, 20]],
        },
    }
    emp = empty
    def mk_top_level(a, child):
        attr = {
                'title': u'Nutowy Edytor Typograficzny',
                'border_width': 1,
                'minw': 0,
                'minh': 0,
                'startw': 800,
                'starth': 600,
                'position': 'maximize',
            }
        attr.update(a)
        tl = {
            't': 'top_level',
            'a': attr,
            'on': {'destroy': fdict['quit'],
            },
            'c': child,
        } # end top level
        return tl
    if 0:
        def mk_text_viewers(ito):
            fh = open(os.path.join(ito['mixer'], ito['ifilname']), 'r')
            text_mp = fh.read()
            edi_mp = mk_editor({'text': text_mp})
            fh = open(os.path.join(ito['mixer'], ito['dfilname']), 'r')
            text_dat = fh.read()
            edi_dat = mk_editor({'text': text_dat})
            return edi_mp, edi_dat
        edi_trivial_mp, edi_trivial_dat = mk_text_viewers(b_trivial)
        edi_textual_mp, edi_textual_dat = mk_text_viewers(b_textual)
        edi_similar_mp, edi_similar_dat = mk_text_viewers(b_similar)
        edi_smoothbez_mp, edi_smoothbez_dat = mk_text_viewers(b_smoothbez)
    viewer1 = mk_image_viewer({'img': 'cromoterapia_woman.jpg'})
    viewer_ooo = {
        't': 'viewer',
        'a': {
            'img': 'cromoterapia_woman.jpg',
            'bg': ['bytes', [33, 33, 33]],
        },
    }
    def tex(a):
        return pdf(texowe, page=a),
    statusbar = {
        't': 'statusbar',
        'id': 'tstatus',
        'a': {
        },
        'on': {},
    }
    fstatus = {
        't': 'statusbar',
        'id': 'fstatus',
        'a': {
            'has_resize_grip': False,
        },
        'on': {},
    }
    statusbarX = {
        't': 'label',
        'id': 'statusbar',
        'a': {
            'label': u' nic takiego, nic wielkiego',
            'xalign': 0.0,
        },
        'on': {},
    }
    subtitle = {
        't': 'label',
        'id': 'subtitle',
        'a': {
            'label': u' ' + u'zamiana postaci brajlowskiej nut na postać typograficzną',
            'xalign': 0.0,
        },
        'on': {},
    }
    gstatus = {
        't': 'viewer',
        'id': 'gstatus',
        'a': {
            'bg': ['bytes', [10, 210, 210]],
            'size': {'w': 100, 'h': 20},
        },
    }
    xstatus = {
        't': 'viewer',
        'id': 'xstatus',
        'a': {
            'bg': ['bytes', [10, 10, 110]],
            'size': {'w': 100, 'h': 20},
        },
    }
    def mk_statusbar(s):
        return {
        't': 'statusbar',
        'id': s,
        'a': {
        },
        'on': {},
    }
    button_calculate_result = {
        't': 'button',
        'id': 'calculate',
        'a': {
            'label': u'utwórz postać brajlowską',
        },
        'on': {
            'clicked': fdict['editor_to_result'],
        },
    }
    button_quit = {
        't': 'button',
        'id': 'quit',
        'a': {
            'label': u'zakończ program',
        },
        'on': {
            'clicked': quit,
        },
    }
    button_get_pdf = {
        't': 'button',
        'id': 'button_get_pdf',
        'a': {
            'label': u'plik PDF niegotowy',
            'sensitive': False,
        },
        'on': {
            'clicked': fdict['save_pdf'],
        },
    }
    button_get_midi = {
        't': 'button',
        'id': 'button_get_midi',
        'a': {
            'label': u'plik MIDI niegotowy',
            'sensitive': False,
        },
        'on': {
            'clicked': fdict['save_midi'],
        },
    }
    button_get_ascii_braille = {
        't': 'button',
        'id': 'button_get_ascii_braille',
        'a': {
            'label': u'plik braille niegotowy',
            'sensitive': False,
        },
        'on': {
            'clicked': fdict['save_ascii_braille'],
        },
    }
    button_get_unicode_braille = {
        't': 'button',
        'id': 'button_get_unicode_braille',
        'a': {
            'label': u'plik braille niegotowy',
            'sensitive': False,
        },
        'on': {
            'clicked': fdict['save_unicode_braille'],
        },
    }
    toolbar = {
        't': 'hbox',
        'a': {
        },
        'on': {},
        'c': [
            ['exp', button_calculate_result],
            ['exp', button_get_unicode_braille],
            ['exp', button_get_ascii_braille],
            ['exp', button_get_pdf],
            ['exp', button_get_midi],
            ['exp', button_quit],
            ],
    }
    statusarea = {
        't': 'hbox',
        'a': {
        },
        'on': {},
        'c': [['noexp', gstatus], ['exp', statusbar]],
    }
    rest = {
        't': 'vbox',
        'a': {
        },
        'on': {},
        'c': [['exp', result], 'sep', ['noexp', statusarea]]
    }
    hd = {
        't': 'hdouble',
        'a': {
            'position': 600,
            'resize': [False, True],
            'shrink': [True, True],
        },
        'on': {},
        'c': [edi, rest],
    }
    hdX = {
        't': 'vdouble',
        'a': {
            'position': 190,
            'resize': [False, True],
            'shrink': [True, True],
        },
        'on': {},
    }
    submenu_examples = []
    for exi in range(len(ke.examples_xml)):
        nstr = str(exi + 1)
        def mk_opening_example(i):
            return lambda w: fdict['open_example'](i)
        submenu_examples.append([u'otwórz przykład ' + nstr + '. „' + ke.examples_xml[exi]['id'] + '”', mk_opening_example(exi)])
    menu_plik = [
                [u'otwórz plik MusicXML', fdict['open_music_xml']],
                'sep',
                ] + submenu_examples + [
                'sep',
                [u'zapisz plik brajlowski Unicode', fdict['save_unicode_braille']],
                [u'zapisz plik brajlowski ASCII', fdict['save_ascii_braille']],
                [u'zapisz plik PDF', fdict['save_music_xml']],
                [u'zapisz plik MIDI', fdict['save_midi']],
                [u'zapisz plik MusicXML', fdict['save_music_xml']], 
                ]
    menu = {
        't': 'menu',
        'a': {
            'menus': [
                ['plik', menu_plik],
                ['pomoc', [
                [u'O programie', fdict['display_about']],
                ]],
            ],
        },
    }
    main_vb = {
        't': 'vbox',
        'a': {
        },
        'on': {},
        'c': [['noexp', menu], ['noexp', fstatus], ['noexp', toolbar], ['exp', hd]],
    }
    top_child = [main_vb]
    tl = mk_top_level({'title': u'System Kaliope | Program Eurydyka' + u' | Zamiana postaci typograficznej nut na postać brajlowską',
        'icon': 'Kaliope.ico',
        }, top_child)
    return tl
ui_functions = mk_ui_functions()
ui_structure = mk_ui_structure(ui_functions)
tu = ui.eval(ui_structure)
wdict = ui.mk_idict(tu)
ui_functions['set_widgets_dictionary'](wdict)
ui_functions['init']()
about_window = {
    't': 'about',
    'id': 'about',
    'a': {
        'program_name': 'Kaliope Eurydyka',
        'version': '1.0',
        'copyright': None,
        'comments': u'''Program do zamiany postaci typograficznej brajlowskiej nut
na postać brajlowską
Autorzy: Zespół Kaliope
''',
        'website': None,
        'logo': None,
    },
    'on': {
    },
}
top_level.run()