#!/usr/bin/python
# -*- coding: utf-8 -*-

import os
import pprint
import tempfile
import gtk
import kaliope.ui as ui
import kaliope.top_level as top_level
import kaliope.uti as uti
import kaliope.kaliope_lib as kaliope_lib
import kaliope.kaliope_examples as ke
kl = kaliope_lib
import kaliope.kaliope_homergraph_lib as khl
import kaliope.file_dialog as file_dialog
def mk_config():
    config = {}
    config['colors'] = {
        'area_editable': ['bytes', [226, 255, 163]],
        'area_noneditable': ['bytes', [255, 233, 163]],
    }
    return config
config = mk_config()
def mk_ui_functions():
    priv = {
        'pdf_string': None,
        'reflected_source': None,
        'wdict': None,
        'result_actions': None,
    }
    color_white = ['bytes', [255, 255, 255]]
    color_light =  ['bytes', [255, 255, 150]] 
    color_red = ['bytes', [255, 0, 0]]
    color_orange =  ['bytes', [255, 165, 0]] 
    color_yellow =  ['bytes', [255, 215, 000]] 
    color_blue =  ['bytes', [0, 0, 255]] 
    color_green =  ['bytes', [50, 205, 50]] 
    color_light_green =  ['bytes', [180, 205, 138]] 
    status_color = {
        'empty': color_light,
        'in_progress': color_yellow,
        'pdf_ready': color_light_green,
        'pdf_read_in_progress': color_yellow,
        'inconsistent': color_orange,
        'consistent': color_green,
        'error': color_red,
        'ok': color_green,
    }
    status_text = {
        'empty': u'brak pliku PDF do przetworzenia',
        'pdf_read_in_progress': u'wczytuję plik PDF...',
        'pdf_ready': u'plik PDF gotowy do przetwarzania',
        'in_progress': u'obliczam...',
        'inconsistent': u'rezultat niegotowy',
        'consistent': u'rezultat gotowy',
        'error': u'błąd',
        'ok': u'wynik poprawny',
    }
    def set_status(sid, message=None):
        new_text = message if message is not None else status_text[sid]
        wdict['tstatus']['m']['set_value'](u'  ' + new_text)
        wdict['gstatus']['m']['set_color'](status_color[sid])
    cstatus_color = {
        'error': color_red,
        'ok': color_green,
    }
    cstatus_text = {
        'error': u'błąd konfiguracji',
        'ok': u'konfiguracja poprawna',
    }
    def set_config_status(sid, message=None):
        new_text = message if message is not None else cstatus_text[sid]
        wdict['cstatus']['m']['set_value'](u'  ' + new_text)
        wdict['gcstatus']['m']['set_color'](cstatus_color[sid])
    def init():
        clear()
    def clear():
        wdict['fstatus']['m']['set_value'](u'')
        priv['possible'] = {}
        possible_actions([])
        init_editor()
        priv['pdf_string'] = None
        priv['png_string'] = None
        priv['embosser_string'] = None
        wdict['viewer']['m']['clear']()
        clear_braille_area()
        priv['wdict']['editor']['m']['grab_focus']()
        priv['sid'] = None
        set_status('empty')
    def clear_braille_area():
        dres = priv['set_par']({})
        priv['wdict']['braille']['m']['redraw']()
    def possible_actions(l):
        if 'calculate' in l:
            priv['wdict']['calculate']['m']['set_label'](u'utwórz postać brajlowską fragmentu')
            priv['wdict']['calculate']['m']['set_sensitive'](True)
            priv['possible']['calculate'] = True
        else:
            priv['wdict']['calculate']['m']['set_label'](u'postać brajlowska niegotowa')
            priv['wdict']['calculate']['m']['set_sensitive'](False)
            priv['possible']['calculate'] = False
        if 'save' in l:
            priv['wdict']['button_save_embosser_file']['m']['set_label'](u'zapisz plik drukarki Everest')
            priv['wdict']['button_save_embosser_file']['m']['set_sensitive'](True)
            priv['possible']['save'] = True
        else:
            priv['wdict']['button_save_embosser_file']['m']['set_label'](u'plik drukarki Everest niegotowy')
            priv['wdict']['button_save_embosser_file']['m']['set_sensitive'](False)
            priv['possible']['save'] = False
        priv['result_actions'] = False
    def result_actions_no():
        priv['wdict']['button_save_embosser_file']['m']['set_label'](u'plik drukarki Everest niegotowy')
        priv['wdict']['button_save_embosser_file']['m']['set_sensitive'](False)
        priv['result_actions'] = False
    def result_actions_yes():
        priv['wdict']['button_save_embosser_file']['m']['set_label'](u'zapisz plik drukarki Everest')
        priv['wdict']['button_save_embosser_file']['m']['set_sensitive'](True)
        priv['result_actions'] = True
    def editor_to_result(w):
        e_value = priv['wdict']['editor']['m']['get_value']()
        if e_value != priv['reflected_source']:
            set_status(u'in_progress')
            while gtk.events_pending():
                gtk.main_iteration(False)
            r = kaliope_lib.typo_to_braille(e_value)
            if r['ok']:
                new_text = r['value']['brailleu'][0]
                priv['wdict']['result']['m']['set_value'](new_text)
                set_status(u'consistent')
                priv['midi_string'] = r['value']['midi']
                priv['pdf_string'] = r['value']['pdf']
                priv['reflected_source'] = e_value
                result_actions_yes()
            else:
                set_status('error', r['message'])
        else:
            set_status('consistent', u'zapis typograficzny nie uległ zmianie')
    def get_pdfX(w):
        if pdf_string is not None:
            fd = file_dialog.FileDialog()
            r = fd.save_dialog('', [file_dialog.FileFilter(u"pliki .pdf", ["*.pdf"], ["image/pdf"])], 'plik.pdf')
            fn = r['fn']
            try:
                open(fn, 'wb').write(pdf_string)
            except:
                pass
        else:
            pass
    def get_midiX(w):
        if priv['midi_string'] is not None:
            fd = file_dialog.FileDialog()
            r = fd.save_dialog('', [file_dialog.FileFilter(u"pliki .midi", ["*.midi"], [" audio/midi"])], 'plik.midi')
            fn = r['fn']
            try:
                open(fn, 'wb').write(priv['midi_string'])
            except:
                pass
        else:
            pass
    def save_pdf(w):
        if priv['pdf_string'] is not None:
            p = {'title': u'zapisz plik PDF',
                'filters': [
                        {'name': u"pliki PDF", 'patterns': ["*.pdf"], 'mime_types': ["image/pdf"]},
                        {'name': u"wszystkie pliki", 'patterns': ["*.*"]},
                    ],
                'suggested_name': 'plik.pdf',
                'b': priv['pdf_string'],
            }
            r = file_dialog.write_bytes(p)
            if r['ok']:
                pass
            else:
                set_status('error', u'błąd zapisu pliku lub rezygnacja z zapisu')
    def save_midi(w):
        if priv['midi_string'] is not None:
            p = {'title': u'zapisz plik MIDI',
                'filters': [
                        {'name': u"pliki MIDI", 'patterns': ["*.midi"], 'mime_types': ["audio/midi"]},
                        {'name': u"wszystkie pliki", 'patterns': ["*.*"]},
                    ],
                'suggested_name': 'plik.midi',
                'b': priv['midi_string'],
            }
            r = file_dialog.write_bytes(p)
            if r['ok']:
                pass
            else:
                set_status('error', u'błąd zapisu pliku lub rezygnacja z zapisu')
    def save_embosser_file(w):
        if not priv['possible']['save']:
            set_status('error', u'zapis do pliku drukarki Everest nie jest możliwy')
        else:
            bitmap = priv['bitmap']
            s = khl.bitmap_to_embosser(bitmap)
            if True:
                p = {'title': u'zapisz plik drukarki Everest',
                    'filters': [
                            {'name': u"pliki ebr", 'patterns': ["*.ebr"]},
                            {'name': u"wszystkie pliki", 'patterns': ["*.*"]},
                        ],
                    'suggested_name': 'plik.ebr',
                    'b': s,
                }
                r = file_dialog.write_bytes(p)
                if r['ok']:
                    pass
                    set_status('ok', u'plik drukarki Everest poprawnie zapisany')
                else:
                    set_status('error', u'błąd zapisu pliku lub rezygnacja z zapisu')
    def load_unicode_braille(w):
        fd = file_dialog.FileDialog()
        r = fd.open_dialog(u'otwórz plik w kodowaniu utf-8 Unicode Braille',
            [fd.fi_brailleu])
        if r['ok']:
            fn = r['fn']
            try:
                s = (open(fn, 'r').read()).decode('utf8')
                wdict['editor']['m']['set_value'](s)
                set_status('empty')
                wdict['viewer']['m']['clear']()
                wdict['fstatus']['m']['set_value'](r['fn'])
            except:
                set_status('error', u'błąd otwarcia pliku')
        else:
            pass
    def open_example(w, i):
        wdict['editor']['m']['set_value'](ke.xml[i]['value'])
        set_status('empty')
        wdict['result']['m']['clear']()
        wdict['fstatus']['m']['set_value'](u'')
    def open_pdf(w):
        if not priv['config']['ok']:
            set_status('error', u'plik PDF można wczytać tylko przy poprawnej konfiguracji')
        else:
            page = priv['config']['value']['page']
            p = {'title': u'otwórz plik PDF',
                'filters': [
                        {'name': u"pliki PDF", 'patterns': ["*.pdf"]},
                        {'name': u"wszystkie pliki", 'patterns': ["*.*"]},
                    ],
            }
            r = file_dialog.read_bytes(p)
            if r['ok']:
                priv['pdf_string'] = r['b']
                set_status('pdf_read_in_progress')
                while gtk.events_pending():
                    gtk.main_iteration(False)
                q = kl.pdf_to_png(priv['pdf_string'], page)
                if q['ok']:
                    priv['png_string'] = q['value']['png']
                    clear_braille_area()
                    image_string_to_viewer(priv['png_string'])
                    priv['sid'] = q['sid']
                    possible_actions(['calculate'])
                    set_status('pdf_ready')
                else:
                    clear()
                    set_status('error', u'błąd wczytania pliku PDF')
            else:
                pass
    def image_string_to_viewer(image_string):
        if True:
            if 0:
                fool_fn = tempfile.NamedTemporaryFile()
                open(fool_fn, 'wb').write(image_string)
                priv['wdict']['viewer']['m']['set_value'](fool_fn)
            else:
                fool_dir = tempfile.mkdtemp()
                fool_fn = 'image.png'
                fool_path = os.path.join(fool_dir, fool_fn)
                fool_fh = open(fool_path, 'wb')
                fool_fh.write(image_string)
                fool_fh.close()
                priv['wdict']['viewer']['m']['set_value'](fool_path)
        else:
            fh = stringio.StringIO()
            fh.write(image_string)
            im = Image.open(fh)    
            im.verify()
            priv['wdict']['viewer']['m']['from_image'](im)
    def cut(w):
        if not priv['config']['ok']:
            set_status('error', u'tworzenie brajlowskiej postaci wymaga poprawnej konfiguracji')
        else:
            page = priv['config']['value']['page']
            v = priv['config']['value']
            j = {'l' : v['l'], 't': v['t'], 'w': v['w'],'h': v['h']}
            out = {'w': v['wb'],'h': v['hb']}
            p = {}
            if 'sid' in priv and priv['sid'] is not None:
                p['sid'] = priv['sid']
            elif 'pdf_string' in priv and priv['pdf_string'] is not None:
                p['s'] = priv['pdf_string']
            p['cut'] = j
            p['out'] = out
            p['page'] = page
            set_status('in_progress')
            while gtk.events_pending():
                gtk.main_iteration(False)
            r = kl.pdf_to_mono(p)
            priv['bitmap'] = r['value']['json']
            par = r['value']['json']
            par['scale'] = 15
            dres = priv['set_par'](par)
            priv['wdict']['braille']['m']['redraw']()
            set_status('consistent')
            possible_actions(['calculate', 'save'])
    mk_draw_res = khl.mk_draw_braille()
    priv['draw_braille'] = mk_draw_res['draw']
    priv['set_par'] = mk_draw_res['set_par']
    def draw(par):
        cr = par['context']
        widget = par['widget']
        alloc = par['allocation']
        req = par['request']
        r = priv['draw_braille'](cr)
        widget.set_size_request(r['ow'], r['oh'])
    def save_unicode_braille(w):
        s = wdict['result']['m']['get_value']()
        if True:
            b = s.encode('utf8')
            c_ok = True
        else:
            b = ''
            c_ok = False
        if c_ok:
            p = {'title': u'zapisz plik w kodowaniu Unicode Braille',
                'filters': [
                        {'name': u"pliki Unicode Braille", 'patterns': ["*.ubr"]},
                        {'name': u"wszystkie pliki", 'patterns': ["*.*"]},
                    ],
                'b': b,
            }
            r = file_dialog.write_bytes(p)
            if r['ok']:
                wdict['fstatus']['m']['set_value'](r['fn'])
            else:
                set_status('error', u'błąd zapisu pliku lub rezygnacja z zapisu')
        else:
            set_status('error', u'błąd konwersji pliku do Unicode Braille')
    def save_ascii_braille(w):
        s = wdict['result']['m']['get_value']()
        r = kl.convert('unicode', 'ascii', s)
        if r['ok']:
            b = r['s'].encode('utf8')
            c_ok = True
        else:
            b = ''
            c_ok = False
        if c_ok:
            p = {'title': u'zapisz plik w kodowaniu ASCII Braille',
                'filters': [
                        {'name': u"pliki ASCII Braille", 'patterns': ["*.abr"]},
                        {'name': u"wszystkie pliki", 'patterns': ["*.*"]},
                    ],
                'b': b,
            }
            r = file_dialog.write_bytes(p)
            if r['ok']:
                wdict['fstatus']['m']['set_value'](r['fn'])
            else:
                set_status('error', u'błąd zapisu pliku lub rezygnacja z zapisu')
        else:
            set_status('error', u'błąd konwersji pliku do ASCII Braille')
    def load_ascii_braille(w):
        fd = file_dialog.FileDialog()
        r = fd.open_dialog(u'otwórz plik w kodowaniu utf-8 Unicode Braille',
            [fd.fi_brailleu])
        if r['ok']:
            fn = r['fn']
            try:
                s = (open(fn, 'r').read()).decode('utf8')
                wdict['editor']['m']['set_value'](s)
                set_status('empty')
                wdict['viewer']['m']['clear']()
                wdict['fstatus']['m']['set_value'](r['fn'])
            except:
                set_status('error', u'błąd otwarcia pliku')
        else:
            pass
    def init_editor():
        wdict['editor']['m']['set_value'](u'''
strona = 1
górny margines = 45 %
lewy margines = 45 %
rozmiar poziomy = 6 mm
rozmiar pionowy = 10 mm
liczba punktów poziomo = 60
liczba punktów pionowo = 100
''')
    def on_changed_editor():
        priv['config'] = read_and_validate_config()
        set_config_status('ok' if priv['config']['ok'] else 'error')
    def read_and_validate_config():
        j = khl.string_to_json(wdict['editor']['m']['get_value']())
        v = {}
        try:
            v['page'] = j[u'strona']
            v['l'] = j[u'lewy margines']
            v['t'] = j[u'górny margines']
            v['w'] = j[u'rozmiar poziomy']
            v['h'] = j[u'rozmiar pionowy']
            v['wb'] = j[u'liczba punktów poziomo']
            v['hb'] = j[u'liczba punktów pionowo']
            ok = True
        except:
            ok = False
        if ok:
            try:
                assert isinstance(v['page'], int) and 1 <= v['page'] <= 500
                validate_dimen(v['l'])
                validate_dimen(v['t'])
                validate_dimen(v['w'])
                validate_dimen(v['h'])
                validate_number(v['wb'], 1, 64)
                validate_number(v['hb'], 1, 100)
            except:
                ok = False
        res = {'ok': ok, 'value': v}
        return res
    def validate_dimen(j):
        assert isinstance(j, (list, tuple))
        assert len(j) == 2
        assert isinstance(j[0], (int, float))
        assert isinstance(j[1], basestring)
        assert j[1] in ['mm', 'cm', 'pt', 'bp', '%']
    def validate_number(j, min, max):
        assert isinstance(j, int)
        assert min <= j <= max
    def quit(*qr):
        top_level.quit()
    def display_about(w):
        about_w = ui.eval(about_window)
        awdict = ui.mk_idict(about_w)
        met = awdict['about']['m']
        met['show']()
        met['run']()
        met['destroy']()
    def set_widgets_dictionary(wd):
        priv['wdict'] = wd
    res = {
        'init': init,
        'set_widgets_dictionary': set_widgets_dictionary,
        'editor_to_result': editor_to_result,
        'on_changed_editor': on_changed_editor,
        'open_pdf': open_pdf,
        'cut': cut,
        'draw': draw,
        'open_example': open_example,
        'save_embosser_file': save_embosser_file,
        'display_about': display_about,
        'quit': quit,
        'wd': priv['wdict'],
    }
    return res
ui_functions = mk_ui_functions()
def mk_ui_structure(fdict):
    def lab(p):
        default = {
            't': 'label',
            'a': {
                'xalign': 0.5,
                'size': {'x': 100, 'y': 33},
            },
            'on': {},
        }
        return uti.sub_update(default, p)
    def widgetlab(w, lap):
        la = lab(lap)
        vb = {
            't': 'vbox',
            'a': {
            },
            'on': {},
            'c': [['noexp', la], ['exp', w]],
        }
        return vb
    viewerlab = widgetlab
    def mk_image_viewer(par):
        if 'bg' not in par:
            bg = ['bytes', [245, 245, 240]]
        vi = {
            't': 'viewer',
            'id': 'viewer',
            'a': {
                'img': par['img'],
            },
        }
        if 'page' in par:
            vi['a']['page'] = par['page']
        return vi
    def png(f, dir='tex_png', bg=None):
        return img(f, '.png', dir)
    def jpg(f, dir='pub', bg=None):
        return img(f, '.jpg', dir)
    def pdf(f, page=1, bg=None):
        return img(f, '.pdf', page=page)
    def img(f, ext=None, dir=None, page=None, bg=None):
        r, e = os.path.splitext(f)
        if ext is not None:
            fn = r + ext
        else:
            fn = f
        if dir is not None:
            path = os.path.join(dir, fn)
        else:
            path = fn
        par = {'img': path}
        if page is not None:
            par['page'] = page
        if bg is not None:
            par['bg'] = bg
        return mk_image_viewer(par)
    def png2(p):
        default = {'dir': 'tex_png', 'bg': None, 'ext': '.png'}
        a = {}
        a.update(default)
        a.update(p)
        return img2(a)
    def jpg2(p):
        default = {'dir': 'pub', 'bg': None, 'ext': '.jpg'}
        a = {}
        a.update(default)
        a.update(p)
        return img2(a)
    def pdf2(p):
        default = {'page': 1, 'ext': '.pdf'}
        a = {}
        a.update(default)
        a.update(p)
        return img2(a)
    def img2(p):
        default = {'ext': None, 'dir': None, 'page': None, 'bg': None}
        a = {}
        a.update(default)
        a.update(p)
        f = a['fn']
        ext = a['ext']
        dir = a['dir']
        page = a['page']
        bg = a['bg']
        r, e = os.path.splitext(f)
        if ext is not None:
            fn = r + ext
        else:
            fn = f
        if dir is not None:
            path = os.path.join(dir, fn)
        else:
            path = fn
        par = {'img': path}
        if page is not None:
            par['page'] = page
        if bg is not None:
            par['bg'] = bg
        return mk_image_viewer(par)
    par = {
        'fn': 'theslides.pdf', 'page': 2, 'dir': 'texmixer',
        'bg': ['bytes', [255, 255, 255]],
        }
    par = {}
    vp = {
        't': 'viewer',
        'id': 'viewer',
        'a': {
            'bg': ['bytes', [210, 210, 210]],
        },
    }
    pdf_viewer = viewerlab(vp,
        {'a': {'label': u'strona pliku PDF', 'bg_color': config['colors']['area_noneditable']}})
    dw_par = {        
        'scale': 25,
        'w': 9,
        'h': 9,
        'bitmap': [
            [1, 1, 1, 0, 1, 1, 0, 1, 1, ],
            [1, 1, 1, 1, 0, 1, 1, 0, 1, ],
            [1, 1, 0, 1, 1, 0, 1, 1, 0, ],
            [0, 1, 1, 0, 1, 1, 0, 1, 1, ],
            [1, 0, 1, 1, 0, 1, 1, 0, 1, ],
            [1, 1, 0, 1, 1, 0, 1, 1, 0, ],
            [0, 1, 1, 0, 1, 1, 0, 1, 1, ],
            [1, 0, 1, 1, 0, 1, 1, 0, 1, ],
            [1, 1, 0, 1, 1, 0, 1, 1, 0, ],
        ],
    }
    dw_par = {
        'w': 0,
        'h': 0,
        'bitmap': [],
    }
    def mydraw(par):
        cr = par['context']
        widget = par['widget']
        alloc = par['allocation']
        req = par['request']
        draw_braille(cr)
        widget.set_size_request(draw_w, draw_h)
    drawing = {
        't': 'drawing_simple',
        'id': 'braille',
        'a': {},
        'on': {'draw': ui_functions['draw']},
    }
    scrolled_drawing_main = {
        't': 'scrolled_window',
        'a': {},
        'c': [drawing],
        'on': {},
    }
    scrolled_drawing = widgetlab(scrolled_drawing_main,
        {'a': {'label': u'brajlowska postać fragmentu', 'bg_color': config['colors']['area_noneditable']}})
    empty = {
        't': 'empty',
        'a': {
            'color': ['bytes', [20, 20, 20]],
        },
    }
    emp = empty
    def mk_top_level(a, child):
        attr = {
                'title': u'Nutowy Edytor Typograficzny',
                'border_width': 1,
                'minw': 0,
                'minh': 0,
                'startw': 800,
                'starth': 600,
                'position': 'maximize',
            }
        attr.update(a)
        tl = {
            't': 'top_level',
            'a': attr,
            'on': {'destroy': fdict['quit'],
            },
            'c': child,
        } # end top level
        return tl
    if 0:
        def mk_text_viewers(ito):
            fh = open(os.path.join(ito['mixer'], ito['ifilname']), 'r')
            text_mp = fh.read()
            edi_mp = mk_editor({'text': text_mp})
            fh = open(os.path.join(ito['mixer'], ito['dfilname']), 'r')
            text_dat = fh.read()
            edi_dat = mk_editor({'text': text_dat})
            return edi_mp, edi_dat
        edi_trivial_mp, edi_trivial_dat = mk_text_viewers(b_trivial)
        edi_textual_mp, edi_textual_dat = mk_text_viewers(b_textual)
        edi_similar_mp, edi_similar_dat = mk_text_viewers(b_similar)
        edi_smoothbez_mp, edi_smoothbez_dat = mk_text_viewers(b_smoothbez)
    viewer1 = mk_image_viewer({'img': 'cromoterapia_woman.jpg'})
    viewer_ooo = {
        't': 'viewer',
        'a': {
            'img': 'cromoterapia_woman.jpg',
            'bg': ['bytes', [33, 33, 33]],
        },
    }
    def tex(a):
        return pdf(texowe, page=a),
    def edit(p):
        default = {
        't': 'editor',
        'a': {
            'left_margin': 0,
            'indent': 2,
            'pixels_above_lines': 2,
            'pixels_below_lines': 0,
            'pixels_inside_wrap': -1,
            'text': u'',
            'sensitive': True,
            'editable': True,
            'wrapping': True,
        },
        'on': {},
        }
        return uti.sub_update(default, p)
    def lab(p):
        default = {
            't': 'label',
            'a': {
                'xalign': 0.5,
                'size': {'x': 100, 'y': 33},
            },
            'on': {},
        }
        return uti.sub_update(default, p)
    def editlab(edp, lap):
        la = lab(lap)
        ed = edit(edp)
        vb = {
            't': 'vbox',
            'a': {
            },
            'on': {},
            'c': [['noexp', la], ['exp', ed]],
        }
        return vb
    def editlabstat(edp, lap, st):
        la = lab(lap)
        ed = edit(edp)
        vb = {
            't': 'vbox',
            'a': {
            },
            'on': {},
            'c': [['noexp', la], ['exp', ed], ['noexp', st]],
        }
        return vb
    cstatus = {
        't': 'statusbar',
        'id': 'cstatus',
        'a': {
            'has_resize_grip': False,
        },
        'on': {},
    }
    gcstatus = {
        't': 'viewer',
        'id': 'gcstatus',
        'a': {
            'bg': ['bytes', [210, 210, 210]],
            'size': {'w': 100, 'h': 20},
        },
    }
    cstatusarea = {
        't': 'hbox',
        'a': {
        },
        'on': {},
        'c': [['noexp', gcstatus], ['exp', cstatus]],
    }
    edi = editlabstat({
        'id': 'editor',
        'a': {
            'input_type': 'transparent',
            'left_margin': 0,
            'indent': 2,
            'pixels_above_lines': 2,
            'pixels_below_lines': 0,
            'pixels_inside_wrap': -1,
            'text': u'',
            'sensitive': True,
            'editable': True,
        },
        'on': {'changed': lambda a, b: fdict['on_changed_editor']()},
    },
    {'a': {'label': u'edytor konfiguracji', 'bg_color': config['colors']['area_editable']}},
    cstatusarea,
    )
    if 0:
        def lab(p):
            default = {
                't': 'label',
                'a': {
                    'xalign': 0.5,
                    'size': {'x': 100, 'y': 33},
                    'bg_color': ['bytes', [100, 200, 50]],
                },
                'on': {},
            }
            return uti.sub_update(default, p)
    def whitel(p, l):
        la = lab({'a': {'label': l}})
        ed = edit(p)
        vb = {
            't': 'vbox',
            'a': {
            },
            'on': {},
            'c': [['noexp', la], ['exp', ed]],
        }
        return vb
    statusbar = {
        't': 'statusbar',
        'id': 'tstatus',
        'a': {
        },
        'on': {},
    }
    fstatus = {
        't': 'statusbar',
        'id': 'fstatus',
        'a': {
            'has_resize_grip': False,
        },
        'on': {},
    }
    statusbarX = {
        't': 'label',
        'id': 'statusbar',
        'a': {
            'label': u' nic takiego, nic wielkiego',
            'xalign': 0.0,
        },
        'on': {},
    }
    subtitle = {
        't': 'label',
        'id': 'subtitle',
        'a': {
            'label': u' ' + u'zamiana postaci brajlowskiej nut na postać typograficzną',
            'xalign': 0.0,
        },
        'on': {},
    }
    gstatus = {
        't': 'viewer',
        'id': 'gstatus',
        'a': {
            'bg': ['bytes', [10, 210, 210]],
            'size': {'w': 100, 'h': 20},
        },
    }
    xstatus = {
        't': 'viewer',
        'id': 'xstatus',
        'a': {
            'bg': ['bytes', [10, 10, 110]],
            'size': {'w': 100, 'h': 20},
        },
    }
    def mk_statusbar(s):
        return {
        't': 'statusbar',
        'id': s,
        'a': {
        },
        'on': {},
    }
    button_open_pdf = {
        't': 'button',
        'id': 'button_open_pdf',
        'a': {
            'label': u'otwórz stronę pliku PDF',
        },
        'on': {
            'clicked': fdict['open_pdf'],
        },
    }
    button_calculate_result = {
        't': 'button',
        'id': 'calculate',
        'a': {
            'label': u'utwórz postać brajlowską fragmentu',
        },
        'on': {
            'clicked': fdict['cut'],
        },
    }
    button_save_embosser_file = {
        't': 'button',
        'id': 'button_save_embosser_file',
        'a': {
            'label': u'plik drukarki Everest niegotowy',
            'sensitive': False,
        },
        'on': {
            'clicked': fdict['save_embosser_file'],
        },
    }
    button_quit = {
        't': 'button',
        'id': 'quit',
        'a': {
            'label': u'zakończ program',
        },
        'on': {
            'clicked': quit,
        },
    }
    if 0:
        button_get_ascii_braille = {
            't': 'button',
            'id': 'button_get_ascii_braille',
            'a': {
                'label': u'plik braille niegotowy',
                'sensitive': False,
            },
            'on': {
                'clicked': fdict['save_ascii_braille'],
            },
        }
        button_get_unicode_braille = {
            't': 'button',
            'id': 'button_get_unicode_braille',
            'a': {
                'label': u'plik braille niegotowy',
                'sensitive': False,
            },
            'on': {
                'clicked': fdict['save_unicode_braille'],
            },
        }
    toolbar = {
        't': 'hbox',
        'a': {
        },
        'on': {},
        'c': [
            ['exp', button_open_pdf],
            ['exp', button_calculate_result],
            ['exp', button_save_embosser_file],
            ['exp', button_quit],
            ],
    }
    statusarea = {
        't': 'hbox',
        'a': {
        },
        'on': {},
        'c': [['noexp', gstatus], ['exp', statusbar]],
    }
    rest = {
        't': 'vbox',
        'a': {
        },
        'on': {},
        'c': [['exp', scrolled_drawing], 'sep', ['noexp', statusarea]]
    }
    hd2 = {
        't': 'hdouble',
        'a': {
            'position': 600,
            'resize': [False, True],
            'shrink': [True, True],
        },
        'on': {},
        'c': [pdf_viewer, rest],
    }
    hd1 = {
        't': 'hdouble',
        'a': {
            'position': 300,
            'resize': [False, True],
            'shrink': [True, True],
        },
        'on': {},
        'c': [edi, hd2],
    }
    menu = {
        't': 'menu',
        'a': {
            'menus': [
                ['plik', [
                [u'otwórz stronę pliku PDF', fdict['open_pdf']],
                'sep',
                [u'zapisz plik drukarki Everest', fdict['save_embosser_file']],
                ]],
                ['pomoc', [
                [u'O programie', fdict['display_about']],
                ]],
            ],
        },
    }
    main_vb = {
        't': 'vbox',
        'a': {
        },
        'on': {},
        'c': [['noexp', menu], ['noexp', fstatus], ['noexp', toolbar], ['exp', hd1]],
    }
    top_child = [main_vb]
    tl = mk_top_level({'title': u'System Kaliope | Program HomerGraph' + u' | Zamiana fragmentu strony pdf na postać brajlowską',
        'icon': 'Kaliope.ico',
        }, top_child)
    return tl
ui_structure = mk_ui_structure(ui_functions)
tu = ui.eval(ui_structure)
wdict = ui.mk_idict(tu)
ui_functions['set_widgets_dictionary'](wdict)
ui_functions['init']()
about_window = {
    't': 'about',
    'id': 'about',
    'a': {
        'program_name': 'Kaliope HomerGraph',
        'version': '1.0',
        'copyright': None,
        'comments': u'''Program do zamiany fragmentu strony pdf na postać brajlowską.
Autorzy: Zespół Kaliope
''',
        'website': None,
        'logo': None,
    },
    'on': {
    },
}
top_level.run()