#!/usr/bin/python
# -*- coding: utf-8 -*-

import os
import pprint
import cStringIO as stringio
import tempfile
import gtk
import kaliope.ui as ui
import kaliope.top_level as top_level
import kaliope.uti as uti
import kaliope.kaliope_lib as kaliope_lib
kl = kaliope_lib
import kaliope.kaliope_examples as ke
import kaliope.file_dialog as file_dialog
def mk_config():
    config = {}
    config['colors'] = {
        'area_editable': ['bytes', [226, 255, 163]],
        'area_noneditable': ['bytes', [255, 233, 163]],
    }
    return config
config = mk_config()
def mk_ui_functions():
    priv = {
        'pdf_string': None,
        'midi_string': None,
        'reflected_source': None,
        'wdict': None,
    }
    color_white = ['bytes', [255, 255, 255]]
    color_red = ['bytes', [255, 0, 0]]
    color_orange =  ['bytes', [255, 165, 0]] 
    color_yellow =  ['bytes', [255, 215, 000]] 
    color_blue =  ['bytes', [0, 0, 255]] 
    color_green =  ['bytes', [50, 205, 50]] 
    status_color = {
        'empty': color_white,
        'inconsistent': color_orange,
        'in_progress': color_yellow,
        'consistent': color_green,
        'error': color_red,
    }
    status_text = {
        'empty': u'rezultat niegotowy',
        'inconsistent': u'rezultat niegotowy',
        'in_progress': u'obliczam...',
        'consistent': u'rezultat gotowy',
        'error': u'błąd',
    }
    def set_status(sid, message=None):
        new_text = message if message is not None else status_text[sid]
        try:
            wdict['tstatus']['m']['set_value'](u'  ' + new_text)
        except KeyError:
            pass
        try:
            wdict['gstatus']['m']['set_color'](status_color[sid])
        except KeyError:
            pass
    def init():
        set_status('empty')
        priv['wdict']['editor']['m']['grab_focus']()
    def hyphenate_simple(w):
        e_value = priv['wdict']['editor']['m']['get_value']()
        set_status(u'in_progress')
        tokens = kl.hyphenate_words(kl.split_text(e_value), algorithm=None)
        new_text = ''.join([v for t, v in tokens])
        priv['wdict']['result']['m']['set_value'](new_text)
        set_status(u'consistent')
    def open_example(w, i):
        wdict['editor']['m']['set_value'](ke.brailleu[i]['value'])
        set_status('empty')
        wdict['viewer']['m']['clear']()
        wdict['fstatus']['m']['set_value'](u'')
    def on_changed_editor():
        hyphenate_simple(None)
    def on_changed_result():
        set_status('inconsistent')
    def display_about(w):
        about_w = ui.eval(about_window)
        awdict = ui.mk_idict(about_w)
        met = awdict['about']['m']
        met['show']()
        met['run']()
        met['destroy']()
    def quit(*ar):
        top_level.quit()
    def set_widgets_dictionary(wd):
        priv['wdict'] = wd
    res = {
        'init': init,
        'set_widgets_dictionary': set_widgets_dictionary,
        'hyphenate_simple': hyphenate_simple,
        'on_changed_editor': on_changed_editor,
        'on_changed_result': on_changed_result,
        'display_about': display_about,
        'quit': quit,
        'wd': priv['wdict'],
    }
    return res
def mk_ui_structure(fdict):
    def mk_image_viewer(par):
        if 'bg' not in par:
            bg = ['bytes', [0, 0, 0]],
        vi = {
            't': 'viewer',
            'a': {
                'img': par['img'],
            },
        }
        if 'page' in par:
            vi['a']['page'] = par['page']
        return vi
    def png(f, dir='tex_png', bg=None):
        return img(f, '.png', dir)
    def jpg(f, dir='pub', bg=None):
        return img(f, '.jpg', dir)
    def pdf(f, page=1, bg=None):
        return img(f, '.pdf', page=page)
    def img(f, ext=None, dir=None, page=None, bg=None):
        r, e = os.path.splitext(f)
        if ext is not None:
            fn = r + ext
        else:
            fn = f
        if dir is not None:
            path = os.path.join(dir, fn)
        else:
            path = fn
        par = {'img': path}
        if page is not None:
            par['page'] = page
        if bg is not None:
            par['bg'] = bg
        return mk_image_viewer(par)
    empty = {
        't': 'empty',
        'a': {
            'color': ['bytes', [20, 20, 20]],
        },
    }
    emp = empty
    def mk_top_level(a, child):
        attr = {
                'title': u'Nutowy Edytor Typograficzny',
                'border_width': 1,
                'minw': 0,
                'minh': 0,
                'startw': 800,
                'starth': 600,
                'position': 'center',
            }
        attr.update(a)
        tl = {
            't': 'top_level',
            'a': attr,
            'on': {'destroy': fdict['quit'],
            },
            'c': child,
        } # end top level
        return tl
    if 0:
        def mk_text_viewers(ito):
            fh = open(os.path.join(ito['mixer'], ito['ifilname']), 'r')
            text_mp = fh.read()
            edi_mp = mk_editor({'text': text_mp})
            fh = open(os.path.join(ito['mixer'], ito['dfilname']), 'r')
            text_dat = fh.read()
            edi_dat = mk_editor({'text': text_dat})
            return edi_mp, edi_dat
        edi_trivial_mp, edi_trivial_dat = mk_text_viewers(b_trivial)
        edi_textual_mp, edi_textual_dat = mk_text_viewers(b_textual)
        edi_similar_mp, edi_similar_dat = mk_text_viewers(b_similar)
        edi_smoothbez_mp, edi_smoothbez_dat = mk_text_viewers(b_smoothbez)
    viewer1 = mk_image_viewer({'img': 'cromoterapia_woman.jpg'})
    viewer_ooo = {
        't': 'viewer',
        'a': {
            'img': 'cromoterapia_woman.jpg',
            'bg': ['bytes', [33, 33, 33]],
        },
    }
    def tex(a):
        return pdf(texowe, page=a),
    vi = {
        't': 'viewer',
        'id': 'viewer',
        'a': {
            'bg': ['bytes', [210, 210, 210]],
        },
    }
    def edit(p):
        default = {
        't': 'editor',
        'a': {
            'left_margin': 0,
            'indent': 2,
            'pixels_above_lines': 2,
            'pixels_below_lines': 0,
            'pixels_inside_wrap': -1,
            'text': u'',
            'sensitive': True,
            'editable': True,
        },
        'on': {},
        }
        return uti.sub_update(default, p)
    def lab(p):
        default = {
            't': 'label',
            'a': {
                'xalign': 0.5,
                'size': {'x': 100, 'y': 33},
            },
            'on': {},
        }
        return uti.sub_update(default, p)
    def editl(p, l):
        la = lab({'a': {'label': l}})
        ed = edit(p)
        vb = {
            't': 'vbox',
            'a': {
            },
            'on': {},
            'c': [['noexp', la], ['exp', ed]],
        }
        return vb
    def editlab(edp, lap):
        la = lab(lap)
        ed = edit(edp)
        vb = {
            't': 'vbox',
            'a': {
            },
            'on': {},
            'c': [['noexp', la], ['exp', ed]],
        }
        return vb
    edi = editlab({
        'id': 'editor',
        'a': {
            'editable': True,
            'wrapping': True,
        },
        'on': {'changed': lambda a, b: fdict['on_changed_editor']()},
    }, {'a': {'label': u'wyrazy do podziału na sylaby', 'bg_color': config['colors']['area_editable']}})
    result = editlab({
        'id': 'result',
        'a': {
            'sensitive': True,
            'editable': False,
            'wrapping': True,
        },
        'on': {},
    }, {'a': {'label': u'wyrazy podzielone na sylaby', 'bg_color': config['colors']['area_noneditable']}})
    if 0:
        edb = editl({
            'id': 'edb',
            'a': {
                'editable': True,
                'input_type': 'braille',
            },
            'on': {'changed': lambda a, b: fdict['on_changed_edb']()},
        }, u'edytor brajlowski')
        ret = editl({
            'id': 'ret',
            'a': {
                'editable': False,
            },
        }, u'skrócony zapis tekstowy')
        reb = editl({
            'id': 'reb',
            'a': {
                'editable': False,
            },
        }, u'skrócony zapis brajlowski')
        def mk_editor(par):
            if 'text' in par:
                initial_text = par['text']
            else:
                initial_text = ''
            def on_changed_edi(a, b):
                fdict['on_changed_editor']()
            edi = {
                't': 'editor',
                'a': {
                    'left_margin': 0,
                    'indent': 2,
                    'pixels_above_lines': 2,
                    'pixels_below_lines': 0,
                    'pixels_inside_wrap': -1,
                    'text': initial_text,
                },
                'on': {'changed': on_changed_edi},
            }
            return edi
    edi_par = {'text': u''}
    edi_par = {'text': u'''jajko
konstantynopolitańczykowianeczka
pszczółka
bezach
bezami
bynajmniej
gdzieniegdzie
inaczej
nadal
nigdy
nigdzie
niechże
niechby
owszem
półach
półami
półek
podówczas
przynajmniej
skądinąd
trójach
trójami
trójek
bezchmurnie
ćwierćinteligent
ćwierćwiecze
ćwierćlitrówka
drogowskaz
kilkusetosobowy
luftwaffe
mógłbym
niechby
niechże
niecka
niecce
nierozerwalny
niesubordynacja
nieuwzględniony
obezwładnić
ogniotrwały
poczt
poczet
podepchnąć
podetkać
podwiązka
poderwać
porozmawiać
postkolonialny
półmrok
prawzór
przeschnąć
retransmisja
Roentgen
Rostock
Rostocku
rotooffsetowy
rozdmuchiwać
roztrwanianie
rozwlec
samorozgrzeszenie
samowzbudzający
satysfakcja
skądżeś
sobowtór
sportowiec
stusześćdziesięcioosobowy
subotnik
superzbiornikowiec
synoptycznie
szefmonter
szezlong
śródrdzeniowy
ugośćcie
współwłasność
wykrztusić
wyodrębnić
wyschnąć
zadysponować
zaniedbać
zaobrączkować
zapomnę
zaschnąć
zdezaktualizować
zdezintegrować
zmartwychwstać
zniósłby
'''}
    def on_changed_res(a, b):
        fdict['on_changed_result']()
    resultX = {
        't': 'editor',
        'id': 'result',
        'a': {
            'left_margin': 0,
            'indent': 2,
            'pixels_above_lines': 2,
            'pixels_below_lines': 0,
            'pixels_inside_wrap': -1,
            'text': u'',
            'sensitive': True,
            'editable': False,
        },
        'on': {'changed': on_changed_res},
    }
    statusbar = {
        't': 'statusbar',
        'id': 'tstatus',
        'a': {
        },
        'on': {},
    }
    fstatus = {
        't': 'statusbar',
        'id': 'fstatus',
        'a': {
            'has_resize_grip': False,
        },
        'on': {},
    }
    statusbarX = {
        't': 'label',
        'id': 'statusbar',
        'a': {
            'label': u' nic takiego, nic wielkiego',
            'xalign': 0.0,
        },
        'on': {},
    }
    subtitle = {
        't': 'label',
        'id': 'subtitle',
        'a': {
            'label': u' ' + u'zamiana postaci brajlowskiej nut na postać typograficzną',
            'xalign': 0.0,
        },
        'on': {},
    }
    gstatus = {
        't': 'viewer',
        'id': 'gstatus',
        'a': {
            'bg': ['bytes', [10, 210, 210]],
            'size': {'w': 100, 'h': 20},
        },
    }
    xstatus = {
        't': 'viewer',
        'id': 'xstatus',
        'a': {
            'bg': ['bytes', [10, 10, 110]],
            'size': {'w': 100, 'h': 20},
        },
    }
    def mk_statusbar(s):
        return {
        't': 'statusbar',
        'id': s,
        'a': {
        },
        'on': {},
    }
    button_hyphenate = {
        't': 'button',
        'id': 'hyphenate',
        'a': {
            'label': u'wykonaj podział wyrazów na sylaby',
        },
        'on': {
            'clicked': fdict['hyphenate_simple'],
        },
    }
    button_quit = {
        't': 'button',
        'id': 'quit',
        'a': {
            'label': u'zakończ program',
        },
        'on': {
            'clicked': quit,
        },
    }
    toolbar = {
        't': 'hbox',
        'a': {
        },
        'on': {},
        'c': [['exp', button_hyphenate], ['exp', button_quit]],
    }
    menu = {
        't': 'menu',
        'a': {
            'menus': [
                ['pomoc', [
                [u'O programie', fdict['display_about']],
                ]],
            ],
        },
    }
    statusarea = {
        't': 'hbox',
        'a': {
        },
        'on': {},
        'c': [['noexp', gstatus], ['exp', statusbar]],
    }
    vist = {
        't': 'vbox',
        'a': {
        },
        'on': {},
        'c': [['exp', vi], 'sep', ['noexp', statusarea]]
    }
    hd = {
        't': 'hdouble',
        'a': {
            'position': 400,
            'resize': [False, True],
            'shrink': [True, True],
        },
        'on': {},
        'c': [edi, result],
    }
    hdX = {
        't': 'vdouble',
        'a': {
            'position': 190,
            'resize': [False, True],
            'shrink': [True, True],
        },
        'on': {},
        'c': [edi, vi],
    }
    def pri(w): print '123', w
    spacer = {
        't': 'label',
        'a': {
            'size': {'x': 100, 'y': 12},
        },
        'on': {},
    }
    main_vb = {
        't': 'vbox',
        'a': {
        },
        'on': {},
        'c': [['noexp', menu], ['exp', hd]],
    }
    top_child = [main_vb]
    tl = mk_top_level({'title': u'System Kaliope | Program Przenoszenie' + u' | Podział wyrazów na sylaby',
        'icon': 'Kaliope.ico',
        }, top_child)
    return tl
about_window = {
    't': 'about',
    'id': 'about',
    'a': {
        'program_name': 'Kaliope Przenoszenie',
        'version': '1.0',
        'copyright': None,
        'comments': u'''Program do testowania modułu przenoszenia wyrazów (podziału
        wyrazów na sylaby)
Autorzy: Zespół Kaliope
''',
        'website': None,
        'logo': None,
    },
    'on': {
    },
}
ui_functions = mk_ui_functions()
ui_structure = mk_ui_structure(ui_functions)
tu = ui.eval(ui_structure)
wdict = ui.mk_idict(tu)
ui_functions['set_widgets_dictionary'](wdict)
ui_functions['init']()
top_level.run()