#!/usr/bin/python
# -*- coding: utf-8 -*-

import os
import pprint
import tempfile
import copy
import gtk
import kaliope.ui as ui
import kaliope.top_level as top_level
import kaliope.uti as uti
import kaliope.kaliope_lib as kaliope_lib
kl = kaliope_lib
import kaliope.kaliope_examples as ke
import kaliope.kaliope_examples_lg as kelg
import kaliope.file_dialog as file_dialog
def mk_config():
    config = {}
    config['colors'] = {
        'area_editable': ['bytes', [226, 255, 163]],
        'area_noneditable': ['bytes', [255, 233, 163]],
    }
    return config
config = mk_config()
def mk_ui_functions():
    priv = {
        'pdf_string': None,
        'reflected_source': None,
        'wdict': None,
    }
    color_white = ['bytes', [255, 255, 255]]
    color_light =  ['bytes', [255, 255, 150]] 
    color_red = ['bytes', [255, 0, 0]]
    color_orange =  ['bytes', [255, 165, 0]] 
    color_yellow =  ['bytes', [255, 215, 000]] 
    color_blue =  ['bytes', [0, 0, 255]] 
    color_green =  ['bytes', [50, 205, 50]] 
    status_color = {
        'empty': color_light,
        'inconsistent': color_orange,
        'in_progress': color_yellow,
        'consistent': color_green,
        'error': color_red,
    }
    status_text = {
        'empty': u'podgląd niegotowy',
        'inconsistent': u'brak zgodności podglądu',
        'in_progress': u'obliczam...',
        'consistent': u'podgląd zgodny',
        'error': u'błąd',
    }
    def set_status(sid, message=None):
        new_text = message if message is not None else status_text[sid]
        wdict['tstatus']['m']['set_value'](u'  ' + new_text)
        wdict['gstatus']['m']['set_color'](status_color[sid])
    def init():
        set_status('empty')
        priv['keyboard_type'] = 'transparent'
        priv['wdict']['edlg']['m']['grab_focus']()
    def clear():
        wdict['fstatus']['m']['set_value'](u'')
        wdict['edlg']['m']['set_value'](u'')
        wdict['edc']['m']['set_value'](u'')
        priv['pdf_string'] = None
        priv['reflected_source'] = None
        priv['parts'] = None
        wdict['viewer']['m']['clear']()
        priv['wdict']['button_get_pdf']['m']['set_label'](u'plik PDF niegotowy')
        priv['wdict']['button_get_pdf']['m']['set_sensitive'](False)
        priv['wdict']['edlg']['m']['grab_focus']()
        set_status('empty')
    def display_about(w):
        about_w = ui.eval(about_window)
        awdict = ui.mk_idict(about_w)
        met = awdict['about']['m']
        met['show']()
        met['run']()
        met['destroy']()
    def string_to_editors(s):
        parts = kl.sklad['string_to_parts'](s)
        priv['parts'] = parts
        wdict['edlg']['m']['set_value'](parts['value'])
        wdict['edc']['m']['set_value'](parts['prolog'])
    def save_reflected_source():
        priv['reflected_source'] = copy.deepcopy(priv['parts'])
    def sources_equal():
        editors_to_parts()
        first = priv['parts']
        second = priv['reflected_source']
        eq = True
        eq = eq and first['prolog'] == second['prolog']
        eq = eq and first['value'] == second['value']
        fi = first['info']
        si = second['info']
        eq = eq and set(fi.keys()) == set(si.keys())
        for k in fi.keys():
            eq = eq and fi[k] == si[k]
        return eq
    def editors_to_parts():
        lg = priv['wdict']['edlg']['m']['get_value']()
        conf = priv['wdict']['edc']['m']['get_value']()
        if 'parts' not in priv:
            priv['parts'] = {}
            priv['parts']['info'] = {'filename': u'', 'title': u''}
        priv['parts']['value'] = lg
        priv['parts']['prolog'] = conf
    def editors_to_view(w):
        editors_to_parts()
        blocks = kl.sklad['parts_to_blocks'](priv['parts'])
        if 0:
            r = kl.sklad['blocks_to_results'](blocks)
            save_reflected_source()
            image_string = r['value']['png']
            image_string_to_viewer(image_string)
        if False:
            set_status('consistent', u'zapis L-G nie uległ zmianie')
        else:
            set_status(u'in_progress')
            while gtk.events_pending():
                gtk.main_iteration(False)
            r = kl.sklad['blocks_to_results'](blocks)
            if r['ok']:
                priv['pdf_string'] = r['value']['pdf']
                image_string = r['value']['png']
                image_string_to_viewer(image_string)
                save_reflected_source()
                set_status(u'consistent')
                priv['wdict']['button_get_pdf']['m']['set_label'](u'zapisz plik PDF')
                priv['wdict']['button_get_pdf']['m']['set_sensitive'](True)
            else:
                set_status('error', u'błąd zamiany notacji L-G na postać typograficzną')
    def image_string_to_viewer(image_string):
        if True:
            if 0:
                fool_fn = tempfile.NamedTemporaryFile()
                open(fool_fn, 'wb').write(image_string)
                priv['wdict']['viewer']['m']['set_value'](fool_fn)
            else:
                fool_dir = tempfile.mkdtemp()
                fool_fn = 'image.png'
                fool_path = os.path.join(fool_dir, fool_fn)
                fool_fh = open(fool_path, 'wb')
                fool_fh.write(image_string)
                fool_fh.close()
                priv['wdict']['viewer']['m']['set_value'](fool_path)
        else:
            fh = stringio.StringIO()
            fh.write(image_string)
            im = Image.open(fh)    
            im.verify()
            priv['wdict']['viewer']['m']['from_image'](im)
    def set_keyboard_type(w):
        if priv['keyboard_type'] == 'transparent':
            priv['wdict']['editor']['m']['set_input_type']('braille')
            priv['keyboard_type'] = 'braille'
            priv['wdict']['set_keyboard_type']['m']['set_label'](u'użyj zwykłej klawiatury')
        elif priv['keyboard_type'] == 'braille':
            priv['wdict']['editor']['m']['set_input_type']('transparent')
            priv['keyboard_type'] = 'transparent'
            priv['wdict']['set_keyboard_type']['m']['set_label'](u'użyj klawiatury brajlowskiej')
        priv['wdict']['editor']['m']['grab_focus']()
    def save_pdf(w):
        if priv['pdf_string'] is not None:
            p = {'title': u'zapisz plik PDF',
                'filters': [
                        {'name': u"pliki PDF", 'patterns': ["*.pdf"], 'mime_types': ["image/pdf"]},
                        {'name': u"wszystkie pliki", 'patterns': ["*.*"]},
                    ],
                'suggested_name': 'plik.pdf',
                'b': priv['pdf_string'],
            }
            r = file_dialog.write_bytes(p)
            if r['ok']:
                pass
            else:
                set_status('error', u'plik nie został zapisany')
    def open_lg(w):
        p = {'title': u'otwórz plik L-G',
            'filters': [
                    {'name': u"pliki L-G", 'patterns': ["*.lg"], 'mime_types': ["text/plain"]},
                    {'name': u"wszystkie pliki", 'patterns': ["*.*"]},
                ],
        }
        r = file_dialog.read_bytes(p)
        if r['ok']:
            b = r['b']
            try:
                s = b.decode('utf8')
                c_ok = True
            except:
                c_ok = False
                s = u''
            if c_ok:
                clear()
                string_to_editors(s)
                set_status('empty')
                wdict['viewer']['m']['clear']()
                wdict['fstatus']['m']['set_value'](r['fn'])
            else:
                if False:
                    set_status('error', u'niepoprawne znaki w pliku')
                else:
                    wdict['editor']['m']['set_value'](s)
                    set_status('error', u'niepoprawne znaki w pliku')
                    wdict['viewer']['m']['clear']()
                    wdict['fstatus']['m']['set_value'](fn)
            priv['wdict']['button_get_pdf']['m']['set_label'](u'plik PDF niegotowy')
            priv['wdict']['button_get_pdf']['m']['set_sensitive'](False)
        else:
            pass
    def open_example(i):
        clear()
        s = kelg.examples[i]['value']
        string_to_editors(s)
        set_status('empty')
        wdict['viewer']['m']['clear']()
        if 'filename' in priv['parts']['info']:
            fn = priv['parts']['info']['filename']
        else:
            fn = u''
        wdict['fstatus']['m']['set_value'](fn)
        if 0:
            wdict['editor']['m']['set_value'](ke.brailleu[i]['value'])
            set_status('empty')
            wdict['viewer']['m']['clear']()
            wdict['fstatus']['m']['set_value'](u'')
    def save_lg(w):
        editors_to_parts()
        s = kl.sklad['parts_to_string'](priv['parts'])
        if True:
            b = s.encode('utf8')
            c_ok = True
        else:
            b = ''
            c_ok = False
        if c_ok:
            p = {'title': u'zapisz plik L-G',
                'filters': [
                        {'name': u"pliki L-G", 'patterns': ["*.lg"]},
                        {'name': u"wszystkie pliki", 'patterns': ["*.*"]},
                    ],
                'b': b,
            }
            r = file_dialog.write_bytes(p)
            if r['ok']:
                wdict['fstatus']['m']['set_value'](r['fn'])
            else:
                set_status('error', u'plik nie został zapisany')
        else:
            set_status('error', u'błąd konwersji pliku do Unicode')
    def on_changed_edc():
        if priv['reflected_source'] is not None:
            if sources_equal():
                set_status('consistent')
            else:
                set_status('inconsistent')
    def on_key_press(d):
        if d['keyname'] in ['F6']:
            editors_to_view(None)
    def on_changed_edlg():
        if priv['reflected_source'] is not None:
            if sources_equal():
                set_status('consistent')
            else:
                set_status('inconsistent')
    def quit(*ar):
        top_level.quit()
    def set_widgets_dictionary(wd):
        priv['wdict'] = wd
    res = {
        'init': init,
        'clear': clear,
        'display_about': display_about,
        'set_widgets_dictionary': set_widgets_dictionary,
        'editors_to_view': editors_to_view,
        'on_changed_edc': on_changed_edc,
        'on_changed_edlg': on_changed_edlg,
        'on_key_press': on_key_press,
        'set_keyboard_type': set_keyboard_type,
        'open_lg': open_lg,
        'open_example': open_example,
        'save_lg': save_lg,
        'save_pdf': save_pdf,
        'quit': quit,
        'wd': priv['wdict'],
    }
    return res
def mk_ui_structure(fdict):
    def edit(p):
        default = {
        't': 'editor',
        'a': {
            'left_margin': 0,
            'indent': 2,
            'pixels_above_lines': 2,
            'pixels_below_lines': 0,
            'pixels_inside_wrap': -1,
            'text': u'',
            'sensitive': True,
            'editable': True,
            'wrapping': True,
        },
        'on': {},
        }
        return uti.sub_update(default, p)
    def lab(p):
        default = {
            't': 'label',
            'a': {
                'xalign': 0.5,
                'size': {'x': 100, 'y': 33},
            },
            'on': {},
        }
        return uti.sub_update(default, p)
    def editl(p, l):
        la = lab({'a': {'label': l}})
        ed = edit(p)
        vb = {
            't': 'vbox',
            'a': {
            },
            'on': {},
            'c': [['noexp', la], ['exp', ed]],
        }
        return vb
    def editlab(edp, lap):
        la = lab(lap)
        ed = edit(edp)
        vb = {
            't': 'vbox',
            'a': {
            },
            'on': {},
            'c': [['noexp', la], ['exp', ed]],
        }
        return vb
    edc = editlab({
        'id': 'edc',
        'a': {
            'editable': True,
            'input_type': 'transparent',
        },
        'on': {'changed': lambda a, b: fdict['on_changed_edc']()},
    }, {'a': {'label': u'edytor konfiguracji', 'bg_color': config['colors']['area_editable']}})
    edlg = editlab({
        'id': 'edlg',
        'a': {
            'editable': True,
            'input_type': 'transparent',
        },
        'on': {'changed': lambda a, b: fdict['on_changed_edlg']()},
    }, {'a': {'label': u'edytor notacji L-G', 'bg_color': config['colors']['area_editable']}})
    edi = edlg
    def mk_editor(par):
        if 'text' in par:
            initial_text = par['text']
        else:
            initial_text = ''
        def on_changed_edi(a, b):
            fdict['on_changed_editor']()
        edi = {
            't': 'editor',
            'a': {
                'left_margin': 0,
                'indent': 2,
                'pixels_above_lines': 2,
                'pixels_below_lines': 0,
                'pixels_inside_wrap': -1,
                'text': initial_text,
            },
            'on': {'changed': on_changed_edi},
        }
        return edi
    def mk_image_viewer(par):
        if 'bg' not in par:
            bg = ['bytes', [0, 0, 0]],
        vi = {
            't': 'viewer',
            'a': {
                'img': par['img'],
            },
        }
        if 'page' in par:
            vi['a']['page'] = par['page']
        return vi
    def png(f, dir='tex_png', bg=None):
        return img(f, '.png', dir)
    def jpg(f, dir='pub', bg=None):
        return img(f, '.jpg', dir)
    def pdf(f, page=1, bg=None):
        return img(f, '.pdf', page=page)
    def img(f, ext=None, dir=None, page=None, bg=None):
        r, e = os.path.splitext(f)
        if ext is not None:
            fn = r + ext
        else:
            fn = f
        if dir is not None:
            path = os.path.join(dir, fn)
        else:
            path = fn
        par = {'img': path}
        if page is not None:
            par['page'] = page
        if bg is not None:
            par['bg'] = bg
        return mk_image_viewer(par)
    empty = {
        't': 'empty',
        'a': {
            'color': ['bytes', [20, 20, 20]],
        },
    }
    emp = empty
    def mk_top_level(a, child):
        attr = {
                'title': u'Nutowy Edytor Typograficzny',
                'border_width': 1,
                'minw': 0,
                'minh': 0,
                'startw': 800,
                'starth': 600,
                'position': 'maximize',
            }
        attr.update(a)
        tl = {
            't': 'top_level',
            'a': attr,
            'on': {
                'destroy': fdict['quit'],
                'key_press': fdict['on_key_press'],
            },
            'c': child,
        } # end top level
        return tl
    if 0:
        def mk_text_viewers(ito):
            fh = open(os.path.join(ito['mixer'], ito['ifilname']), 'r')
            text_mp = fh.read()
            edi_mp = mk_editor({'text': text_mp})
            fh = open(os.path.join(ito['mixer'], ito['dfilname']), 'r')
            text_dat = fh.read()
            edi_dat = mk_editor({'text': text_dat})
            return edi_mp, edi_dat
        edi_trivial_mp, edi_trivial_dat = mk_text_viewers(b_trivial)
        edi_textual_mp, edi_textual_dat = mk_text_viewers(b_textual)
        edi_similar_mp, edi_similar_dat = mk_text_viewers(b_similar)
        edi_smoothbez_mp, edi_smoothbez_dat = mk_text_viewers(b_smoothbez)
    viewer1 = mk_image_viewer({'img': 'cromoterapia_woman.jpg'})
    viewer_ooo = {
        't': 'viewer',
        'a': {
            'img': 'cromoterapia_woman.jpg',
            'bg': ['bytes', [33, 33, 33]],
        },
    }
    def tex(a):
        return pdf(texowe, page=a),
    def viewerlab(vp, lap):
        la = lab(lap)
        vb = {
            't': 'vbox',
            'a': {
            },
            'on': {},
            'c': [['noexp', la], ['exp', vp]],
        }
        return vb
    vp = {
        't': 'viewer',
        'id': 'viewer',
        'a': {
            'bg': ['bytes', [210, 210, 210]],
        },
    }
    vi = viewerlab(vp,  {'a': {'label': u'rezultat graficzny', 'bg_color': config['colors']['area_noneditable']}})
    statusbar = {
        't': 'statusbar',
        'id': 'tstatus',
        'a': {
        },
        'on': {},
    }
    fstatus = {
        't': 'statusbar',
        'id': 'fstatus',
        'a': {
            'has_resize_grip': False,
        },
        'on': {},
    }
    statusbarX = {
        't': 'label',
        'id': 'statusbar',
        'a': {
            'label': u' nic takiego, nic wielkiego',
            'xalign': 0.0,
        },
        'on': {},
    }
    subtitle = {
        't': 'label',
        'id': 'subtitle',
        'a': {
            'label': u' ' + u'zamiana postaci brajlowskiej nut na postać typograficzną',
            'xalign': 0.0,
        },
        'on': {},
    }
    gstatus = {
        't': 'viewer',
        'id': 'gstatus',
        'a': {
            'bg': ['bytes', [10, 210, 210]],
            'size': {'w': 100, 'h': 20},
        },
    }
    xstatus = {
        't': 'viewer',
        'id': 'xstatus',
        'a': {
            'bg': ['bytes', [10, 10, 110]],
            'size': {'w': 100, 'h': 20},
        },
    }
    def mk_statusbar(s):
        return {
        't': 'statusbar',
        'id': s,
        'a': {
        },
        'on': {},
    }
    button_view = {
        't': 'button',
        'id': 'view',
        'a': {
            'label': u'utwórz postać typograficzną',
        },
        'on': {
            'clicked': fdict['editors_to_view'],
        },
    }
    button_clear = {
        't': 'button',
        'id': 'clear',
        'a': {
            'label': u'początkowy stan interfejsu',
        },
        'on': {
            'clicked': lambda w: fdict['clear'](),
        },
    }
    button_quit = {
        't': 'button',
        'id': 'quit',
        'a': {
            'label': u'zakończ program',
        },
        'on': {
            'clicked': quit,
        },
    }
    button_get_pdf = {
        't': 'button',
        'id': 'button_get_pdf',
        'a': {
            'label': u'plik PDF niegotowy',
            'sensitive': False,
        },
        'on': {
            'clicked': fdict['save_pdf'],
        },
    }
    toolbar = {
        't': 'hbox',
        'a': {
        },
        'on': {},
        'c': [['exp', button_view], ['exp', button_clear], ['exp', button_get_pdf], ['exp', button_quit]],
    }
    statusarea = {
        't': 'hbox',
        'a': {
        },
        'on': {},
        'c': [['noexp', gstatus], ['exp', statusbar]],
    }
    vist = {
        't': 'vbox',
        'a': {
        },
        'on': {},
        'c': [['exp', vi], 'sep', ['noexp', statusarea]]
    }
    vdou = {
        't': 'vdouble',
        'a': {
            'position': 600,
            'resize': [False, True],
            'shrink': [True, True],
        },
        'on': {},
        'c': [edlg, edc],
    }
    hd = {
        't': 'hdouble',
        'a': {
            'position': 600,
            'resize': [False, True],
            'shrink': [True, True],
        },
        'on': {},
        'c': [vdou, vist],
    }
    hdX = {
        't': 'vdouble',
        'a': {
            'position': 190,
            'resize': [False, True],
            'shrink': [True, True],
        },
        'on': {},
        'c': [edi, vi],
    }
    submenu_examplesX = [
        [u'otwórz przykład 1', lambda w: fdict['open_example'](w, 0)],
        [u'otwórz przykład 2', lambda w: fdict['open_example'](w, 1)],
    ]
    submenu_examples = []
    for exi in range(len(kelg.examples)):
        nstr = str(exi + 1)
        def mk_opening_example(i):
            return lambda w: fdict['open_example'](i)
        submenu_examples.append([u'otwórz przykład ' + nstr + '.', mk_opening_example(exi)])
    menu_plik = [
                [u'otwórz plik L-G', fdict['open_lg']],
                'sep',
                ] + submenu_examples + [
                'sep',
                [u'zapisz plik L-G', fdict['save_lg']],
                [u'zapisz plik PDF', fdict['save_pdf']],
                ]
    menu = {
        't': 'menu',
        'a': {
            'menus': [
                ['plik', menu_plik],
                ['pomoc', [
                [u'O programie', fdict['display_about']],
                ]],
            ],
        },
    }
    main_vb = {
        't': 'vbox',
        'a': {
        },
        'on': {},
        'c': [['noexp', menu], ['noexp', fstatus], ['noexp', toolbar], ['exp', hd]],
    }
    top_child = [main_vb]
    tl = mk_top_level({'title': u'System Kaliope | Program Skład' + u' | Zamiana lekkiej notacji muzycznej L-G na postać typograficzną',
        'icon': 'Kaliope.ico',
        }, top_child)
    return tl
ui_functions = mk_ui_functions()
ui_structure = mk_ui_structure(ui_functions)
tu = ui.eval(ui_structure)
wdict = ui.mk_idict(tu)
ui_functions['set_widgets_dictionary'](wdict)
ui_functions['init']()
about_window = {
    't': 'about',
    'id': 'about',
    'a': {
        'program_name': 'Kaliope Skład',
        'version': '1.0',
        'copyright': None,
        'comments': u'''Program do zamiany lekkiej notacji muzycznej L-G wraz z konfiguracją na postać typograficzną nut
Autorzy: Zespół Kaliope
''',
        'website': None,
        'logo': None,
    },
    'on': {
    },
}
top_level.run()