#!/usr/bin/python
# -*- coding: utf-8 -*-

import os
import pprint
import tempfile
import gtk
import kaliope.ui as ui
import kaliope.top_level as top_level
import kaliope.uti as uti
import kaliope.multipage as mp
import kaliope.file_dialog as file_dialog
import kaliope.kaliope_lib as kaliope_lib
kl = kaliope_lib
import kaliope.kaliope_examples as ke
import kaliope.kaliope_examples_lg as kelg
import kaliope.file_dialog as file_dialog
def mk_config():
    config = {}
    config['colors'] = {
        'area_editable': ['bytes', [226, 255, 163]],
        'area_noneditable': ['bytes', [255, 233, 163]],
        'level_one': ['bytes', [233, 221, 175]],
        'level_two': ['bytes', [214, 193, 107]],
    }
    return config
config = mk_config()
def mk_ui_functions():
    priv = {
        'pdf_string': None,
        'midi_string': None,
        'xml_string': None,
        'reflected_source': None,
        'wdict': None,
        'edt_still': False,
        'edb_still': False,
        'level': 2,
    }
    color_white = ['bytes', [255, 255, 255]]
    color_light =  ['bytes', [255, 255, 150]] 
    color_red = ['bytes', [255, 0, 0]]
    color_orange =  ['bytes', [255, 165, 0]] 
    color_yellow =  ['bytes', [255, 215, 000]] 
    color_blue =  ['bytes', [0, 0, 255]] 
    color_green = ['bytes', [50, 205, 50]] 
    status_color = {
        'empty': color_light,
        'inconsistent': color_orange,
        'in_progress': color_yellow,
        'consistent': color_green,
        'error': color_red,
    }
    status_text = {
        'empty': u'podgląd niegotowy',
        'inconsistent': u'brak zgodności podglądu',
        'in_progress': u'obliczam...',
        'consistent': u'podgląd zgodny',
        'error': u'błąd',
    }
    def set_status(sid, message=None):
        new_text = message if message is not None else status_text[sid]
        if 'tstatus' in wdict and 'gstatus' in wdict:
            wdict['tstatus']['m']['set_value'](u'  ' + new_text)
            wdict['gstatus']['m']['set_color'](status_color[sid])
    def init():
        set_status('empty')
        priv['wdict']['edt']['m']['grab_focus']()
        priv['level'] = 1
    def editor_to_view(w):
        e_value = priv['wdict']['editor']['m']['get_value']()
        if False:
            set_status(u'in_progress')
            while gtk.events_pending():
                gtk.main_iteration(False)
            r = kaliope_lib.braille_to_typo(e_value)
            if r['ok']:
                priv['pdf_string'] = r['value']['pdf']
                priv['midi_string'] = r['value']['midi']
                priv['xml_string'] = r['value']['xml']
                image_string = r['value']['png']
                image_string_to_viewer(image_string)
                priv['reflected_source'] = e_value
                set_status(u'consistent')
                priv['wdict']['button_get_pdf']['m']['set_label'](u'zapisz plik PDF')
                priv['wdict']['button_get_pdf']['m']['set_sensitive'](True)
                priv['wdict']['button_get_midi']['m']['set_label'](u'zapisz plik MIDI')
                priv['wdict']['button_get_midi']['m']['set_sensitive'](True)
                priv['wdict']['button_get_xml']['m']['set_label'](u'zapisz plik MusicXML')
                priv['wdict']['button_get_xml']['m']['set_sensitive'](True)
            else:
                set_status('error', u'błąd zamiany zapisu z brajlowskiego na typograficzny')
        else:
            set_status('consistent', u'zapis brajlowski nie uległ zmianie')
    def image_string_to_viewer(image_string):
        if True:
            if 0:
                fool_fn = tempfile.NamedTemporaryFile()
                open(fool_fn, 'wb').write(image_string)
                priv['wdict']['viewer']['m']['set_value'](fool_fn)
            else:
                fool_dir = tempfile.mkdtemp()
                fool_fn = 'image.png'
                fool_path = os.path.join(fool_dir, fool_fn)
                fool_fh = open(fool_path, 'wb')
                fool_fh.write(image_string)
                fool_fh.close()
                priv['wdict']['viewer']['m']['set_value'](fool_path)
        else:
            fh = stringio.StringIO()
            fh.write(image_string)
            im = Image.open(fh)    
            im.verify()
            priv['wdict']['viewer']['m']['from_image'](im)
    def abbreviate_text(s, level=1):
        tokens = kl.abbreviate_words(kl.split_text(s), level)
        new_text = ''.join([v if t == 'word' else kl.convert('pl', 'unicode', v)['s'] for t, v in tokens])
        return new_text
    def set_keyboard_type(w):
        if priv['keyboard_type'] == 'transparent':
            priv['wdict']['editor']['m']['set_input_type']('braille')
            priv['keyboard_type'] = 'braille'
            priv['wdict']['set_keyboard_type']['m']['set_label'](u'użyj zwykłej klawiatury')
        elif priv['keyboard_type'] == 'braille':
            priv['wdict']['editor']['m']['set_input_type']('transparent')
            priv['keyboard_type'] = 'transparent'
            priv['wdict']['set_keyboard_type']['m']['set_label'](u'użyj klawiatury brajlowskiej')
        priv['wdict']['editor']['m']['grab_focus']()
    def save_pdf(w):
        if priv['pdf_string'] is not None:
            p = {'title': u'zapisz plik PDF',
                'filters': [
                        {'name': u"pliki PDF", 'patterns': ["*.pdf"], 'mime_types': ["image/pdf"]},
                        {'name': u"wszystkie pliki", 'patterns': ["*.*"]},
                    ],
                'suggested_name': 'plik.pdf',
                'b': priv['pdf_string'],
            }
            r = file_dialog.write_bytes(p)
            if r['ok']:
                pass
            else:
                set_status('error', u'błąd zapisu pliku')
    def save_midi(w):
        if priv['midi_string'] is not None:
            p = {'title': u'zapisz plik MIDI',
                'filters': [
                        {'name': u"pliki MIDI", 'patterns': ["*.midi"], 'mime_types': ["audio/midi"]},
                        {'name': u"wszystkie pliki", 'patterns': ["*.*"]},
                    ],
                'suggested_name': 'plik.midi',
                'b': priv['midi_string'],
            }
            r = file_dialog.write_bytes(p)
            if r['ok']:
                pass
            else:
                set_status('error', u'błąd zapisu pliku')
    def save_xml(w):
        if priv['xml_string'] is not None:
            p = {'title': u'zapisz plik MusicXML',
                'filters': [
                        {'name': u"pliki XML", 'patterns': ["*.xml"]},
                        {'name': u"wszystkie pliki", 'patterns': ["*.*"]},
                    ],
                'suggested_name': 'plik.xml',
                'b': priv['xml_string'],
            }
            r = file_dialog.write_bytes(p)
            if r['ok']:
                pass
            else:
                set_status('error', u'błąd zapisu pliku')
    def open_unicode_braille(w):
        p = {'title': u'otwórz plik w kodowaniu utf-8 Unicode Braille',
            'filters': [
                    {'name': u"pliki Unicode Braille", 'patterns': ["*.ubr"], 'mime_types': ["text/plain"]},
                    {'name': u"wszystkie pliki", 'patterns': ["*.*"]},
                ],
        }
        r = file_dialog.read_bytes(p)
        if r['ok']:
            b = r['b']
            try:
                s = b.decode('utf8')
                c_ok = True
            except:
                c_ok = False
                s = u''
            if c_ok:
                wdict['editor']['m']['set_value'](s)
                set_status('empty')
                wdict['viewer']['m']['clear']()
                wdict['fstatus']['m']['set_value'](r['fn'])
            else:
                if False:
                    set_status('error', u'niepoprawne znaki w pliku')
                else:
                    wdict['editor']['m']['set_value'](s)
                    set_status('error', u'niepoprawne znaki w pliku')
                    wdict['viewer']['m']['clear']()
                    wdict['fstatus']['m']['set_value'](fn)
            priv['wdict']['button_get_pdf']['m']['set_label'](u'plik PDF niegotowy')
            priv['wdict']['button_get_pdf']['m']['set_sensitive'](False)
            priv['wdict']['button_get_midi']['m']['set_label'](u'plik MIDI niegotowy')
            priv['wdict']['button_get_midi']['m']['set_sensitive'](False)
            priv['wdict']['button_get_xml']['m']['set_label'](u'plik MusicXML niegotowy')
            priv['wdict']['button_get_xml']['m']['set_sensitive'](True)
        else:
            pass
    def open_example(w, i):
        wdict['editor']['m']['set_value'](ke.brailleu[i]['value'])
        set_status('empty')
        wdict['viewer']['m']['clear']()
        wdict['fstatus']['m']['set_value'](u'')
    def save_unicode_braille(w):
        s = wdict['editor']['m']['get_value']()
        if True:
            b = s.encode('utf8')
            c_ok = True
        else:
            b = ''
            c_ok = False
        if c_ok:
            p = {'title': u'zapisz plik w kodowaniu Unicode Braille',
                'filters': [
                        {'name': u"pliki Unicode Braille", 'patterns': ["*.ubr"]},
                        {'name': u"wszystkie pliki", 'patterns': ["*.*"]},
                    ],
                'b': b,
            }
            r = file_dialog.write_bytes(p)
            if r['ok']:
                wdict['fstatus']['m']['set_value'](r['fn'])
            else:
                set_status('error', u'błąd zapisu pliku')
        else:
            set_status('error', u'błąd konwersji pliku do Unicode Braille')
    def save_ascii_braille(w):
        s = wdict['editor']['m']['get_value']()
        r = kl.convert('unicode', 'ascii', s)
        if r['ok']:
            b = s.encode('utf8')
            c_ok = True
        else:
            b = ''
            c_ok = False
        if c_ok:
            p = {'title': u'zapisz plik w kodowaniu ASCII Braille',
                'filters': [
                        {'name': u"pliki ASCII Braille", 'patterns': ["*.abr"]},
                        {'name': u"wszystkie pliki", 'patterns': ["*.*"]},
                    ],
                'b': b,
            }
            r = file_dialog.write_bytes(p)
            if r['ok']:
                wdict['fstatus']['m']['set_value'](r['fn'])
            else:
                set_status('error', u'błąd zapisu pliku')
        else:
            set_status('error', u'błąd konwersji pliku do ASCII Braille')
    def open_ascii_braille(w):
        p = {'title': u'otwórz plik w kodowaniu ASCII Braille',
            'filters': [
                    {'name': u"pliki ASCII Braille", 'patterns': ["*.abr"]},
                    {'name': u"wszystkie pliki", 'patterns': ["*.*"]},
                ],
        }
        r = file_dialog.read_bytes(p)
        if r['ok']:
            b = r['b']
            rc = kl.convert('ascii', 'unicode', b)
            if rc['ok']:
                wdict['editor']['m']['set_value'](rc['s'])
                set_status('empty')
                wdict['viewer']['m']['clear']()
                wdict['fstatus']['m']['set_value'](r['fn'])
            else:
                if False:
                    set_status('error', u'niepoprawne znaki w pliku')
                else:
                    wdict['editor']['m']['set_value'](rc['s'])
                    set_status('error', u'niepoprawne znaki w pliku')
                    wdict['viewer']['m']['clear']()
                    wdict['fstatus']['m']['set_value'](r['fn'])
            priv['wdict']['button_get_pdf']['m']['set_label'](u'plik PDF niegotowy')
            priv['wdict']['button_get_pdf']['m']['set_sensitive'](False)
            priv['wdict']['button_get_midi']['m']['set_label'](u'plik MIDI niegotowy')
            priv['wdict']['button_get_midi']['m']['set_sensitive'](False)
        else:
            pass
    def on_changed_edt():
        if priv['edt_still']:
            pass
        else:
            e_value = priv['wdict']['edt']['m']['get_value']()
            ori_t = e_value
            r = kl.convert('pl', 'unicode', e_value)
            if r['ok']:
                ori_b = r['s']
            else:
                ori_b = r['s']
            priv['edb_still'] = True
            priv['wdict']['edb']['m']['set_value'](ori_b)
            priv['edb_still'] = False
            set_abbreviated(e_value, ori_b)
            bt = kl.convert('unicode', 'pl', ori_b)
            priv['wdict']['txp']['m']['set_value'](bt['s'])
            set_status('consistent')
            if 0:
                abb_t = abbreviate_text(e_value, priv['level'])
                priv['wdict']['ret']['m']['set_value'](abb_t)
                r = kl.convert('ascii', 'unicode', abb_t)
                if r['ok']:
                    abb_b = r['s']
                else:
                    abb_b = r['s']
                priv['wdict']['reb']['m']['set_value'](abb_b)
    def on_changed_edb():
        if priv['edb_still']:
            pass
        else:
            e_value = priv['wdict']['edb']['m']['get_value']()
            ori_b = e_value
            r = kl.convert('unicode', 'pl', e_value)
            if r['ok']:
                ori_t = r['s']
            else:
                ori_t = r['s']
            priv['edt_still'] = True
            priv['wdict']['edt']['m']['set_value'](ori_t)
            priv['edt_still'] = False
            bt = kl.convert('unicode', 'pl', ori_b)
            priv['wdict']['txp']['m']['set_value'](bt['s'])
            set_abbreviated(ori_t, ori_b)
            set_status('consistent')
        if 0:
            r = kl.convert('unicode', 'ascii', e_value)
            if r['ok']:
                ori_t = r['s']
            else:
                ori_t = r['s']
            priv['wdict']['edt']['m']['set_value'](ori_t)
            set_abbreviated(ori_t, e_value)
        if 0:
            abb_t = abbreviate_text(e_value, priv['level'])
            priv['wdict']['ret']['m']['set_value'](abb_t)
            r = kl.convert('ascii', 'unicode', abb_t)
            if r['ok']:
                abb_b = r['s']
            else:
                abb_b = r['s']
            priv['wdict']['reb']['m']['set_value'](abb_b)
    def set_abbreviated(t, b):
        abb_b = abbreviate_text(t, priv['level'])
        priv['wdict']['abb']['m']['set_value'](abb_b)
        r = kl.convert('unicode', 'pl', abb_b)
        if r['ok']:
            abb_t = r['s']
        else:
            abb_t = r['s']
        priv['wdict']['abp']['m']['set_value'](abb_t)
        r = kl.convert('unicode', 'ascii', abb_b)
        if r['ok']:
            abb_t = r['s']
        else:
            abb_t = r['s']
        priv['wdict']['abt']['m']['set_value'](abb_t)
    def display_about(w):
        about_w = ui.eval(about_window)
        awdict = ui.mk_idict(about_w)
        met = awdict['about']['m']
        met['show']()
        met['run']()
        met['destroy']()
    def toggle_level(w):
        if priv['level'] == 1:
            priv['level'] = 2
            priv['wdict']['label_level']['m']['set_value'](u'drugi poziom skrótów')
            priv['wdict']['button_level']['m']['set_label'](u'  włącz pierwszy poziom  ')
            priv['wdict']['label_level']['m']['set_bg_color'](config['colors']['level_two'])
            priv['wdict']['button_level']['m']['set_bg_color'](config['colors']['level_one'])
        else:
            priv['level'] = 1
            priv['wdict']['label_level']['m']['set_value'](u'pierwszy poziom skrótów')
            priv['wdict']['button_level']['m']['set_label'](u'  włącz drugi poziom  ')
            priv['wdict']['label_level']['m']['set_bg_color'](config['colors']['level_one'])
            priv['wdict']['button_level']['m']['set_bg_color'](config['colors']['level_two'])
        priv['edt_still'] = False
        on_changed_edt()
    def quit(*ar):
        top_level.quit()
    def set_widgets_dictionary(wd):
        priv['wdict'] = wd
    res = {
        'init': init,
        'set_widgets_dictionary': set_widgets_dictionary,
        'editor_to_view': editor_to_view,
        'on_changed_edt': on_changed_edt,
        'on_changed_edb': on_changed_edb,
        'set_keyboard_type': set_keyboard_type,
        'open_ascii_braille': open_ascii_braille,
        'open_unicode_braille': open_unicode_braille,
        'open_example': open_example,
        'save_unicode_braille': save_unicode_braille,
        'save_ascii_braille': save_ascii_braille,
        'save_midi': save_midi,
        'save_pdf': save_pdf,
        'save_xml': save_xml,
        'toggle_level': toggle_level,
        'display_about': display_about,
        'quit': quit,
        'wd': priv['wdict'],
    }
    return res
def mk_ui_structure(fdict):
    def edit(p):
        default = {
        't': 'editor',
        'a': {
            'left_margin': 0,
            'indent': 2,
            'pixels_above_lines': 2,
            'pixels_below_lines': 0,
            'pixels_inside_wrap': -1,
            'text': u'',
            'sensitive': True,
            'editable': True,
            'wrapping': True,
        },
        'on': {},
        }
        return uti.sub_update(default, p)
    def lab(p):
        default = {
            't': 'label',
            'a': {
                'xalign': 0.5,
                'size': {'x': 100, 'y': 33},
            },
            'on': {},
        }
        return uti.sub_update(default, p)
    def editl(p, l):
        la = lab({'a': {'label': l}})
        ed = edit(p)
        vb = {
            't': 'vbox',
            'a': {
            },
            'on': {},
            'c': [['noexp', la], ['exp', ed]],
        }
        return vb
    def editlab(edp, lap):
        la = lab(lap)
        ed = edit(edp)
        vb = {
            't': 'vbox',
            'a': {
            },
            'on': {},
            'c': [['noexp', la], ['exp', ed]],
        }
        return vb
    edt = editlab({
        'id': 'edt',
        'a': {
            'editable': True,
            'input_type': 'transparent',
        },
        'on': {'changed': lambda a, b: fdict['on_changed_edt']()},
    }, {'a': {'label': u'edytor tekstowy', 'bg_color': config['colors']['area_editable']}})
    edb = editlab({
        'id': 'edb',
        'a': {
            'editable': True,
            'input_type': 'braille',
        },
        'on': {'changed': lambda a, b: fdict['on_changed_edb']()},
    }, {'a': {'label': u'edytor brajlowski', 'bg_color': config['colors']['area_editable']}})
    ret = editlab({
        'id': 'ret',
        'a': {
            'editable': False,
        },
    }, {'a': {'label': u'zapis znakowy skróconego zapisu brajlowskiego', 'bg_color': config['colors']['area_noneditable']}})
    abb = editlab({
        'id': 'abb',
        'a': {
            'editable': False,
        },
    }, {'a': {'label': u'skrócony zapis brajlowski', 'bg_color': config['colors']['area_noneditable']}})
    abt = editlab({
        'id': 'abt',
        'a': {
            'editable': False,
        },
    }, {'a': {'label': u'zapis znakowy skróconego zapisu brajlowskiego', 'bg_color': config['colors']['area_noneditable']}})
    abp = editlab({
        'id': 'abp',
        'a': {
            'editable': False,
        },
    }, {'a': {'label': u'zapis polskimi znakami skróconego zapisu brajlowskiego', 'bg_color': config['colors']['area_noneditable']}})
    txp = editlab({
        'id': 'txp',
        'a': {
            'editable': False,
        },
    }, {'a': {'label': u'zapis polskimi znakami pełnego zapisu brajlowskiego', 'bg_color': config['colors']['area_noneditable']}})
    def mk_image_viewer(par):
        if 'bg' not in par:
            bg = ['bytes', [0, 0, 0]],
        vi = {
            't': 'viewer',
            'a': {
                'img': par['img'],
            },
        }
        if 'page' in par:
            vi['a']['page'] = par['page']
        return vi
    def png(f, dir='tex_png', bg=None):
        return img(f, '.png', dir)
    def jpg(f, dir='pub', bg=None):
        return img(f, '.jpg', dir)
    def pdf(f, page=1, bg=None):
        return img(f, '.pdf', page=page)
    def img(f, ext=None, dir=None, page=None, bg=None):
        r, e = os.path.splitext(f)
        if ext is not None:
            fn = r + ext
        else:
            fn = f
        if dir is not None:
            path = os.path.join(dir, fn)
        else:
            path = fn
        par = {'img': path}
        if page is not None:
            par['page'] = page
        if bg is not None:
            par['bg'] = bg
        return mk_image_viewer(par)
    empty = {
        't': 'empty',
        'a': {
            'color': ['bytes', [20, 20, 20]],
        },
    }
    emp = empty
    def mk_top_level(a, child):
        attr = {
                'title': u'Nutowy Edytor Typograficzny',
                'border_width': 1,
                'minw': 0,
                'minh': 0,
                'startw': 800,
                'starth': 600,
                'position': 'center',
            }
        attr.update(a)
        tl = {
            't': 'top_level',
            'a': attr,
            'on': {'destroy': fdict['quit'],
            },
            'c': child,
        } # end top level
        return tl
    statusbar = {
        't': 'statusbar',
        'id': 'tstatus',
        'a': {
        },
        'on': {},
    }
    fstatus = {
        't': 'statusbar',
        'id': 'fstatus',
        'a': {
            'has_resize_grip': False,
        },
        'on': {},
    }
    statusbarX = {
        't': 'label',
        'id': 'statusbar',
        'a': {
            'label': u' nic takiego, nic wielkiego',
            'xalign': 0.0,
        },
        'on': {},
    }
    subtitle = {
        't': 'label',
        'id': 'subtitle',
        'a': {
            'label': u' ' + u'zamiana postaci brajlowskiej nut na postać typograficzną',
            'xalign': 0.0,
        },
        'on': {},
    }
    gstatus = {
        't': 'viewer',
        'id': 'gstatus',
        'a': {
            'bg': ['bytes', [10, 210, 210]],
            'size': {'w': 100, 'h': 20},
        },
    }
    xstatus = {
        't': 'viewer',
        'id': 'xstatus',
        'a': {
            'bg': ['bytes', [10, 10, 110]],
            'size': {'w': 100, 'h': 20},
        },
    }
    def mk_statusbar(s):
        return {
        't': 'statusbar',
        'id': s,
        'a': {
        },
        'on': {},
    }
    button_view = {
        't': 'button',
        'id': 'view',
        'a': {
            'label': u'utwórz postać typograficzną',
        },
        'on': {
            'clicked': fdict['editor_to_view'],
        },
    }
    button_quit = {
        't': 'button',
        'id': 'quit',
        'a': {
            'label': u'zakończ program',
        },
        'on': {
            'clicked': quit,
        },
    }
    button_get_pdf = {
        't': 'button',
        'id': 'button_get_pdf',
        'a': {
            'label': u'plik PDF niegotowy',
            'sensitive': False,
        },
        'on': {
            'clicked': fdict['save_pdf'],
        },
    }
    button_get_midi = {
        't': 'button',
        'id': 'button_get_midi',
        'a': {
            'label': u'plik MIDI niegotowy',
            'sensitive': False,
        },
        'on': {
            'clicked': fdict['save_midi'],
        },
    }
    button_level = {
        't': 'button',
        'id': 'button_level',
        'a': {
            'label': u'  włącz drugi poziom  ',
            'sensitive': True,
            'bg_color': config['colors']['level_two'],
        },
        'on': {
            'clicked': fdict['toggle_level'],
        },
    }
    label_level = {
        't': 'label',
        'id': 'label_level',
        'a': {
            'label': u'pierwszy poziom skrótów',
            'sensitive': True,
                'xalign': 0.5,
                'size': {'x': 100, 'y': 33},
                'bg_color': config['colors']['level_one'],
        },
        'on': {
        },
    }
    button_get_xml = {
        't': 'button',
        'id': 'button_get_xml',
        'a': {
            'label': u'plik MusicXML niegotowy',
            'sensitive': False,
        },
        'on': {
            'clicked': fdict['save_xml'],
        },
    }
    button_set_keyboard_type = {
        't': 'button',
        'id': 'set_keyboard_type',
        'a': {
            'label': u'użyj klawiatury brajlowskiej',
        },
        'on': {
            'clicked': fdict['set_keyboard_type'],
        },
    }
    toolbar = {
        't': 'hbox',
        'a': {
        },
        'on': {},
        'c': [['exp', button_view], ['exp', button_set_keyboard_type], ['exp', button_get_pdf], ['exp', button_get_midi], ['exp', button_get_xml], ['exp', button_quit]],
    }
    level_toggle = {
        't': 'hbox',
        'a': {
        },
        'on': {},
        'c': [['exp', label_level], ['noexp', button_level]],
    }
    menu = {
        't': 'menu',
        'a': {
            'menus': [
                ['pomoc', [
                [u'O programie', fdict['display_about']],
                ]],
            ],
        },
    }
    statusarea = {
        't': 'hbox',
        'a': {
        },
        'on': {},
        'c': [['noexp', gstatus], ['exp', statusbar]],
    }
    hd1 = {
        't': 'hdouble',
        'a': {
            'position': 400,
            'resize': [False, True],
            'shrink': [True, True],
        },
        'on': {},
        'c': [edt, abb],
    }
    hd2 = {
        't': 'hdouble',
        'a': {
            'position': 400,
            'resize': [False, True],
            'shrink': [True, True],
        },
        'on': {},
        'c': [edb, abt],
    }
    hd3 = {
        't': 'hdouble',
        'a': {
            'position': 400,
            'resize': [False, True],
            'shrink': [True, True],
        },
        'on': {},
        'c': [txp, abp],
    }
    sub_vdouble = {
        't': 'vdouble',
        'a': {
            'position': 200,
            'resize': [True, True],
            'shrink': [True, True],
        },
        'on': {},
        'c': [hd2, hd3],
    }
    ed_vdouble = {
        't': 'vdouble',
        'a': {
            'position': 200,
            'resize': [True, True],
            'shrink': [True, True],
        },
        'on': {},
        'c': [hd1, sub_vdouble],
    }
    def pri(w): print '123', w
    main_vb = {
        't': 'vbox',
        'a': {
        },
        'on': {},
        'c': [['noexp', menu], ['noexp', level_toggle], ['exp', ed_vdouble]],
    }
    top_child = [main_vb]
    tl = mk_top_level({'title': u'System Kaliope | Program Skróty' + u' | Tworzenie skróconej, brajlowskiej wersji tekstu',
        'icon': 'Kaliope.ico',
        }, top_child)
    return tl
about_window = {
    't': 'about',
    'id': 'about',
    'a': {
        'program_name': 'Kaliope Skróty',
        'version': '1.0',
        'copyright': None,
        'comments': u'''Program do testowania modułu skrótów brajlowskich
Autorzy: Zespół Kaliope
''',
        'website': None,
        'logo': None,
    },
    'on': {
    },
}
ui_functions = mk_ui_functions()
ui_structure = mk_ui_structure(ui_functions)
tu = ui.eval(ui_structure)
wdict = ui.mk_idict(tu)
ui_functions['set_widgets_dictionary'](wdict)
ui_functions['init']()
top_level.run()